-- name=ho_chimera
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chimera" );
  game.relations[ "ho_chimera" ].exitroom = "rm_housedoctor";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chimera" ] = { type = "win", room = "rm_housedoctor", zz = "ho_chimera", zz_gate = "gho_housedoctor_chimera" };
 
  local win_chimera_func = function ()

    if ( cmn.IsEventDone( "win_chimera" ) ) then
      interface.InventoryItemAdd( "inv_susiediary", "spr_chimera_win" );
      ObjSet("inv_susiediary",{drag=0})
      ObjDelete( "gho_housedoctor_chimera" );
    end;

  end;
  cmn.AddSubscriber( "win_chimera", win_chimera_func );
   --------------------------------------------------------------------------------------------
  local unmark_eee = function () 
    ObjSet( "spr_chimera_eee", {input = 1, visible = 1} );
    ObjDelete("gfx_chimera_unmark_eee_zone")
    ObjSet("anm_chimera_anm_ball",{animfunc="ball",frame=999})    
  end;
  cmn.AddSubscriber( "chimera_unmark_eee", unmark_eee, "ho_chimera" ); 
  -------------------------------------------------------------------------------------------- 
  local start_chimera_func = function ()
  if not cmn.IsEventDone("win_chimera") then
    if cmn.IsUnmarkedTask("chimera","eee") then 
      unmark_eee()
    end   
  end
  end;
  cmn.AddSubscriber( "win_chimera", start_chimera_func, "ho_chimera" );  

end;

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_housedoctor_env" )

  if ( not cmn.IsEventDone( "opn_chimera" ) ) then

    cmn.InitHo( "chimera" );
    cmn.SetMarkedTask( "chimera", "eee" );   
    cmn.SetEventDone( "opn_chimera" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_chimera_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_chimera_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_chimera_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_chimera_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_chimera_eee" },{"gfx_chimera_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_chimera_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_chimera_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_chimera_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_chimera_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_chimera_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_chimera_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_chimera_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["std"]["win_chimera"].found do

    local name = tostring( ng_global.progress["std"]["win_chimera"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_chimera_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_chimera_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_eee() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "chimera", "eee" );
    cmn.CallEventHandler( "chimera_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_chimera_unmark_eee_zone")
  SoundSfx( "aud_ho_chimera_ball" );
  ld.AnimPlay("anm_chimera_anm_ball","ball",func_end) 
end