-- name=ho_marine
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "marine" );
  game.relations[ "ho_marine" ].exitroom = "rm_seafront";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_marine" ] = { type = "win", room = "rm_seafront", zz = "ho_marine", zz_gate = "gho_seafront_marine" };
 
  local win_marine_func = function ()

    if ( cmn.IsEventDone( "win_marine" ) ) then
      interface.InventoryItemAdd("inv_schilling","spr_marine_win",function() level_inv.ProcessGetSchillingAll( "win_marine" ) end);      
      ObjDelete( "gho_seafront_marine" );

    end;

  end;
  cmn.AddSubscriber( "win_marine", win_marine_func );

  local unmark_eee = function () 
    ObjSet( "spr_marine_eee", {input = 1, alp = 1} );
    ObjDelete("gfx_marine_unmark_eee_zone")
    ObjDelete("spr_marine_unmark_eee_part_1_sh")    
    ObjDelete("spr_marine_unmark_eee_part_1")
    ObjSet("anm_marine_use_knife",{animfunc="end_knife1",frame=0})
  end;
  cmn.AddSubscriber( "marine_unmark_eee", unmark_eee, "ho_marine" ); 

  
  local unmark_ddd = function () 
    ObjSet( "spr_marine_ddd", {input = 1, alp = 1} );
    ObjDelete("gfx_marine_unmark_ddd_zone")
    ObjSet("anm_marine_ddd_unmark",{animfunc="end_purse1",frame=0})
  end;
  cmn.AddSubscriber( "marine_unmark_ddd", unmark_ddd, "ho_marine" ); 
  
  
  local unmark_lll = function () 
    ObjSet( "spr_marine_lll", {input = 1, alp = 1} );
    ObjDelete("gfx_marine_unmark_lll_zone")
    ObjSet("anm_marine_lll_unmark",{animfunc="end_fishnet1",frame=0})
  end;
  cmn.AddSubscriber( "marine_unmark_lll", unmark_lll, "ho_marine" ); 
  
  local start_marine_func = function ()
  if not cmn.IsEventDone("win_marine") then
    if cmn.IsUnmarkedTask("marine","eee") then 
      unmark_eee()
    end    
    if cmn.IsUnmarkedTask("marine","lll") then 
      unmark_lll()
    end
    if cmn.IsUnmarkedTask("marine","ddd") then 
      unmark_ddd()
    end    
  end
  end;
  cmn.AddSubscriber( "win_marine", start_marine_func, "ho_marine" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_seafront_env" )

  if ( not cmn.IsEventDone( "opn_marine" ) ) then

    cmn.InitHo( "marine" );
    cmn.SetMarkedTask( "marine", "eee" );
    cmn.SetMarkedTask( "marine", "lll" );    
    cmn.SetMarkedTask( "marine", "ddd" );     
    cmn.SetEventDone( "opn_marine" );
     ObjSet("txt_marine_panel",{param0=12})
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_marine_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_marine_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_marine_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_marine_ddd" },{"gfx_marine_unmark_ddd_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_marine_eee" },{"spr_marine_unmark_eee_part_1","gfx_marine_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_marine_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_marine_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_marine_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_marine_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_marine_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_marine_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_marine_lll" },{"gfx_marine_unmark_lll_zone"} } );
  
  SoundHoTheme( true );
  ObjAttach("spr_marine_panel","int_taskpanel_impl")
  ObjSet("spr_marine_panel",{pos_x=0,pos_y=0})  
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["std"]["win_marine"].found do

    local name = tostring( ng_global.progress["std"]["win_marine"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  if ng_global.progress["std"]["win_marine"].found then
    ObjSet("txt_marine_panel",{param0=12-#ng_global.progress["std"]["win_marine"].found})
  end
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;

function public.Close()
  ObjDetach("spr_marine_panel")
end
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  local sum = 12 - #ng_global.progress["std"]["win_marine"].found
   
  ObjSet("txt_marine_panel",{param0=sum})
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_marine_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_marine_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_eee() 
  if ApplyObj("spr_marine_unmark_eee_part_1","gfx_marine_unmark_eee_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marine", "eee" );
    cmn.CallEventHandler( "marine_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("spr_marine_unmark_eee_part_1")
  ObjDelete("gfx_marine_unmark_eee_zone")
  SoundSfx( "aud_ho_marine_knife" );
  ld.AnimPlay("anm_marine_use_knife","use_knife",func_end)
  else 
  ObjSet("spr_marine_unmark_eee_part_1",{pos_z = 1})
  ObjSet( "spr_marine_unmark_eee_part_1_sh", {alp = 1} );    
  end
end;

----------------------------------------------------------------------------
function public.unmark_lll() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marine", "lll" );
    cmn.CallEventHandler( "marine_unmark_lll" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_marine_unmark_lll_zone")
  SoundSfx( "aud_ho_marine_net" );
  ld.AnimPlay("anm_marine_lll_unmark","click_fishnet",func_end)
end;
----------------------------------------------------------------------------
function public.unmark_ddd() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marine", "ddd" );
    cmn.CallEventHandler( "marine_unmark_ddd" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_marine_unmark_ddd_zone")
  SoundSfx( "aud_ho_marine_purse" );
  ld.AnimPlay("anm_marine_ddd_unmark","click_purse",func_end)
end;