-- name=ho_toys
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "toys" );
  game.relations[ "ho_toys" ].exitroom = "rm_livingroom";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_toys" ] = { type = "win", room = "rm_livingroom", zz = "ho_toys", zz_gate = "gho_livingroom_toys" };
 
  local win_toys_func = function ()

    if ( cmn.IsEventDone( "win_toys" ) ) then
      interface.InventoryItemAdd( "inv_diary", "spr_toys_win" );
      ObjSet("inv_diary",{drag=0})
      ObjDelete( "gho_livingroom_toys" );
    end;

  end;
  cmn.AddSubscriber( "win_toys", win_toys_func );

  local unmark_fff= function () 
    ObjSet( "spr_toys_fff", {input = 1, alp = 1} );
    ObjDelete("gfx_toys_unmark_fff_zone")
    ObjSet("anm_toys_unmark_fff",{animfunc="end_fff1",frame=0})
  end;
  cmn.AddSubscriber( "toys_unmark_fff", unmark_fff, "ho_toys" ); 

  local unmark_ddd= function () 
    ObjSet( "spr_toys_ddd", {input = 1, alp = 1} );
    ObjDelete("gfx_toys_unmark_ddd_zone")
    ObjSet("anm_toys_use_core",{animfunc="end_core1",frame=0})
  end;
  cmn.AddSubscriber( "toys_unmark_ddd", unmark_ddd, "ho_toys" ); 
  
   
  local unmark_iii= function () 
    ObjSet( "spr_toys_iii", {input = 1, alp = 1} );
    ObjDelete("gfx_toys_unmark_iii_zone")
    ObjSet("spr_toys_tr_iii",{alp=1})
    for i=1,4 do
      ObjSet("spr_toys_block_"..i,{pos_x=private.block_arr[i][1],pos_y=private.block_arr[i][2],pos_z=private.block_arr[i][3],input=0})
    end    
  end;
  cmn.AddSubscriber( "toys_unmark_iii", unmark_iii, "ho_toys" );   
  
  local start_toys_func = function ()
    if not cmn.IsEventDone("win_toys") then
      if cmn.IsUnmarkedTask("toys","fff") then 
        unmark_fff()
      end  
      if cmn.IsUnmarkedTask("toys","ddd") then 
        unmark_ddd()
      end        
      if cmn.IsUnmarkedTask("toys","iii") then
        unmark_iii()
      else
        for i=1,4 do
          if ng_global.progress["std"]["win_toys"].state_iii[i]==1 then
            ObjSet("spr_toys_block_"..i,{pos_x=private.block_arr[i][1],pos_y=private.block_arr[i][2],pos_z=private.block_arr[i][3],input=0})
          end
        end
      end
    end
  end;
  cmn.AddSubscriber( "win_toys", start_toys_func, "ho_toys" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_livingroom_env" )

  if ( not cmn.IsEventDone( "opn_toys" ) ) then

    cmn.InitHo( "toys" );
    cmn.SetMarkedTask( "toys", "fff" );  
    cmn.SetMarkedTask( "toys", "ddd" );    
    cmn.SetMarkedTask( "toys", "iii" );    
    cmn.SetEventDone( "opn_toys" );
    ng_global.progress["std"]["win_toys"].state_iii={0,1,0,0}
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_toys_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_toys_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_toys_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_toys_ddd" },{"gfx_toys_unmark_ddd_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_toys_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_toys_fff" },{"gfx_toys_unmark_fff_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_toys_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_toys_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_toys_iii" },{"gfx_toys_unmark_iii_zone","spr_toys_block_1"},{"gfx_toys_unmark_iii_zone","spr_toys_block_3"},{"gfx_toys_unmark_iii_zone","spr_toys_block_4"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_toys_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_toys_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_toys_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["std"]["win_toys"].found do

    local name = tostring( ng_global.progress["std"]["win_toys"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_toys_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_toys_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_fff() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "toys", "fff" );
    cmn.CallEventHandler( "toys_unmark_fff" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_toys_unmark_fff_zone")
  SoundSfx( "aud_ho_toys_sail" )
  ld.AnimPlay("anm_toys_unmark_fff","click_fff",func_end) 
end

function public.unmark_ddd() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "toys", "ddd" );
    cmn.CallEventHandler( "toys_unmark_ddd" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_toys_unmark_ddd_zone")
  SoundSfx( "aud_ho_toys_shot" );
  ld.AnimPlay("anm_toys_use_core","use_core",func_end) 
end


private.block_arr={{143,433,7},{110,558,6},{248 ,426,6},{249 ,528 ,5}}
public.block_cur_posz = 0
function public.unmark_iii(obj)
  local f_end = function()
    ld.Lock(0)
    local count = 0
    for i=1,4 do
      count=count+ng_global.progress["std"]["win_toys"].state_iii[i]
    end
    if count ==4 then
      cmn.UnmarkTask( "toys", "iii" );
      cmn.CallEventHandler( "toys_unmark_iii" );      
    end
  end
  local num = tonumber(ld.StringDivide(obj)[4])
  if ApplyObj(obj,"gfx_toys_unmark_iii_zone") then
    SoundSfx( "aud_ho_toys_set" );
    ld.Lock(1) 
    
    ObjSet(obj,{pos_z=private.block_arr[num][3],input=0})
    ng_global.progress["std"]["win_toys"].state_iii[num]=1
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); f_end() end,
      {0,0,GetObjPosByObj(obj,"ho_toys")[1],GetObjPosByObj(obj,"ho_toys")[2], 0.2,0,private.block_arr[num][1],private.block_arr[num][2]}
    );
  else 
      ObjSet(obj,{pos_z=public.block_cur_posz})
  end
end