-- name=ho_tree
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "tree" );
  game.relations[ "ho_tree" ].exitroom = "rm_nearhouse";
  ld.NoteInit("spr_tree_note", "spr_tree_note_1")

  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_tree" ] = { type = "win", room = "rm_nearhouse", zz = "ho_tree", zz_gate = "gho_nearhouse_tree" };
 
  local win_tree_func = function ()

    if ( cmn.IsEventDone( "win_tree" ) ) then
      interface.InventoryItemAdd( "inv_keyhouse", "spr_tree_win" );
      ObjDelete( "gho_nearhouse_tree" );
    end;

  end;
  cmn.AddSubscriber( "win_tree", win_tree_func );
  
  local unmark_iii = function () 
    ObjSet( "spr_tree_iii", {input = 1} );
    ObjDelete("obj_tree_iii_unmark")
    ObjSet("anm_tree_anm_click_hat",{animfunc="end_hat1",frame=0})
  end;
  cmn.AddSubscriber( "tree_unmark_iii", unmark_iii, "ho_tree" ); 
 
  local unmark_jjj = function () 
    ObjSet( "spr_tree_jjj", {input = 1,alp=1} );
    ObjDelete("obj_tree_jjj_unmark")
    ObjSet("anm_tree_anm_hedge",{animfunc="end_hedge2",frame=0,playing=0})
  end;
  cmn.AddSubscriber( "tree_unmark_jjj", unmark_jjj, "ho_tree" ); 
    
  local unmark_bbb = function () 
    ObjSet( "spr_tree_bbb", {input = 1,alp=1} );
    ObjDelete("spr_tree_bbb_unmark_1")
    ObjDelete("spr_tree_bbb_unmark_2")    
  end;
  cmn.AddSubscriber( "tree_unmark_bbb", unmark_bbb, "ho_tree" ); 
      
  local start_tree_func = function ()
  if not cmn.IsEventDone("win_tree") then
      common_impl.ProcessHoStart( "tree" );

      local ho_found = ng_global.progress[ "std" ][ "win_tree" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;
    if cmn.IsUnmarkedTask("tree","iii") then 
      unmark_iii()
    end  
    if cmn.IsUnmarkedTask("tree","jjj") then 
      unmark_jjj()
    end 
    if cmn.IsUnmarkedTask("tree","bbb") then 
      unmark_bbb()
    end      
  end
  end;
  cmn.AddSubscriber( "win_tree", start_tree_func, "ho_tree" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearhouse_env" )

  if ( not cmn.IsEventDone( "opn_tree" ) ) then

    cmn.InitHo( "tree" );

    cmn.SetEventDone( "opn_tree" );
    cmn.SetMarkedTask( "tree", "iii" );
    cmn.SetMarkedTask( "tree", "jjj" );    
    cmn.SetMarkedTask( "tree", "bbb" );     
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_tree_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_tree_bbb","spr_tree_bbb_unmark_1","spr_tree_bbb_unmark_2"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_tree_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_tree_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_tree_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_tree_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_tree_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_tree_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_tree_iii","obj_tree_iii_unmark"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_tree_jjj","obj_tree_jjj_unmark"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_tree_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_tree_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false )
  interface.ItemPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show()
  ObjDelete("grm_tree_nearhouse") 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )


end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_tree_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_tree_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;


function public.unmark_iii()
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["std"]["win_tree"].start = 1;
    ng_global.progress["std"]["win_tree"].unmark["iii"].done = 1;
    cmn.CallEventHandler("tree_unmark_iii");
  end  
  ld.Lock(1)
  SoundSfx( "aud_ho_tree_hat" );
  ld.AnimPlay("anm_tree_anm_click_hat","click_hat",func_end)
end

function public.unmark_jjj()
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["std"]["win_tree"].start = 1;
    ng_global.progress["std"]["win_tree"].unmark["jjj"].done = 1;
    cmn.CallEventHandler("tree_unmark_jjj");
  end  
  ld.Lock(1)
  SoundSfx( "aud_ho_tree_hedgehog" );
  ld.AnimPlay("anm_tree_anm_hedge","hedge",func_end)
end

function public.unmark_bbb()
  if ApplyObj("spr_tree_bbb_unmark_1","spr_tree_bbb_unmark_2") then   
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["std"]["win_tree"].start = 1;
    ng_global.progress["std"]["win_tree"].unmark["bbb"].done = 1;
    cmn.CallEventHandler("tree_unmark_bbb");
  end  
  ld.Lock(1)
  ObjDelete("spr_tree_bbb_unmark_1")
  SoundSfx( "aud_ho_tree_butterfly" );
  ObjAnimate( "spr_tree_bbb", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  else 
    ObjSet("spr_tree_bbb_unmark_1",{pos_z = 0})
  end
end