-- name=ho_winestore
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "winestore" );
  game.relations[ "ho_winestore" ].exitroom = "rm_cellar";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_winestore" ] = { type = "win", room = "rm_cellar", zz = "ho_winestore", zz_gate = "gho_cellar_winestore" };
 
  local win_winestore_func = function ()

    if ( cmn.IsEventDone( "win_winestore" ) ) then
      interface.InventoryItemAdd( "inv_lordbag", "spr_winestore_win" );
      ObjSet("inv_lordbag",{drag=0})
      ObjDelete( "gho_cellar_winestore" );
    end;

  end;
  cmn.AddSubscriber( "win_winestore", win_winestore_func );
  
  local start_winestore_func = function ()
  if not cmn.IsEventDone("win_winestore") then
  common_impl.ProcessHoStart( "winestore" );

      local ho_found = ng_global.progress[ "std" ][ "win_winestore" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;  
  end
  end;
  cmn.AddSubscriber( "win_winestore", start_winestore_func, "ho_winestore" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_cellar_env" )

  if ( not cmn.IsEventDone( "opn_winestore" ) ) then

    cmn.InitHo( "winestore" );

    cmn.SetEventDone( "opn_winestore" );
   
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_winestore_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_winestore_bbb"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_winestore_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_winestore_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_winestore_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_winestore_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_winestore_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_winestore_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_winestore_iii"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_winestore_jjj"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_winestore_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_winestore_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.ItemPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  common_impl.DialogHo_Show()
  ObjDelete("grm_winestore_cellar")    
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_winestore_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_winestore_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------