-- name=mg_behindglass
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_behindglass";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_behindglass" ] = {type = "win", use_place = "mg_behindglass", room = "rm_square", zz = "mg_behindglass", zz_gate = "gmg_square_behindglass" };

  local win_behindglass_logic = function()
    if ld.CheckRequirements( {"win_behindglass"} ) then
      ObjSet( "gfx_behindglass_package", {active = 1, visible = 1} );
      ObjSet( "gfx_behindglass_tubule", {active = 1, visible = 1} );
      ObjSet( "spr_behindglass_package", {input = 1, visible = 1} );
      ObjSet( "spr_behindglass_tubule", {input = 1, visible = 1} );
      ObjSet( "obj_behindglass_mg_root", {input = 0} );
      ObjDelete("spr_square_flask")
      ObjSet("spr_behindglass_btn_change_mode",{input = 0})
    
    end
  end;
  local win_behindglass = function()
    if ld.CheckRequirements( {"win_behindglass"} ) then
      ObjDelete("obj_behindglass_glass_clk_zone");
      ObjDelete("anm_behindglass_anm_mgglass_glass");
    end
  end;
  cmn.AddSubscriber("win_behindglass", win_behindglass, private.room_objname )
  cmn.AddSubscriber("win_behindglass", win_behindglass_logic )
  --------------------------------------------------------------------------------------------
  
  
--------------------------------------------------------------------
common_impl.hint[ "get_package" ] = { type = "get", get_obj = "spr_behindglass_package", room = "rm_square", zz = "mg_behindglass", zz_gate = "gmg_square_behindglass" };

private.get_package_logic = function()
  
end;
private.get_package_inv = function()
  interface.InventoryItemAdd("inv_package","spr_behindglass_package");
  ObjSet( "inv_package", { drag = 0 } );
end;
private.get_package_beg = function()
  ObjDelete("gfx_behindglass_package")
end;
private.get_package_end = function()
  ObjDelete("spr_behindglass_sh_package")
end;

cmn.AddSubscriber( "get_package", private.get_package_inv );
cmn.AddSubscriber( "get_package", private.get_package_beg, private.room_objname );
cmn.AddSubscriber( "get_package", private.get_package_end, private.room_objname );
cmn.AddSubscriber( "get_package", private.get_package_logic );
--------------------------------------------------------------------
function public.get_package()
  cmn.SetEventDone( "get_package" );
  cmn.CallEventHandler( "get_package" );
  if common_impl.ZzCompleteCheck( "get_package" ) then cmn.GotoRoom( "rm_square" ); end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tubule" ] = { type = "get", get_obj = "spr_behindglass_tubule", room = "rm_square", zz = "mg_behindglass", zz_gate = "gmg_square_behindglass" };

private.get_tubule_logic = function()
  
end;
private.get_tubule_inv = function()
  interface.InventoryItemAdd("inv_tubule","spr_behindglass_tubule");
end;
private.get_tubule_beg = function()
  ObjDelete("gfx_behindglass_tubule")
end;
private.get_tubule_end = function()
  ObjDelete("spr_behindglass_sh_tubule")
end;

cmn.AddSubscriber( "get_tubule", private.get_tubule_inv );
cmn.AddSubscriber( "get_tubule", private.get_tubule_beg, private.room_objname );
cmn.AddSubscriber( "get_tubule", private.get_tubule_end, private.room_objname );
cmn.AddSubscriber( "get_tubule", private.get_tubule_logic );
--------------------------------------------------------------------
function public.get_tubule()
  cmn.SetEventDone( "get_tubule" );
  cmn.CallEventHandler( "get_tubule" );
  if common_impl.ZzCompleteCheck( "get_tubule" ) then cmn.GotoRoom( "rm_square" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

---------------------------------------------------------------------
private.behindglass_pos_coordy={131,198,265,332,399,465,532}
private.behindglass_pos_x = 670;
private.behindglass_fp = {6,5,4,0,1,2,3,17,"hard"}
private.behindglass_color={2,2,2,1,1,1} --1 - red, 2- blue
private.behindglass_skip_pos={1,2,3,0,4,5,6,0};

----------------------------------------------------
function private.behindglass_stand_part_after_win()
  for i=1,7,1 do 
    if private.behindglass_skip_pos[i]~=0 then 
      ObjSet( "obj_behindglass_part"..private.behindglass_skip_pos[i], {pos_y=private.behindglass_pos_coordy[i]} );
    end;  
  end; 
  ObjSet( "txt_behindglass_counter1", {text="0"} ); 
end;  
-----------------------------------------------------

function private.behindglass_get_part_pos_fp(num)
  for i=1,7,1 do 
    if private.behindglass_fp[i]==num then return i; end;
  end;  
end;  

private.behindglass_parts_init_flag=false;
function private.behindglass_parts_init()
  if private.behindglass_parts_init_flag == false then 
    for i=1,6,1 do 
      local part_pos= private.behindglass_get_part_pos_fp(i)
      ObjCreate("obj_behindglass_part"..i,"obj");
      ObjAttach("obj_behindglass_part"..i, "obj_behindglass_mg_root");
      ObjSet( "obj_behindglass_part"..i, {pos_x=670, pos_y=private.behindglass_pos_coordy[part_pos], input=1, inputrect_init=1, inputrect_w=70, inputrect_h=70, inputrect_x=-35, inputrect_y=-35, 
      event_mdown="mg_behindglass.behindglass_part_mdown("..i..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
      
      ObjCreate("spr_behindglass_part_con"..i,"spr");
      ObjAttach("spr_behindglass_part_con"..i,"obj_behindglass_part"..i);
      ObjSet( "spr_behindglass_part_con"..i, {input=0, res="assets/levels/level/mg_behindglass/con"..private.behindglass_color[i]} );

      ObjCreate("spr_behindglass_part_light"..i,"spr");
      ObjAttach("spr_behindglass_part_light"..i,"obj_behindglass_part"..i);
      ObjSet( "spr_behindglass_part_light"..i, {input=0, res="assets/levels/level/mg_behindglass/pressure", alp=0} );

    end;
  
    ObjCreate("obj_behindglass_part0","obj");
    ObjAttach("obj_behindglass_part0", "obj_behindglass_mg_root");
    ObjSet( "obj_behindglass_part0", {pos_x=670, pos_y=private.behindglass_pos_coordy[4], input=1, inputrect_init=1, inputrect_w=70, inputrect_h=70, inputrect_x=-35, inputrect_y=-35, 
    event_mdown="mg_behindglass.behindglass_empty_part_mdown();", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
    
    ------- ctob ne ebnulos
    ObjCreate("spr_behindglass_part_light0","spr");
    ObjAttach("spr_behindglass_part_light0","obj_behindglass_part0");
    ObjSet( "spr_behindglass_part_light0", {input=0, visible=0, res="assets/levels/level/mg_behindglass/pressure", alp=0} );
    ----------------------
    
  end;
  private.behindglass_parts_init_flag = true;  
end;  

function private.behindglass_stand_on_pos(without_win_ver)
  private.behidglass_select_part=0;
  for i=1,7,1 do 
    ObjSet( "obj_behindglass_part"..ng_global.progress["std"]["win_behindglass"].state[i], {pos_y=private.behindglass_pos_coordy[i]} );
    ObjSet( "spr_behindglass_part_light"..ng_global.progress["std"]["win_behindglass"].state[i], {alp=0, color_r=1, color_g=1, color_b=1} );
  end;  
  
  if without_win_ver~=1 then private.behindglass_win_ver(); end;
  ObjSet( "txt_behindglass_counter1", {text = ng_global.progress["std"]["win_behindglass"].state[8]} );
  if private.behindglass_win_flag~=1 and ng_global.progress["std"]["win_behindglass"].state[8]==0 then  SoundSfx( "aud_mgreset" ); public.Reset(); end;
  
 -- ObjSet( "txt_behindglass_counter2", {text = ng_global.progress["std"]["win_behindglass"].state[8]-1} );
end;  

private.behindglass_win_flag=0;
function private.behindglass_win_ver()
  local count=0
  for i=1,7,1 do 
    if i<4 then 
      if ng_global.progress["std"]["win_behindglass"].state[i]<4 then count=count+1; end;
    elseif i==4 then 
      if ng_global.progress["std"]["win_behindglass"].state[i]==0 then count=count+1; end;
    elseif i>4 then 
      if ng_global.progress["std"]["win_behindglass"].state[i]>=4 then count=count+1; end;
    end;  
  end;
  if count==7 then private.behindglass_win_flag=1;  private.Win(); end;
end


----------------------------------------------------------------
private.behidglass_select_part=0;
function public.behindglass_part_mdown(num)
  SoundSfx( "aud_mg_behindglass_click" );
  if private.behidglass_select_part==0 then 
     private.behidglass_select_part=num;
     ObjSet( "spr_behindglass_part_light"..num, {alp=1, color_r=0, color_g=1, color_b=0} );
    
  elseif private.behidglass_select_part==num then 
     private.behidglass_select_part=0;
     ObjSet( "spr_behindglass_part_light"..num, {alp=0, color_r=1, color_g=1, color_b=1} );
  else
     local func_end = function()
       ld.Lock(0);
       private.behidglass_select_part=0;
       ObjSet( "spr_behindglass_part_light"..num, {alp=0, color_r=1, color_g=1, color_b=1} );
       ObjSet( "spr_behindglass_part_light"..private.behidglass_select_part, {alp=0, color_r=1, color_g=1, color_b=1} );
     end;
     
     ld.Lock(1);
     SoundSfx( "aud_mg_behindglass_wrong" );
     ObjSet( "spr_behindglass_part_light"..num, {color_r=1, color_g=0, color_b=0, alp=0} );
     ObjAnimate( "spr_behindglass_part_light"..private.behidglass_select_part, 8, 0, 0, function() end, {0,0,1, 0.45,0,0} );
     ObjAnimate( "spr_behindglass_part_light"..num, 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
  end;  
end;

function private.behindglass_get_part_pos(num)
  for i=1,7,1 do 
    if ng_global.progress["std"]["win_behindglass"].state[i]==num then return i; end;
  end;  
end;   
 
 
function public.behindglass_empty_part_mdown()
  if private.behidglass_select_part==0 then 
        
     local func_end = function()
       ld.Lock(0);
       private.behidglass_select_part=0;
       
       for i=1,6,1 do 
         ObjSet( "spr_behindglass_part_light"..i, {alp=0, color_r=1, color_g=1, color_b=1} );
       end;  
     end;
     
     ld.Lock(1);
     for i=1,6,1 do 
         ObjSet( "spr_behindglass_part_light"..i, {color_r=1, color_g=0, color_b=0, alp=0} );
         ObjAnimate( "spr_behindglass_part_light"..i, 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );
     end;
     SoundSfx( "aud_mg_behindglass_wrong" );    
     ld.StartTimer( 0.5, func_end );    
         
  else  
     local pos_p = private.behindglass_get_part_pos(private.behidglass_select_part)
     local pos_e = private.behindglass_get_part_pos(0);
     
     if math.abs(pos_p-pos_e)<3 then 
         
         local func_end = function()
           ld.Lock(0);
           ng_global.progress["std"]["win_behindglass"].state[8]=ng_global.progress["std"]["win_behindglass"].state[8]-1;
           ng_global.progress["std"]["win_behindglass"].state[pos_p]=0;
           ng_global.progress["std"]["win_behindglass"].state[pos_e]=private.behidglass_select_part;
           
           ObjSet( "obj_behindglass_part"..private.behidglass_select_part, {pos_z=1} );
           
           private.behindglass_stand_on_pos();
         end;  
         
         ld.Lock(1);
         local coord_p = private.behindglass_pos_coordy[pos_p];
         local coord_e = private.behindglass_pos_coordy[pos_e];
          
         ObjSet( "obj_behindglass_part"..private.behidglass_select_part, {pos_z=15} );
         SoundSfx( "aud_mg_behindglass_move" );
         ObjAnimate( "obj_behindglass_part"..private.behidglass_select_part, 1, 0, 0, func_end, {0,0,coord_p, 0.3,0,coord_e} );
         ObjSet( "obj_behindglass_part0", {pos_y=coord_p} );
         private.behindglass_counter_step();
         --  ng_global.progress["std"]["win_behindglass"].state[8]=ng_global.progress["std"]["win_behindglass"].state[8]-1;
     else
         local func_end = function()
           ld.Lock(0);
           private.behidglass_select_part=0;
           ObjSet( "spr_behindglass_part_light"..private.behidglass_select_part, {alp=0, color_r=1, color_g=1, color_b=1} );
           private.behindglass_stand_on_pos();
         end;
         
         ld.Lock(1);
         SoundSfx( "aud_mg_behindglass_wrong" );
         ObjSet( "spr_behindglass_part_light"..private.behidglass_select_part, {color_r=1, color_g=0, color_b=0, alp=0} );
         ObjAnimate( "spr_behindglass_part_light"..private.behidglass_select_part, 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
     end;
  end;   
end;  
   ------------------------------------------------------ counter -------------------------
function private.behindglass_show_counter(text1, text2)
  local func_end = function()
    ObjSet( "obj_behindglass_counter_root", {pos_y=0} );
    ObjSet( "txt_behindglass_counter1", {text = text2} );
    ObjSet( "txt_behindglass_counter2", {text = text1} );
  end;  
  
  SoundSfx( "aud_mg_behindglass_gears" );
  ObjSet( "txt_behindglass_counter1", {text = text1} );
  ObjSet( "txt_behindglass_counter2", {text = text2} );
  ObjAnimate( "obj_behindglass_counter_root", 1, 0, 0, func_end, {0,0,0, 0.5,0,-72} );
  ld.AnimPlay( "anm_behindglass_anm_mgglass_counter2", "idle_cod", function() end );
  ld.AnimPlay( "anm_behindglass_anm_mgglass_counter1", "idle_counter", function() end );
end;   

function private.behindglass_counter_step()
  local text1=ng_global.progress["std"]["win_behindglass"].state[8];
  local text2=ng_global.progress["std"]["win_behindglass"].state[8]-1;
  
  if text2<0 then text2=0; end;
  
  private.behindglass_show_counter(text1, text2);
end;  

   
function public.menter_btnmode()
  ld.ShCur(CURSOR_HAND)
  local obj_focuse = "spr_behindglass_btn_change_mode_focus"
  ObjAnimate( obj_focuse, 8, 0, 0, "", {0,0,ObjGet(obj_focuse).alp, 0.5,0,1} );
end
function public.mleave_btnmode()
  ld.ShCur(CURSOR_HAND)
  local obj_focuse = "spr_behindglass_btn_change_mode_focus"
  ObjAnimate( obj_focuse, 8, 0, 0, "", {0,0,ObjGet(obj_focuse).alp, 0.5,0,0} );  
end
function public.change_mode()
  SoundSfx( "aud_mg_behindglass_mode" );
  local param = ng_global.progress["std"]["win_behindglass"].state[9]
  if param == "casual" then
    --ld.LogTrace( "casual->hard" );
    private.behindglass_fp[8]=17
    private.behindglass_fp[9]="hard"
    ObjAnimate( "spr_behindglass_btn_change_mode", 7, 0, 0, "", {0,0,-0.8, 0.25,0,0.8} );
  elseif param == "hard" then
    --ld.LogTrace( "hard->casual" );
    private.behindglass_fp[8]=24
    private.behindglass_fp[9]="casual"    
    ObjAnimate( "spr_behindglass_btn_change_mode", 7, 0, 0, "", {0,0,0.8, 0.25,0,-0.8} );    
  end
  public.Reset()
end
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_behindglass"} ) then
    SoundMgTheme( true )
    cmn.MiniGameShow( "behindglass" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_square_env" )
  local check = false;
  if ng_global.gamemode == 0 and not ng_global.progress["std"]["win_behindglass"].state then
    check = true;
  end;
  private.behindglass_parts_init();
  if not ld.CheckRequirements( {"win_behindglass"} ) then
    gm.load();
  end;  
  if cmn.IsEventDone("win_behindglass") then
    private.behindglass_stand_part_after_win();
  end;
  if ng_global.progress["std"]["win_behindglass"].state and ng_global.progress["std"]["win_behindglass"].state[9] == "hard" then
    ObjSet("spr_behindglass_btn_change_mode",{ang=0.8})
  elseif ng_global.progress["std"]["win_behindglass"].state and ng_global.progress["std"]["win_behindglass"].state[9] == "casual" then
    ObjSet("spr_behindglass_btn_change_mode",{ang=-0.8})    
  end
  
  if check == true then
      ng_global.progress["std"]["win_behindglass"].state[9] = "hard";
      public.change_mode();
  end;
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_behindglass"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "behindglass" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function()
    ng_global.progress["std"]["win_behindglass"].state = ld.TableCopy(private.behindglass_fp);
    private.behindglass_stand_on_pos();
    ObjAnimate( "obj_behindglass_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_behindglass_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function public.Skip()
  local func_end = function()
    ng_global.progress["std"]["win_behindglass"].state = ld.TableCopy(private.behindglass_skip_pos);
    private.behindglass_stand_on_pos(1); --without win ver
    -- ObjAnimate( "obj_behindglass_mg_root", 8, 0, 0, function() ld.Lock(0); private.behindglass_stand_on_pos(); end, {0,0,0, 0.25,0,1} );
    ObjAnimate( "obj_behindglass_mg_root", 8, 0, 0, function() ld.Lock(0);private.Win(); end, {0,0,0, 0.25,0,1} );   
  end;  
  
  ld.Lock(1);
  ObjAnimate( "obj_behindglass_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_behindglass" );
  cmn.CallEventHandler( "win_behindglass" );
  if common_impl.ZzCompleteCheck( "win_behindglass" ) then cmn.GotoRoom( "rm_square" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  SoundMgTheme( false )
  --ld.StartTimer( 0.5, private.WinEnd  );
  
  local func_end2 = function()
    ld.StartTimer( 0.5, private.WinEnd  );
  end;  
  
  
   local func_end = function()
       cmn.MiniGameHide(true);
       private.behidglass_select_part=0;
       
       for i=1,6,1 do 
         ObjSet( "spr_behindglass_part_light"..i, {alp=0, color_r=1, color_g=1, color_b=1} );
       end;  
       SoundSfx( "aud_mg_behindglass_win2" );
       ld.AnimPlay( "anm_behindglass_anm_mgglass_glass", "use_glass", func_end2 )
   end;
     
     ld.Lock(1);
     SoundSfx( "aud_mg_behindglass_win" );
     for i=1,6,1 do 
         ObjSet( "spr_behindglass_part_light"..i, {color_r=0, color_g=1, color_b=0, alp=0} );
         ObjAnimate( "spr_behindglass_part_light"..i, 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );
     end;
         ld.StartTimer( 1, func_end  );  
     ObjAnimate( "spr_behindglass_btn_play_hard", 8, 0, 0, "", {0,0,1, 0.5,0,0} );  
     ObjAnimate( "spr_behindglass_btn_play_simple", 8, 0, 0, "", {0,0,1, 0.5,0,0} );  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default();
    if ng_global.progress["std"]["win_behindglass"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_behindglass"].state )
    else  
      ng_global.progress["std"]["win_behindglass"].state = ld.TableCopy(private.behindglass_fp);
    end
  
    gm.loaded  = true;
    
  else
  
  end;
  private.behindglass_stand_on_pos();
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_behindglass"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;

-----------------------------------------------------------------------------------------------------------------------
function public.behindglass_glass_zone_clk()  --mg_behindglass.behindglass_glass_zone_clk()
  local func_end = function()
    ld.Lock(0);
    
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_cover_square" );
  ld.AnimPlay( "anm_behindglass_anm_mgglass_glass", "idle_glass", func_end )
end;  