-- name=mg_dolls
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_dolls";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_dolls" ] = {type = "win", use_place = "mg_dolls", room = "rm_terrace", zz = "mg_dolls", zz_gate = "gmg_terrace_dolls" };

  local win_dolls_logic = function()
    if ld.CheckRequirements( {"win_dolls"} ) then
      ObjSet("spr_dolls_barkey",{ visible = 1, input = 1, active = 1 })
      ObjSet( "gfx_dolls_barkey", {active=1, visible=1} );
    end
  end;
  local win_dolls = function()
    if ld.CheckRequirements( {"win_dolls"} ) then
      ObjSet( "obj_dolls_mg_root", {input = 0} );
      ObjDelete("obj_dolls_idle_default_clk_zone");
      ObjSet( "anm_dolls_anm_dolls_door", {animfunc = "open_default", frame = 999 } );
    end
  end;
  cmn.AddSubscriber("win_dolls", win_dolls, private.room_objname )
  cmn.AddSubscriber("win_dolls", win_dolls_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_barkey" ] = { type = "get", get_obj = "spr_dolls_barkey", room = "rm_terrace", zz = "mg_dolls", zz_gate = "gmg_terrace_dolls" };

private.get_barkey_logic = function()
  
end;
private.get_barkey_inv = function()
  interface.InventoryItemAdd("inv_barkey","spr_dolls_barkey");
end;
private.get_barkey_beg = function()
  ObjDelete("gfx_dolls_barkey")
end;
private.get_barkey_end = function()
  
end;

cmn.AddSubscriber( "get_barkey", private.get_barkey_inv );
cmn.AddSubscriber( "get_barkey", private.get_barkey_beg, private.room_objname );
cmn.AddSubscriber( "get_barkey", private.get_barkey_end, private.room_objname );
cmn.AddSubscriber( "get_barkey", private.get_barkey_logic );
--------------------------------------------------------------------
function public.get_barkey()
  cmn.SetEventDone( "get_barkey" );
  cmn.CallEventHandler( "get_barkey" );
  if common_impl.ZzCompleteCheck( "get_barkey" ) then cmn.GotoRoom( "rm_terrace" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;


private.dolls_anim_array = {"graph","son","countess","brother"};

private.dolls_fp_array = {{1,1,1,1},{1,1,1,1},{0,1,2,0}};
private.dolls_click_array = {3,2,3,4};

private.dolls_connect = {3,1,4,2};

function private.dolls_stand_on_pos(without_win_ver)
  for i=1,4,1 do 
    if  ng_global.progress["std"]["win_dolls"].state[1][i] ==1 then 
      ObjSet( "spr_dolls_"..private.dolls_anim_array[i].."1", {visible=1} );ObjSet( "spr_dolls_"..private.dolls_anim_array[i].."2", {visible=0} );
    else 
      ObjSet( "spr_dolls_"..private.dolls_anim_array[i].."2", {visible=1} );ObjSet( "spr_dolls_"..private.dolls_anim_array[i].."1", {visible=0} );
    end;  
    
     if  ng_global.progress["std"]["win_dolls"].state[2][i] == 1 then
    --   ld.LogTrace( "stand_on_pos "..private.dolls_anim_array[i].."1" );
       ObjSet( "anm_dolls_anm_dolls"..i, {animfunc = private.dolls_anim_array[i].."1", frame = 0, playing=0 } );
     else 
    --   ld.LogTrace( "stand_on_pos "..private.dolls_anim_array[i].."2" );
       ObjSet( "anm_dolls_anm_dolls"..i, {animfunc = private.dolls_anim_array[i].."2", frame = 0, playing=0 } );
     end;  
    
   end; 
  
   
   if without_win_ver~=1 then  private.dolls_win_ver(); end;
 --  ld.LogTrace( ng_global.progress["std"]["win_dolls"].state ); 
end;  


function private.dolls_win_ver()
  local count=0;
  for i=1,4,1 do 
    if ng_global.progress["std"]["win_dolls"].state[1][i]==1 and ng_global.progress["std"]["win_dolls"].state[2][i] == 2 then count=count+1; end;
  end;  
  
  if count==4 then private.Win(); end;
end;  



private.dolls_first_init_flag = false; 
function private.dolls_first_init()
  if private.dolls_first_init_flag==false then 
    for i=1,4,1 do 
      ObjSet( "obj_dolls_"..private.dolls_anim_array[i], {input=1, event_mdown="mg_dolls.dolls_mdown("..i..");", event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
    end;  
  end;
  
  private.dolls_first_init_flag = true;
end;  
 
 
 
 
function public.dolls_mdown(num)
   SoundSfx( "aud_mg_dolls_click" );
   private.dolls_rotate(num);
   private.dolls_rotate(private.dolls_connect[num],1);
end;  
 
 
 
function private.dolls_rotate(num, with_stand_on_pos)
  local num1,num2 = 0,0;
  
  local func_end3 = function()
    if with_stand_on_pos==1 then  ld.Lock(0); private.dolls_stand_on_pos(); end;
  end;  
  
  local func_end2 = function()
    ng_global.progress["std"]["win_dolls"].state[3][num] = ng_global.progress["std"]["win_dolls"].state[3][num]+1;
    if ng_global.progress["std"]["win_dolls"].state[3][num]>=private.dolls_click_array[num] then  
      ng_global.progress["std"]["win_dolls"].state[3][num]=0; 
      local anim_num = 1;
      if ng_global.progress["std"]["win_dolls"].state[2][num]==1 then ng_global.progress["std"]["win_dolls"].state[2][num]=2;anim_num=1; SoundSfx( "aud_mg_dolls_hands_on" ); else ng_global.progress["std"]["win_dolls"].state[2][num]=1;anim_num=2; SoundSfx("aud_mg_dolls_hands_off");  end;
  --    ld.LogTrace( private.dolls_anim_array[num]..""..anim_num );
      ObjSet( "anm_dolls_anm_dolls"..num, {animfunc = private.dolls_anim_array[num]..""..anim_num, frame=0, playing=0 } );
      ld.AnimPlay( "anm_dolls_anm_dolls"..num,  private.dolls_anim_array[num]..""..anim_num, func_end3 )
    else  
      ld.StartTimer( 0.41, function() func_end3(); end);
    end;  
  end;  
  
  
  local func_end1 = function()
    if ng_global.progress["std"]["win_dolls"].state[1][num]==1 then ng_global.progress["std"]["win_dolls"].state[1][num]=2; else ng_global.progress["std"]["win_dolls"].state[1][num]=1; end;

    ObjSet( "spr_dolls_"..private.dolls_anim_array[num]..num1, {visible = 0} );
    ObjSet( "spr_dolls_"..private.dolls_anim_array[num]..num2, {visible = 1} );
    ObjAnimate( "obj_dolls_"..private.dolls_anim_array[num], 8, 0, 0, func_end2, {0,0,0, 0.25,0,1} );
  end;  
  
  ld.Lock(1);
  if  ng_global.progress["std"]["win_dolls"].state[1][num]==1 then num1=1; num2=2; else num1=2; num2 = 1; end;
  ObjAnimate( "obj_dolls_"..private.dolls_anim_array[num], 8, 0, 0, func_end1, {0,0,1, 0.25,0,0} );
  ObjAnimate( "spr_dolls_lig"..num, 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );
end;  


 
 
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_dolls"} ) then
  SoundMgTheme( true )
   
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( {"win_dolls"} ) then
     cmn.MiniGameShow( "dolls" );  
  end;
  
  private.dolls_first_init()
  
  SoundEnv( "aud_terrace_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_dolls"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "dolls" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  local func_end = function() 
      ng_global.progress["std"]["win_dolls"].state  = ld.TableCopy(private.dolls_fp_array);
      private.dolls_stand_on_pos();
      ObjAnimate( "obj_dolls_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.25,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_dolls_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
  
end;
--*********************************************************************************************************************
function public.Skip()
   local func_end = function() 
      ng_global.progress["std"]["win_dolls"].state  = {{1,1,1,1},{2,2,2,2},{0,0,0,0}};
      private.dolls_stand_on_pos(1);
      ObjAnimate( "obj_dolls_mg_root", 8, 0, 0, function()  private.dolls_stand_on_pos(); end, {0,0,0, 0.25,0,1} );
  end
  
  
  ld.Lock(1);
  ObjAnimate( "obj_dolls_mg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_dolls" );
  cmn.CallEventHandler( "win_dolls" );
  if common_impl.ZzCompleteCheck( "win_dolls" ) then cmn.GotoRoom( "rm_terrace" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, function()  SoundSfx( "aud_mg_dolls_win" ); ld.AnimPlay( "anm_dolls_anm_dolls_door", "open_default", private.WinEnd  ); end );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["std"]["win_dolls"].state then
      gm.state = ld.TableCopy( ng_global.progress["std"]["win_dolls"].state )
    else  
       ng_global.progress["std"]["win_dolls"].state  = ld.TableCopy(private.dolls_fp_array);
      
    end
  
    gm.loaded  = true;
  else
  
  end;
  
  if not cmn.IsEventDone("win_dolls") then 
     private.dolls_stand_on_pos();
  else
     private.dolls_stand_on_pos(1);
  end;    
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_dolls"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;


------------------------------ other funcs -----------------------------
function public.dolls_idle_default_clk_zone()
  local func_end = function() 
      ld.Lock(0); 
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_plastic" );
  ld.AnimPlay( "anm_dolls_anm_dolls_door", "idle_default", func_end )
end;  