-- name=mg_incabinetmg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_incabinetmg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_incabinetmg" ] = {type = "win", use_place = "mg_incabinetmg", room = "rm_secondfloor", zz = "mg_incabinetmg", zz_gate = "gmg_secondfloor_incabinetmg" };

  local win_incabinetmg_logic = function()
    if ld.CheckRequirements( {"win_incabinetmg"} ) then
      ObjSet("spr_incabinetmg_ingredientt",{ visible = 1, input = 1, active = 1 })
    end
  end;
  local win_incabinetmg = function()
    if ld.CheckRequirements( {"win_incabinetmg"} ) then
      ObjDelete("obj_incabinetmg_mg_root");
      ObjDelete("spr_incabinetmg_door");
    end
  end;
  cmn.AddSubscriber("win_incabinetmg", win_incabinetmg, private.room_objname )
  cmn.AddSubscriber("win_incabinetmg", win_incabinetmg_logic )
  --------------------------------------------------------------------------------------------
 
----------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ingredientt" ] = { type = "get", get_obj = "spr_incabinetmg_ingredientt", room = "rm_secondfloor", zz = "mg_incabinetmg", zz_gate = "gmg_secondfloor_incabinetmg" };

private.get_ingredientt_logic = function()
  
end;
private.get_ingredientt_inv = function()
  interface.InventoryItemAdd("inv_ingredientt","spr_incabinetmg_ingredientt");
end;
private.get_ingredientt_beg = function()
  ObjDelete("gfx_incabinetmg_ingredientt")
end;
private.get_ingredientt_end = function()
  ObjDelete("spr_incabinetmg_sh_ingredientt");
end;

cmn.AddSubscriber( "get_ingredientt", private.get_ingredientt_inv );
cmn.AddSubscriber( "get_ingredientt", private.get_ingredientt_beg, private.room_objname );
cmn.AddSubscriber( "get_ingredientt", private.get_ingredientt_end, private.room_objname );
cmn.AddSubscriber( "get_ingredientt", private.get_ingredientt_logic );
--------------------------------------------------------------------
function public.get_ingredientt()
  cmn.SetEventDone( "get_ingredientt" );
  cmn.CallEventHandler( "get_ingredientt" );
  if common_impl.ZzCompleteCheck( "get_ingredientt" ) then cmn.GotoRoom( "rm_secondfloor" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;

 -----------------------------------------------------------------------------------------------------------------------
  local incabinetmg_loaded=0;

  function private.incabinetmg_parts_init() -- on load
    if incabinetmg_loaded==0 then 
      for i=1,37,1 do  -- select part light
         ObjCreate("spr_incabinetmg_lig_"..i, "spr");
         ObjAttach("spr_incabinetmg_lig_"..i,"spr_incabinetmg_a"..i)
         ObjSet("spr_incabinetmg_lig_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_incabinetmg/lig", color_r=0, color_g=1, color_b=0 }) --green
         ObjCreate("spr_incabinetmg_lig1_"..i, "spr");
         ObjAttach("spr_incabinetmg_lig1_"..i,"spr_incabinetmg_a"..i)
         ObjSet("spr_incabinetmg_lig1_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_incabinetmg/lig",color_r=1, color_g=0, color_b=0 }) --red
         ObjCreate("spr_incabinetmg_lig2_"..i, "spr");
         ObjAttach("spr_incabinetmg_lig2_"..i,"spr_incabinetmg_a"..i)
         ObjSet("spr_incabinetmg_lig2_"..i,{input=0, visible=1, alp=0, res="assets/levels/level/mg_incabinetmg/lig", color_r=0, color_g=0, color_b=1}) --blue
       end;
       private.incabinetmg_get_true_parts_pos()
       incabinetmg_loaded=1;
     end;   
  end;    
  
  -----------------------------------------------------------------------------------------------------------------------
  local incabinetmg_pos_array={}; --array of positions
  local incabinetmg_selected_part=0;

  function private.incabinetmg_get_true_parts_pos() --on load before stand on pos
    for i=1,37,1 do
       local buf_obj = ObjGet("spr_incabinetmg_a"..i);
       incabinetmg_pos_array[i]={buf_obj.pos_x, buf_obj.pos_y};
     end;   
  end;  
   
  -----------------------------------------------------------------------------------------------------------------------
  local incabinetmg_parts_first_pos_array={9,18,8,7,16,2,17,3,1,19,12,5,6,15,4,10,11,14,13,21,24,33,36,25,34,27,20,35,28,37,32,29,30,22,26,31,23}; --first pos array
  local incabinetmg_parts_first_ang = {};
  local incabinetmg_right_second_parts={};
  for i=1,37,1 do 
    incabinetmg_right_second_parts[i]=0;  
  end;   
    
  function private.incabinetmg_stand_on_first_pos(with_anim)  -- stand parts on firts postition
    for i=1,37,1 do 
       --stand parts_on random angle
       incabinetmg_parts_first_ang[i]=(math.random(0,5)*60)*math.pi/180;
       --stand parts on positon and set angle
       ObjSet("spr_incabinetmg_lig_"..i,{alp=0});
       ObjSet("spr_incabinetmg_lig1_"..i,{alp=0});
       ObjSet("spr_incabinetmg_lig2_"..i,{alp=0});
    end;
    for i=1,37,1 do 
      incabinetmg_right_second_parts[i]=0; 
    end;   
    
    if with_anim==1 then 
       SoundSfx( "aud_mg_incabinet_start" );
       -- after anim
       local func_end = function()
       for i=1,37,1 do 
          ObjSet("spr_incabinetmg_a"..i,{pos_x=incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][1], pos_y=incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][2], ang=incabinetmg_parts_first_ang[i],
             input=1, event_mdown="mg_incabinetmg.incabinetmg_part_mdown("..i..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"});
          end;
           ld.StartTimer( 0.5, function()  ld.Lock(0); end );
          ng_global.progress["std"]["win_incabinetmg"].state={ld.TableCopy(incabinetmg_parts_first_pos_array), ld.TableCopy(incabinetmg_parts_first_ang)};
       end; 
       ---------------------------
      
       -- anim third stape
       local func_end2=function() 
         for i=1,37,1 do 
           ObjAnimate( "spr_incabinetmg_a"..i, 3, 0, 0, function() end, {0,0,incabinetmg_pos_array[i][1],incabinetmg_pos_array[i][2], 0.5,0,incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][1],incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][2]} );
         end;
         ld.StartTimer( 0.5, func_end );  
       end;
       ----------------------------
       --anim second stape
       local func_end1 = function()
         local time={};
         for i=1,37,1 do
           time[i]=incabinetmg_parts_first_ang[i]/(3*60*math.pi/180);
           ObjAnimate( "spr_incabinetmg_a"..i, 7, 0, 0, function() end, {0,0,0, time[i],0,incabinetmg_parts_first_ang[i]} );
         end;
         ld.StartTimer( 2, func_end2 )  
       end;
       ----------------------------
      
      
      
       ld.Lock(1);
       --anim first stape
       for i=1,37,1 do 
          ObjSet("spr_incabinetmg_a"..i,{pos_x=incabinetmg_pos_array[i][1], pos_y=incabinetmg_pos_array[i][2], ang=0});
          ObjAnimate( "spr_incabinetmg_lig1_"..i, 8, 0, 0, function() end, {0,0,0, 1.5,0,0, 2,0,1, 4.5,0,1, 5,0,0} );
       end;  
       ld.StartTimer( 2, func_end1 ); 
       -- SoundSfx( "aud_mg_incabinetmg_begin" );
    else 
       for i=1,37,1 do 
         ObjSet("spr_incabinetmg_a"..i,{pos_x=incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][1], pos_y=incabinetmg_pos_array[incabinetmg_parts_first_pos_array[i] ][2], ang=incabinetmg_parts_first_ang[i],
           input=1, event_mdown="mg_incabinetmg.incabinetmg_part_mdown("..i..")", event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT)"});
       end;
    end;  
    
  end;  
  -----------------------------------------------------------------------------------------------------------------------
  local incabinetmg_on_true_pos = {};
  local incabinetmg_on_true_pos_ready=0;

  function private.incabinetmg_parts_stand_on_pos(without_win_ver)
    if incabinetmg_on_true_pos_ready==0 then 
      for i=1,37,1 do 
        incabinetmg_on_true_pos[i]=0;
      end;  
    end;
    
    for i=1,37,1 do 
      ObjSet("spr_incabinetmg_a"..i,{pos_x=incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][i] ][1], pos_y=incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][i] ][2],
              ang=ng_global.progress["std"]["win_incabinetmg"].state[2][i]})
      if ng_global.progress["std"]["win_incabinetmg"].state[1][i]==i and ng_global.progress["std"]["win_incabinetmg"].state[2][i]==0 then
        ObjSet("spr_incabinetmg_lig_"..i,{visible=1, alp=1, color_r=0, color_g=0.39, color_b=0});
         
         if incabinetmg_on_true_pos_ready==1 then 
           if  incabinetmg_on_true_pos[i]~=1 then 
              SoundSfx( "aud_mg_incabinet_true" );
              incabinetmg_on_true_pos[i]=1;
           end;  
         else 
           incabinetmg_on_true_pos[i]=1;
         end;  
      else 
         ObjSet("spr_incabinetmg_lig_"..i,{visible=1, alp=0, color_r=0, color_g=0.39, color_b=0});
         if incabinetmg_selected_part==i then ObjSet("spr_incabinetmg_lig2_"..i,{alp=1, color_r=1, color_g=1, color_b=1}); else ObjSet("spr_incabinetmg_lig2_"..i,{alp=0,color_r=1, color_g=1, color_b=1}); end; 
      end;
      ObjSet("spr_incabinetmg_lig1_"..i,{alp=0});
      -- if incabinetmg_right_second_parts[i]==1 then  ObjSet("spr_incabinetmg_lig2_"..i,{alp=1}); else ObjSet("spr_incabinetmg_lig2_"..i,{alp=0}); end;
    end;
    if without_win_ver~=1 then private.incabinetmg_win_ver(); end;
    
    incabinetmg_on_true_pos_ready=1;
  end;  
  -----------------------------------------------------------------------------------------------------------------------  
    -----------------------------------------------------------------------------------------------------------------------
    --local incabinetmg_huy_array = {{1,2,3},{4,5,6,7},{8,9,10,11,12},{13,14,15,16},{17,18,19}};

    local incabinetmg_huy_array = {{1,2,3,4},{5,6,7,8,9},{10,11,12,13,14,15},{16,17,18,19,20,21,22},{23,24,25,26,27,28},{29,30,31,32,33},{34,35,36,37}};
    
    
  function private.incabinetmg_get_pos_on_huy_array(pos)
    --  ld.LogTrace("Pos = "..pos);
    for i=1,#incabinetmg_huy_array,1 do
      for j=1,#incabinetmg_huy_array[i],1 do 
        if incabinetmg_huy_array[i][j]==pos then return i,j end;
      end;  
    end;  
    
    return 0;
  end;  

  function private.incabinetmg_return_part_by_pos(pos)
    for i=1,37,1 do 
       if ng_global.progress["std"]["win_incabinetmg"].state[1][i]==pos then return i; end;    
    end;  
    return 0; 
  end;  
   
  function private.incabinetmg_search_true_second_parts()
    for i=1,37,1 do 
       incabinetmg_right_second_parts[i]=0; 
    end;
  --  -- ld.LogTrace("incabinetmg_selected_part = "..incabinetmg_selected_part);
  -- 
  -- if incabinetmg_selected_part~=0 then 
  -- 
  --    local sel_part_pos =  ng_global.progress["std"]["win_incabinetmg"].state[1][incabinetmg_selected_part];
  --    local set_i1, set_j1 = private.incabinetmg_get_pos_on_huy_array(sel_part_pos); 
  --    --   ld.LogTrace("set_i1 = "..set_i1.."/ set_j1 = "..set_j1)
  --   
  --    for i1=1,#incabinetmg_huy_array,1 do 
  --      for j1=1,#incabinetmg_huy_array[i1],1 do 
  --         if math.abs(set_i1-i1)<=1 then -- proverka po riyadu
  --            if  math.abs(set_i1-i1)==0 then   -- v odnom ryadu
  --                if math.abs(set_j1-j1)==1 then 
  --                  incabinetmg_right_second_parts[private.incabinetmg_return_part_by_pos(incabinetmg_huy_array[i1][j1])]=1;
  --                end;  
  --            else 
  --                if set_j1==j1 then 
  --                   incabinetmg_right_second_parts[private.incabinetmg_return_part_by_pos(incabinetmg_huy_array[i1][j1])]=1;
  --                else 
  --                   if (set_j1==j1+1  and #incabinetmg_huy_array[set_i1]>#incabinetmg_huy_array[i1])  or (set_j1==j1-1 and #incabinetmg_huy_array[set_i1]<#incabinetmg_huy_array[i1]) then 
  --                     incabinetmg_right_second_parts[private.incabinetmg_return_part_by_pos(incabinetmg_huy_array[i1][j1])]=1;
  --                   end;  
  --                end;  
  --            end;  
  --         end  
  --       end;
  --    end;  
  --   
  -- end; 
  -- ------------------- delete lock parts 
  -- for i=1,37,1 do 
  --    if incabinetmg_right_second_parts[i]==1 and ng_global.progress["std"]["win_incabinetmg"].state[1][i]==i and ng_global.progress["std"]["win_incabinetmg"].state[2][i]==0 then 
  --       incabinetmg_right_second_parts[i]=0;
  --    end;  
  -- end;
  -- 
  --       
  end;  
  
 -----------------------------------------------------------------------------------------------------------------------
  function public.incabinetmg_part_mdown(num)
     local func_end = function()
       ObjSet( "spr_incabinetmg_a"..num, {pos_z=0} );
       ObjSet( "spr_incabinetmg_a"..incabinetmg_selected_part, {pos_z=0} );
       ObjSet( "spr_incabinetmg_lig_"..num, {alp=0} );
       ObjSet( "spr_incabinetmg_lig2_"..num, {alp=0} );
       for i=1,37,1 do 
          incabinetmg_right_second_parts[i]=0; 
       end;
        --incabinetmg_selected_part=0; 
       ld.Lock(0);
       --  private.incabinetmg_search_true_second_parts()
       private.incabinetmg_parts_stand_on_pos();
     end;
    
     SoundSfx( "aud_mg_incabinet_click" );
    
     if incabinetmg_selected_part==0 then 
       incabinetmg_selected_part=num;
       private.incabinetmg_search_true_second_parts()
       private.incabinetmg_parts_stand_on_pos();
     elseif incabinetmg_selected_part==num then 
       incabinetmg_selected_part=0;
       for i=1,37,1 do 
          incabinetmg_right_second_parts[i]=0; 
       end;
       private.incabinetmg_parts_stand_on_pos();
     else 
       SoundSfx( "aud_mg_incabinet_move" );
       ld.Lock(1);
       --  if incabinetmg_right_second_parts[num]==1 then 
          ng_global.progress["std"]["win_incabinetmg"].state[1][incabinetmg_selected_part],ng_global.progress["std"]["win_incabinetmg"].state[1][num] = ng_global.progress["std"]["win_incabinetmg"].state[1][num],ng_global.progress["std"]["win_incabinetmg"].state[1][incabinetmg_selected_part];
          ObjSet( "spr_incabinetmg_lig2_"..num, {alp=1} );
          -- ObjSet( "spr_incabinetmg_lig_"..num, {alp=1} );
          ObjSet( "spr_incabinetmg_a"..num, {pos_z=10} );
          ObjSet( "spr_incabinetmg_a"..incabinetmg_selected_part, {pos_z=10} );
          ObjAnimate("spr_incabinetmg_a"..num, 3, 0, 0, function()  end , {0, 0, ObjGet("spr_incabinetmg_a"..num).pos_x, ObjGet("spr_incabinetmg_a"..num).pos_y,   0.5, 0 , incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][num] ][1],incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][num] ][2]});
            ObjAnimate("spr_incabinetmg_a"..incabinetmg_selected_part, 3, 0, 0, "" , {0, 0, ObjGet("spr_incabinetmg_a"..incabinetmg_selected_part).pos_x, ObjGet("spr_incabinetmg_a"..incabinetmg_selected_part).pos_y,   0.5, 0 , incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][incabinetmg_selected_part] ][1],incabinetmg_pos_array[ng_global.progress["std"]["win_incabinetmg"].state[1][incabinetmg_selected_part] ][2]});
          ld.StartTimer( 0.7, func_end )
     -- else 
     --    ObjAnimate("spr_incabinetmg_lig1_"..num, 8, 0, 0, " ", {0, 0, 0, 0.25,0,1, 0.5,0,0});
     --    ObjAnimate("spr_incabinetmg_lig1_"..incabinetmg_selected_part, 8, 0, 0, " ", {0, 0, 0, 0.25,0,1, 0.5,0,0});
     --    ld.StartTimer( 0.7, func_end )
     --  end;  
     end;  
  end;  

  ----------------------------------------------------------------------------------------------------------------------

  function public.incabinetmg_rotate_selected_part()  --mg_incabinetmg.incabinetmg_rotate_selected_part()
    local func_end = function()
      private.incabinetmg_parts_stand_on_pos();
    end;
    
    local func_preend = function()
      new_ang = math.fmod(ng_global.progress["std"]["win_incabinetmg"].state[2][incabinetmg_selected_part] - (60/180-4)*math.pi ,2*math.pi);
      --if new_ang==2*math.pi then new_ang=0; end;
      if math.floor(new_ang)==0 or math.floor(new_ang)==6 then new_ang=0; end;
      ng_global.progress["std"]["win_incabinetmg"].state[2][incabinetmg_selected_part] = new_ang;
      ObjSet("spr_incabinetmg_a"..incabinetmg_selected_part,{ang = new_ang});
      func_end();
    end;
    
    SoundSfx( "aud_mg_incabinet_button" );
    
    ld.Lock(1);
    local tr_ang = - 45*math.pi/180;
    local new_ang=0;
    ObjAnimate("spr_incabinetmg_clik", 7, 0, 0, " ", {0, 0, 0,  0.25,0,tr_ang, 0.5,0,0 });
    ObjAnimate( "spr_incabinetmg_sh_clik", 8, 0, 0, function() end, {0,0,0, 0.1,0,1, 0.4,0,1, 0.5,0,0} );
    if incabinetmg_selected_part~=0 then 
      --  SoundSfx( "aud_mg_incabinetmg_hexagon_rotate" );
       ObjAnimate("spr_incabinetmg_a"..incabinetmg_selected_part, 7, 0, 0, func_preend, {0, 0, ObjGet("spr_incabinetmg_a"..incabinetmg_selected_part).ang,  0.25,0,ObjGet("spr_incabinetmg_a"..incabinetmg_selected_part).ang-60*math.pi/180 });
    else 
       ld.StartTimer( 0.5, func_end);
    end;  
  end;  
   
    -----------------------------------------------------------------------------------------------------------------------
  function private.incabinetmg_win_ver()
    --  ld.LogTrace("win ver");
    local count=0;
    for i=1,37,1 do 
       --  ld.LogTrace("ang["..i.."] = "..ng_global.progress["std"]["win_incabinetmg"].state[2][i].." pos = "..ng_global.progress["std"]["win_incabinetmg"].state[1][i])
         if ng_global.progress["std"]["win_incabinetmg"].state[1][i]==i and ng_global.progress["std"]["win_incabinetmg"].state[2][i]==0 then 
            ObjSet( "spr_incabinetmg_a"..i, {input = 0} );
            count=count+1; 
            if incabinetmg_selected_part==i then 
                ObjSet( "spr_incabinetmg_lig2_"..i, {alp=0} );
                for j=1,37,1 do 
                  incabinetmg_right_second_parts[j]=0; 
                end;
                incabinetmg_selected_part=0; 
            end;
            private.incabinetmg_parts_stand_on_pos(1);
        --    ld.LogTrace("sovp i="..i.." on pos = "..ng_global.progress["std"]["win_incabinetmg"].state[1][i]);
            
         else
             ObjSet( "spr_incabinetmg_a"..i, {input = 1} ); 
         end;  
     end;
     if count==37 then ObjSet( "spr_incabinetmg_clik", {input = 0} ); private.Win(); else ld.Lock(0);  end;   
  end; 
 
    
-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Open()
-- if not ld.CheckRequirements( {"win_incabinetmg"} ) then
-- SoundMgTheme( true )
--   cmn.MiniGameShow( "incabinetmg" );
-- end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_secondfloor_env" )
 
  if not ld.CheckRequirements( {"win_incabinetmg"} ) then
    gm.load();
    cmn.MiniGameShow( "incabinetmg" );
  end
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_incabinetmg"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "incabinetmg" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
   local func_preend = function()
  --  ng_global.progress["std"]["win_incabinetmg"].state={ld.TableCopy(incabinetmg_parts_first_pos_array), ld.TableCopy(incabinetmg_parts_first_ang)};
     incabinetmg_selected_part=0;
     for i=1,37,1 do 
        incabinetmg_right_second_parts[i]=0; 
     end;
      -- private.incabinetmg_parts_stand_on_pos();
     private.incabinetmg_stand_on_first_pos(1) -- with start anim 
     ObjAnimate("obj_incabinetmg_mg_root", 8, 0, 0, " ", {0, 0, 0, 0.25, 0, 1});
     incabinetmg_on_true_pos_ready=0;
  end;
  
  ld.Lock(1);
  ObjAnimate("obj_incabinetmg_mg_root", 8, 0, 0, func_preend, {0, 0, 1, 0.25, 0, 0});
end;
--*********************************************************************************************************************
function public.Skip()
  -- private.Win();
   --  private.Win();
  local func_end=function()
  --ld.Lock(0);
  end;

  local func_preend = function()
  --  ng_global.progress["std"]["win_incabinetmg"].state={ld.TableCopy(incabinetmg_parts_first_pos_array), ld.TableCopy(incabinetmg_parts_first_ang)};
     incabinetmg_selected_part=0;
     for i=1,37,1 do 
        ng_global.progress["std"]["win_incabinetmg"].state[1][i]=i;
        ng_global.progress["std"]["win_incabinetmg"].state[2][i]=0;
        incabinetmg_right_second_parts[i]=0; 
        --    ObjSet("spr_incabinetmg_lig_"..i,{visible=1, alp=1, color_r=0.5, color_g=0.5, color_b=0.5});
     end;
     incabinetmg_on_true_pos_ready=0; 
     private.incabinetmg_parts_stand_on_pos();
     ObjAnimate("obj_incabinetmg_mg_root", 8, 0, 0, func_end, {0, 0, 0, 0.25, 0, 1});
  end;
  
  ld.Lock(1);
  ObjAnimate("obj_incabinetmg_mg_root", 8, 0, 0, func_preend, {0, 0, 1, 0.25, 0, 0});
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_incabinetmg" );
  cmn.CallEventHandler( "win_incabinetmg" );
  if common_impl.ZzCompleteCheck( "win_incabinetmg" ) then cmn.GotoRoom( "rm_secondfloor" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
 --ld.Lock(1);
 --cmn.MiniGameHide();
 --SoundMgTheme( false )
 --ld.StartTimer( 0.5, private.WinEnd  );
 
  local func_end=function()
  --  ld.Lock(1);
  --SoundSfx( "aud_open_fence_farm" );
  ld.StartTimer( 0.5, function()  cmn.MiniGameHide(true); private.WinEnd();  end);
  end;
   
  local func_preend2 = function()
    local cur_p = {510,365};
    ObjSet( "spr_incabinetmg_ingredientt", {active = 1, visible = 1} );
    ObjAnimate( "spr_incabinetmg_door", 3, 0, 0, func_end, {0,0,cur_p[1],cur_p[2], 0.7,0,cur_p[1],cur_p[2]*(-1)} );
  end;   
     
  local func_preend = function()
    for i=1,37,1 do 
      ObjAnimate("spr_incabinetmg_lig_"..i, 8, 0, 0, " ", {0,0,1, 1,1,1, 1.5,1,0});
    end;  
    ObjAnimate( "spr_incabinetmg_clik", 7, 0, 0, function() end, {0,0,0, 1,0,-2*math.pi} ); 
      ld.StartTimer(1.8,func_preend2);
  end; 
   
  ld.Lock(1);
  for i=1,37,1 do 
     ObjAnimate("spr_incabinetmg_lig2_"..i, 8, 0, 0, " ", {0, 0, ObjGet("spr_incabinetmg_lig2_"..i),alp, 0.25,0,0});
  end
  ld.StartTimer(0.5,func_preend);
  SoundSfx( "aud_mg_incabinet_win" );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
 --if not gm.loaded then
 --
 --  gm.default()
 --  if ng_global.progress["std"]["win_incabinetmg"].state then
 --    gm.state = ld.TableCopy( ng_global.progress["std"]["win_incabinetmg"].state )
 --  end
 --
 --  gm.loaded  = true;
 --else
 --
 --end;
  private.incabinetmg_parts_init() 
  if not gm.loaded then
     gm.loaded  = true;
  else
   
  end;
  
  if not cmn.IsEventStart("win_incabinetmg") then 
    private.incabinetmg_stand_on_first_pos(1) --with start anim 
   -- cmn.SetEventStart("win_incabinetmg");
    ng_global.progress["std"]["win_incabinetmg"].state={ld.TableCopy(incabinetmg_parts_first_pos_array), ld.TableCopy(incabinetmg_parts_first_ang)};
  elseif not cmn.IsEventDone("win_incabinetmg") then   
    --   ld.LogTrace("Loaded")
    incabinetmg_selected_part=0;
    private.incabinetmg_stand_on_first_pos() 
    private.incabinetmg_parts_stand_on_pos();
  end;  
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["std"]["win_incabinetmg"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;