-- name=rm_cellar
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cellar";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_storage_note", "spr_storage_note_big","lordsdiarypage_clk")
  
  --------------------------------------------------------------------------------------------
function private.opn_cellar()
  if not ( cmn.IsEventDone( "opn_cellar" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_cellar" );
      cmn.CallEventHandler( "opn_cellar" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_cellar = function() end;
local opn_cellar_logic = function() end;
cmn.AddSubscriber( "opn_cellar", opn_cellar_logic )
cmn.AddSubscriber( "opn_cellar", opn_cellar, private.room_objname )
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animshadows2" ] = { type = "click", use_place = "gfx_cellar_clk_animshadows2_zone", room = "rm_cellar" };

private.clk_animshadows2_logic = function()
  ObjSet("gzz_cellar_storage",{visible = 1, input = 1, active = 1})
  ObjSet("gzz_cellar_glassdoor",{visible = 1, input = 1, active = 1})  
  ObjSet("gzz_cellar_warehouse",{visible = 1, input = 1, active = 1})
  ObjSet("gzz_cellar_grille",{visible = 1, input = 1, active = 1})    
end;
private.clk_animshadows2_beg = function()
  ObjDelete( "gfx_cellar_clk_animshadows2_zone" );
end;
private.clk_animshadows2_end = function()
  ObjSet( "anm_cellar_anm_door_to_backyard", {visible = 1} );
  ObjDelete("anm_cellar_anm_shadow");  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animshadows2", private.clk_animshadows2_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows2", private.clk_animshadows2_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows2", private.clk_animshadows2_logic );
cmn.AddSubscriber( "clk_animshadows2_beg", private.clk_animshadows2_beg, private.room_objname );
cmn.AddSubscriber( "clk_animshadows2_end", private.clk_animshadows2_end, private.room_objname );
cmn.AddSubscriber( "clk_animshadows2_end", private.clk_animshadows2_logic );
--------------------------------------------------------------------------------------------
function public.clk_animshadows2()

  local func_end = function()
    cmn.SetEventDone( "clk_animshadows2" );
    cmn.CallEventHandler( "clk_animshadows2_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_anmincellar");
    SoundTheme( "aud_danger_moment2_mus" );
  end;

  cmn.CallEventHandler( "clk_animshadows2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_cellar_anm_shadow", "shadow", function() end );
  SoundSfx( "aud_clk_animshadows2_cellar" )
  --func_end()
  ObjAnimate( "rm_cellar", 6, 0, 0, func_end, {0,0,1,1, 0.8,0,1,1, 1.8,0,1.3,1.3, 3,0,1.3,1.3, 4,0,1,1} );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_portrait" ] = { type = "use", inv_obj = "inv_portrait", use_place = "gfx_cellar_portrait_zone", room = "rm_cellar" };

private.use_portrait_logic = function()
   
  ObjSet("gfx_cellar_dlg_cellar_lekar1_zone",{visible = 1, input = 1, active = 1})
end;
private.use_portrait_inv = function()
  common_impl.ProcessMultiUseAll("portrait", "portrait")
end;
private.use_portrait_beg = function()
  ObjDelete( "gfx_cellar_portrait_zone" );
end;
private.use_portrait_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_portrait", private.use_portrait_inv );
cmn.AddSubscriber( "use_portrait", private.use_portrait_beg, private.room_objname );
cmn.AddSubscriber( "use_portrait", private.use_portrait_end, private.room_objname );
cmn.AddSubscriber( "use_portrait", private.use_portrait_logic );
cmn.AddSubscriber( "use_portrait_inv", private.use_portrait_inv, private.room_objname );
cmn.AddSubscriber( "use_portrait_beg", private.use_portrait_beg, private.room_objname );
cmn.AddSubscriber( "use_portrait_end", private.use_portrait_end, private.room_objname );
cmn.AddSubscriber( "use_portrait_end", private.use_portrait_logic );
--------------------------------------------------------------------------------------------
function public.use_portrait( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_portrait" );
    cmn.CallEventHandler( "use_portrait_end" );
    common_impl.Lock(0);
    public.dlg_cellar_lekar1();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_portrait_inv" );
  cmn.CallEventHandler( "use_portrait_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_portrait_cellar" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
if dlg_name == "lekar1" then
      if count_txt == 1 then
        
      elseif count_txt == 2 then    
        ld.Lock(1);
        AnimPlay( "anm_cellar_lekar1", "giv", function() ld.Lock(0);  end);
        SoundSfx( "aud_get_to_us" )  
      elseif  count_txt == 3 then
        ld.Lock(1);
        SoundSfx( "aud_touch_paper_barnes" );
        AnimPlay( "anm_cellar_lekar1", "giv1", function() ld.Lock(0);   end);  
        AnimPlay( "anm_cellar_lekar1_text", "text", function()  end);  
      elseif count_txt == 4 then 
        cmn.CallEventHandler( "get_notelekar" );
        ObjSet( "spr_cellar_notelekar", {visible = 1, activ = 1 } );
        --ld.AnimPlayFromStatic( "anm_cellar_lecar1", "giv1", "" )  
        
      end;  
  end;
end;


common_impl.hint[ "dlg_cellar_lekar1" ] = { type = "click", use_place = "gfx_cellar_dlg_cellar_lekar1_zone", room = "rm_cellar" };

private.dlg_cellar_lekar1_logic = function()
  
end;
private.dlg_cellar_lekar1_beg = function()
  ObjDelete( "gfx_cellar_dlg_cellar_lekar1_zone" );
end;
private.dlg_cellar_lekar1_end = function()
 
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_cellar_lekar1", private.dlg_cellar_lekar1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cellar_lekar1", private.dlg_cellar_lekar1_end, private.room_objname );
cmn.AddSubscriber( "dlg_cellar_lekar1", private.dlg_cellar_lekar1_logic );
cmn.AddSubscriber( "dlg_cellar_lekar1_beg", private.dlg_cellar_lekar1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_cellar_lekar1_end", private.dlg_cellar_lekar1_end, private.room_objname );
cmn.AddSubscriber( "dlg_cellar_lekar1_end", private.dlg_cellar_lekar1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_cellar_lekar1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_cellar_lekar1" );
    cmn.CallEventHandler( "dlg_cellar_lekar1_end" );
    cmn.SetEventDone( "get_notelekar" );
      if ObjGetRelations( "inv_notelekar" ).parent == "level_inv_hub" then
        ObjSet( "spr_cellar_notelekar", {visible = 1} );
        cmn.CallEventHandler( "get_notelekar" );
      end
    common_impl.Lock(0);
    ld.ShowBbt("after_dlg_chimeraman_1");
  end;

  function public.dlg_cellar_lekar1_end()
    ObjSet( "dlg_cellar_lekar1", {bake=1} );
    common_impl.Lock(1);
    func_end()
  end
 
  cmn.CallEventHandler( "dlg_cellar_lekar1_beg" );
  

 common_impl.dialog_character_loc = "anim_cellar_anim_lekar1"
  common_impl.continue_visible = false;
  common_impl.Start( "lekar1", 4, nil, nil, true, "dlg_cellar_lekar1_end",{"aud_barnes_1_voc","aud_barnes_2_voc","aud_barnes_3_voc"} );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_notelekar" ] = { type = "get", get_obj = "spr_cellar_notelekar", room = "rm_cellar" };

private.get_notelekar_logic = function()
  
end;
private.get_notelekar_inv = function()
  interface.InventoryItemAdd("inv_notelekar","spr_cellar_notelekar");
end;
private.get_notelekar_beg = function()
  ObjDelete("gfx_cellar_notelekar")
end;
private.get_notelekar_end = function()
  
end;

cmn.AddSubscriber( "get_notelekar", private.get_notelekar_inv );
cmn.AddSubscriber( "get_notelekar", private.get_notelekar_beg, private.room_objname );
cmn.AddSubscriber( "get_notelekar", private.get_notelekar_end, private.room_objname );
cmn.AddSubscriber( "get_notelekar", private.get_notelekar_logic );
--------------------------------------------------------------------
function public.get_notelekar()
  cmn.SetEventDone( "get_notelekar" );
  cmn.CallEventHandler( "get_notelekar" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_grille *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "clk_slipofpaper_open" ] = { type = "click", use_place = "gfx_grille_clk_slipofpaper_open_zone", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.clk_slipofpaper_open_logic = function()
  ObjSet( "gfx_grille_clk_slipofpaper_close_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_grille_wire_zone", { visible = 0, input = 0, active = 0 } )
  ObjSet( "gfx_grille_puzzlepiece_zone", { visible = 0, input = 0, active = 0 } )
end;
private.clk_slipofpaper_open_beg = function()
  ObjDelete( "gfx_grille_clk_slipofpaper_open_zone" );
end;
private.clk_slipofpaper_open_end = function()
  if common_impl.ZzCompleteCheck("clk_slipofpaper_open") then ObjSet( common_impl.hint["clk_slipofpaper_open"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_grille_anm_paper", {animfunc = "close_peper", frame = 0, pos_z = 40 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_slipofpaper_open", private.clk_slipofpaper_open_beg, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_open", private.clk_slipofpaper_open_end, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_open", private.clk_slipofpaper_open_logic );
cmn.AddSubscriber( "clk_slipofpaper_open_beg", private.clk_slipofpaper_open_beg, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_open_end", private.clk_slipofpaper_open_end, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_open_end", private.clk_slipofpaper_open_logic );
--------------------------------------------------------------------------------------------
function public.clk_slipofpaper_open()

  local func_end = function()
    cmn.SetEventDone( "clk_slipofpaper_open" );
    cmn.CallEventHandler( "clk_slipofpaper_open_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_slipofpaper_open") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_slipofpaper_open_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_grille_anm_paper", {pos_z = 40} );
  ld.AnimPlay( "anm_grille_anm_paper", "open_peper", func_end );
  SoundSfx( "aud_touch_paper_cellar" )
  --func_end()

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_slipofpaper_close" ] = { type = "click", use_place = "gfx_grille_clk_slipofpaper_close_zone", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.clk_slipofpaper_close_logic = function()
  ObjSet( "spr_grille_slipofpaper", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_grille_wire_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_grille_puzzlepiece_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_slipofpaper_close_beg = function()
  ObjDelete( "gfx_grille_clk_slipofpaper_close_zone" );
end;
private.clk_slipofpaper_close_end = function()
  if common_impl.ZzCompleteCheck("clk_slipofpaper_close") then ObjSet( common_impl.hint["clk_slipofpaper_close"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_grille_anm_paper", {alp = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_slipofpaper_close", private.clk_slipofpaper_close_beg, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_close", private.clk_slipofpaper_close_end, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_close", private.clk_slipofpaper_close_logic );
cmn.AddSubscriber( "clk_slipofpaper_close_beg", private.clk_slipofpaper_close_beg, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_close_end", private.clk_slipofpaper_close_end, private.room_objname );
cmn.AddSubscriber( "clk_slipofpaper_close_end", private.clk_slipofpaper_close_logic );
--------------------------------------------------------------------------------------------
function public.clk_slipofpaper_close()

  local func_end = function()
    ld.ShowBbt("after_anmtocellar");
    ObjSet( "spr_grille_slipofpaper", {visible = 1} );
    cmn.SetEventDone( "clk_slipofpaper_close" );
    cmn.CallEventHandler( "clk_slipofpaper_close_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("get_slipofpaper") then ld.CloseSubRoom() end;

    public.get_slipofpaper()
  end;

  cmn.CallEventHandler( "clk_slipofpaper_close_beg" );
  common_impl.Lock(1);
  
  ObjAnimate( "anm_grille_anm_paper", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  func_end()
  --ld.AnimPlay( "anm_grille_anm_paper", "open_peper", func_end );
  --SoundSfx( "" )
  --func_end()

end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_slipofpaper" ] = { type = "get", get_obj = "spr_grille_slipofpaper", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.get_slipofpaper_logic = function()
  
end;
private.get_slipofpaper_inv = function()
  interface.InventoryItemAdd("inv_slipofpaper","spr_grille_slipofpaper");
end;
private.get_slipofpaper_beg = function()
  ObjDelete("gfx_grille_slipofpaper")
end;
private.get_slipofpaper_end = function()
  if common_impl.ZzCompleteCheck("get_slipofpaper") then ObjSet( common_impl.hint["get_slipofpaper"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_grille_anm_paper");
  ObjDelete("spr_cellar_slipofpaper");
end;

cmn.AddSubscriber( "get_slipofpaper", private.get_slipofpaper_inv );
cmn.AddSubscriber( "get_slipofpaper", private.get_slipofpaper_beg, private.room_objname );
cmn.AddSubscriber( "get_slipofpaper", private.get_slipofpaper_end, private.room_objname );
cmn.AddSubscriber( "get_slipofpaper", private.get_slipofpaper_logic );
--------------------------------------------------------------------
function public.get_slipofpaper()
    
    cmn.SetEventDone( "get_slipofpaper" );
    cmn.CallEventHandler( "get_slipofpaper" );
    if common_impl.ZzCompleteCheck("get_slipofpaper") then ld.CloseSubRoom() end;
 
 
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wire" ] = { type = "use", inv_obj = "inv_wire", use_place = "gfx_grille_wire_zone", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.use_wire_logic = function()
  ObjSet( "spr_grille_grape1", {  input = 1, active = 1 } )

end;
private.use_wire_inv = function()
  common_impl.ProcessMultiUseAll("wire", "wire")
end;
private.use_wire_beg = function()
  ObjDelete( "gfx_grille_wire_zone" );
end;
private.use_wire_end = function()
  if common_impl.ZzCompleteCheck("use_wire") then ObjSet( common_impl.hint["use_wire"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_grille_anm_wire", {visible = 1,animfunc = "end_wire", frame = 0 } );
  ObjSet( "gfx_grille_grape1", { visible = 1, active = 1} );
  
  ObjSet( "anm_grille_anm_door", { visible = 1} );
  ObjDelete("spr_grille_sh_grape1");
  ObjSet( "spr_grille_grape1", {pos_x = -78.6766, pos_y = 109.1308} );
  ObjDelete("spr_grille_tr_door");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wire", private.use_wire_inv );
cmn.AddSubscriber( "use_wire", private.use_wire_beg, private.room_objname );
cmn.AddSubscriber( "use_wire", private.use_wire_end, private.room_objname );
cmn.AddSubscriber( "use_wire", private.use_wire_logic );
cmn.AddSubscriber( "use_wire_inv", private.use_wire_inv, private.room_objname );
cmn.AddSubscriber( "use_wire_beg", private.use_wire_beg, private.room_objname );
cmn.AddSubscriber( "use_wire_end", private.use_wire_end, private.room_objname );
cmn.AddSubscriber( "use_wire_end", private.use_wire_logic );
--------------------------------------------------------------------------------------------
function public.use_wire( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wire" );
    cmn.CallEventHandler( "use_wire_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wire") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wire_inv" );
  cmn.CallEventHandler( "use_wire_beg" );
  common_impl.Lock(1);
  
  ObjSet( "anm_grille_anm_wire", {visible = 1} );
  ObjSet( "spr_grille_grape1", {visible = 0} );
  ObjSet( "spr_grille_sh_grape1", {visible = 0} );
  ObjSet( "anm_grille_anm_door", {visible = 0} );
  ObjSet( "spr_grille_tr_door", {visible = 1} );
  ld.AnimPlay( "anm_grille_anm_wire", "use_wire", func_end );
  SoundSfx( "aud_use_wire_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_grape1" ] = { type = "get", get_obj = "spr_grille_grape1", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.get_grape1_logic = function()
  
end;
private.get_grape1_inv = function()
  interface.InventoryItemAdd("inv_grape1","spr_grille_grape1");
end;
private.get_grape1_beg = function()
  ObjDelete("gfx_grille_grape1")
end;
private.get_grape1_end = function()
  if common_impl.ZzCompleteCheck("get_grape1") then ObjSet( common_impl.hint["get_grape1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_grille_anm_wire");
end;

cmn.AddSubscriber( "get_grape1", private.get_grape1_inv );
cmn.AddSubscriber( "get_grape1", private.get_grape1_beg, private.room_objname );
cmn.AddSubscriber( "get_grape1", private.get_grape1_end, private.room_objname );
cmn.AddSubscriber( "get_grape1", private.get_grape1_logic );
--------------------------------------------------------------------
function public.get_grape1()
  ObjSet( "spr_grille_grape1", {  visible = 1 } )
  ObjSet( "anm_grille_anm_wire", {visible = 0} );
  cmn.SetEventDone( "get_grape1" );
  cmn.CallEventHandler( "get_grape1" );
  if common_impl.ZzCompleteCheck("get_grape1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_puzzlepiece_zone() 
  common_impl.ShowBbt( 'need_puzzlepiece' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_metal" );
  ld.AnimPlay("anm_grille_anm_door","idle_door",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_puzzlepiece" ] = { type = "use", inv_obj = "inv_puzzlepiece", use_place = "gfx_grille_puzzlepiece_zone", room = "rm_cellar", zz = "zz_grille", zz_gate = "gzz_cellar_grille" };

private.use_puzzlepiece_logic = function()
  ObjSet( "gmg_cellar_prison", { visible = 1, input = 1, active = 1 } )

end;
private.use_puzzlepiece_inv = function()
  common_impl.ProcessMultiUseAll("puzzlepiece", "puzzlepiece")
end;
private.use_puzzlepiece_beg = function()
  ObjDelete( "gfx_grille_puzzlepiece_zone" );
end;
private.use_puzzlepiece_end = function()
  if common_impl.ZzCompleteCheck("use_puzzlepiece") then ObjSet( common_impl.hint["use_puzzlepiece"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_grille_anm_door", {animfunc = "use_pazll", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_puzzlepiece", private.use_puzzlepiece_inv );
cmn.AddSubscriber( "use_puzzlepiece", private.use_puzzlepiece_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece", private.use_puzzlepiece_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece", private.use_puzzlepiece_logic );
cmn.AddSubscriber( "use_puzzlepiece_inv", private.use_puzzlepiece_inv, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece_beg", private.use_puzzlepiece_beg, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece_end", private.use_puzzlepiece_end, private.room_objname );
cmn.AddSubscriber( "use_puzzlepiece_end", private.use_puzzlepiece_logic );
--------------------------------------------------------------------------------------------
function public.use_puzzlepiece( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_puzzlepiece" );
    cmn.CallEventHandler( "use_puzzlepiece_end" );
    --common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_puzzlepiece") then ld.CloseSubRoom() end;
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_prison" ); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_puzzlepiece_inv" );
  cmn.CallEventHandler( "use_puzzlepiece_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_grille_anm_door", "use_pazll", func_end );
  SoundSfx( "aud_use_puzzlepiece_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_warehouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_letterl" ] = { type = "get", get_obj = "spr_warehouse_letterl", room = "rm_cellar", zz = "zz_warehouse", zz_gate = "gzz_cellar_warehouse" };

private.get_letterl_logic = function()
  
end;
private.get_letterl_inv = function()
  interface.InventoryItemAdd("inv_letterl","spr_warehouse_letterl");
end;
private.get_letterl_beg = function()
  ObjDelete("gfx_warehouse_letterl")
end;
private.get_letterl_end = function()
  if common_impl.ZzCompleteCheck("get_letterl") then ObjSet( common_impl.hint["get_letterl"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cellar_letterl");
  ObjDelete("spr_warehouse_letterl_sh");
end;

cmn.AddSubscriber( "get_letterl", private.get_letterl_inv );
cmn.AddSubscriber( "get_letterl", private.get_letterl_beg, private.room_objname );
cmn.AddSubscriber( "get_letterl", private.get_letterl_end, private.room_objname );
cmn.AddSubscriber( "get_letterl", private.get_letterl_logic );
--------------------------------------------------------------------
function public.get_letterl()
  cmn.SetEventDone( "get_letterl" );
  cmn.CallEventHandler( "get_letterl" );
  if common_impl.ZzCompleteCheck("get_letterl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_clover_zone() 
  common_impl.ShowBbt( 'need_clover' )
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_warehouse_anm_door_clover","clover_door_idle",function()ld.Lock(0)end)
end;
  
common_impl.hint[ "use_clover" ] = { type = "use", inv_obj = "inv_clover", use_place = "gfx_warehouse_clover_zone", room = "rm_cellar", zz = "zz_warehouse", zz_gate = "gzz_cellar_warehouse" };

private.use_clover_logic = function()
  ObjSet( "spr_warehouse_tonguebell", {input = 1} )

end;
private.use_clover_inv = function()
  common_impl.ProcessMultiUseAll("clover", "clover")
end;
private.use_clover_beg = function()
  ObjDelete( "gfx_warehouse_clover_zone" );
end;
private.use_clover_end = function()
  if common_impl.ZzCompleteCheck("use_clover") then ObjSet( common_impl.hint["use_clover"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_warehouse_anm_door_clover", {animfunc = "clover_door_end", frame = 0 } );
  ObjDelete("spr_cellar_tonguebell_trash");
  ObjSet( "gfx_warehouse_tonguebell", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clover", private.use_clover_inv );
cmn.AddSubscriber( "use_clover", private.use_clover_beg, private.room_objname );
cmn.AddSubscriber( "use_clover", private.use_clover_end, private.room_objname );
cmn.AddSubscriber( "use_clover", private.use_clover_logic );
cmn.AddSubscriber( "use_clover_inv", private.use_clover_inv, private.room_objname );
cmn.AddSubscriber( "use_clover_beg", private.use_clover_beg, private.room_objname );
cmn.AddSubscriber( "use_clover_end", private.use_clover_end, private.room_objname );
cmn.AddSubscriber( "use_clover_end", private.use_clover_logic );
--------------------------------------------------------------------------------------------
function public.use_clover( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clover" );
    cmn.CallEventHandler( "use_clover_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_clover") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clover_inv" );
  cmn.CallEventHandler( "use_clover_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_warehouse_anm_door_clover", "use_clover", func_end );
  SoundSfx( "aud_use_clover_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tonguebell" ] = { type = "get", get_obj = "spr_warehouse_tonguebell", room = "rm_cellar", zz = "zz_warehouse", zz_gate = "gzz_cellar_warehouse" };

private.get_tonguebell_logic = function()
  
end;
private.get_tonguebell_inv = function()
  interface.InventoryItemAdd("inv_tonguebell","spr_warehouse_tonguebell");
end;
private.get_tonguebell_beg = function()
  ObjDelete("gfx_warehouse_tonguebell")
end;
private.get_tonguebell_end = function()
  if common_impl.ZzCompleteCheck("get_tonguebell") then ObjSet( common_impl.hint["get_tonguebell"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_cellar_tonguebell");
  ObjDelete("spr_warehouse_tonguebell_sh");
end;

cmn.AddSubscriber( "get_tonguebell", private.get_tonguebell_inv );
cmn.AddSubscriber( "get_tonguebell", private.get_tonguebell_beg, private.room_objname );
cmn.AddSubscriber( "get_tonguebell", private.get_tonguebell_end, private.room_objname );
cmn.AddSubscriber( "get_tonguebell", private.get_tonguebell_logic );
--------------------------------------------------------------------
function public.get_tonguebell()
  cmn.SetEventDone( "get_tonguebell" );
  cmn.CallEventHandler( "get_tonguebell" );
  if common_impl.ZzCompleteCheck("get_tonguebell") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_corkscrew_warehouse_zone() 
  common_impl.ShowBbt( 'need_corkscrew_warehouse' )
  ld.Lock(1)
  SoundSfx( "aud_touch_big_metal" );
  ld.AnimPlay("anm_warehouse_anm_door_corck","lock_idle",function()ld.Lock(0)end)
end;
  
common_impl.hint[ "use_corkscrew_warehouse" ] = { type = "use", inv_obj = "inv_corkscrew", use_place = "gfx_warehouse_corkscrew_warehouse_zone", room = "rm_cellar", zz = "zz_warehouse", zz_gate = "gzz_cellar_warehouse" };

private.use_corkscrew_warehouse_logic = function()
  ObjSet( "gho_cellar_winestore", { visible = 1, input = 1, active = 1 } )  
end;
private.use_corkscrew_warehouse_inv = function()
  common_impl.ProcessMultiUseAll("corkscrew", "corkscrew_warehouse")
end;
private.use_corkscrew_warehouse_beg = function()
  ObjDelete( "gfx_warehouse_corkscrew_warehouse_zone" );
end;
private.use_corkscrew_warehouse_end = function()
  if common_impl.ZzCompleteCheck("use_corkscrew_warehouse") then ObjSet( common_impl.hint["use_corkscrew_warehouse"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_warehouse_anm_door_corck", {animfunc = "use_corkscrew_end", frame = 0 } );
  ObjDelete("spr_cellar_chain_close");
  ObjSet( "anm_cellar_anm_door_to_ho",{animfunc="door_to_ho_open", frame=999, playing=0});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_corkscrew_warehouse", private.use_corkscrew_warehouse_inv );
cmn.AddSubscriber( "use_corkscrew_warehouse", private.use_corkscrew_warehouse_beg, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_warehouse", private.use_corkscrew_warehouse_end, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_warehouse", private.use_corkscrew_warehouse_logic );
cmn.AddSubscriber( "use_corkscrew_warehouse_inv", private.use_corkscrew_warehouse_inv, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_warehouse_beg", private.use_corkscrew_warehouse_beg, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_warehouse_end", private.use_corkscrew_warehouse_end, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_warehouse_end", private.use_corkscrew_warehouse_logic );
--------------------------------------------------------------------------------------------
function public.use_corkscrew_warehouse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_corkscrew_warehouse" );
    cmn.CallEventHandler( "use_corkscrew_warehouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_corkscrew_warehouse") then ld.CloseSubRoom() end;
  end;
  local f_step= function()
    ld.CloseSubRoom()
    SoundSfx( "aud_open_warehouse_cellar" );
    ObjDelete("spr_cellar_chain_close");    
       ld.StartTimer( 0.5, function()
         AnimPlay( "anm_cellar_anm_door_to_ho", "door_to_ho_open", func_end )
   end )
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_corkscrew_warehouse_inv" );
  cmn.CallEventHandler( "use_corkscrew_warehouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_warehouse_anm_door_corck", "use_corkscrew", f_step );
  SoundSfx( "aud_use_corkscrew_warehouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_glassdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.clk_tonguebell_zone() 
  common_impl.ShowBbt( 'need_tonguebell' )
  ld.Lock(1)
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay("anm_glassdoor_anm_ball","bat_idle",function()ld.Lock(0)end)
end;

common_impl.hint[ "use_tonguebell" ] = { type = "use", inv_obj = "inv_tonguebell", use_place = "gfx_glassdoor_tonguebell_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.use_tonguebell_logic = function()
  ObjSet( "gfx_glassdoor_clk_callbell_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_tonguebell_inv = function()
  common_impl.ProcessMultiUseAll("tonguebell", "tonguebell")
end;
private.use_tonguebell_beg = function()
  ObjDelete( "gfx_glassdoor_tonguebell_zone" );
end;
private.use_tonguebell_end = function()
  if common_impl.ZzCompleteCheck("use_tonguebell") then ObjSet( common_impl.hint["use_tonguebell"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_ball", {animfunc = "click_bell", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tonguebell", private.use_tonguebell_inv );
cmn.AddSubscriber( "use_tonguebell", private.use_tonguebell_beg, private.room_objname );
cmn.AddSubscriber( "use_tonguebell", private.use_tonguebell_end, private.room_objname );
cmn.AddSubscriber( "use_tonguebell", private.use_tonguebell_logic );
cmn.AddSubscriber( "use_tonguebell_inv", private.use_tonguebell_inv, private.room_objname );
cmn.AddSubscriber( "use_tonguebell_beg", private.use_tonguebell_beg, private.room_objname );
cmn.AddSubscriber( "use_tonguebell_end", private.use_tonguebell_end, private.room_objname );
cmn.AddSubscriber( "use_tonguebell_end", private.use_tonguebell_logic );
--------------------------------------------------------------------------------------------
function public.use_tonguebell( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tonguebell" );
    cmn.CallEventHandler( "use_tonguebell_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_tonguebell") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tonguebell_inv" );
  cmn.CallEventHandler( "use_tonguebell_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_ball", "use_tongue", func_end );
  SoundSfx( "aud_use_tonguebell_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_callbell" ] = { type = "click", use_place = "gfx_glassdoor_clk_callbell_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.clk_callbell_logic = function()
  ObjSet( "spr_glassdoor_bat", { visible = 1, input = 1, active = 1 } )

end;
private.clk_callbell_beg = function()
  ObjDelete( "gfx_glassdoor_clk_callbell_zone" );
end;
private.clk_callbell_end = function()
  if common_impl.ZzCompleteCheck("clk_callbell") then ObjSet( common_impl.hint["clk_callbell"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_ball", {animfunc = "bell_end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_callbell", private.clk_callbell_beg, private.room_objname );
cmn.AddSubscriber( "clk_callbell", private.clk_callbell_end, private.room_objname );
cmn.AddSubscriber( "clk_callbell", private.clk_callbell_logic );
cmn.AddSubscriber( "clk_callbell_beg", private.clk_callbell_beg, private.room_objname );
cmn.AddSubscriber( "clk_callbell_end", private.clk_callbell_end, private.room_objname );
cmn.AddSubscriber( "clk_callbell_end", private.clk_callbell_logic );
--------------------------------------------------------------------------------------------
function public.clk_callbell()

  local func_end = function()
    cmn.SetEventDone( "clk_callbell" );
    cmn.CallEventHandler( "clk_callbell_end" );

    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_callbell") then ld.CloseSubRoom() end;
    public.get_bat()
  end;

  cmn.CallEventHandler( "clk_callbell_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_ball", "click_bell", func_end );
  SoundSfx( "aud_clk_callbell_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bat" ] = { type = "get", get_obj = "spr_glassdoor_bat", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.get_bat_logic = function()
  
end;
private.get_bat_inv = function()
  interface.InventoryItemAdd("inv_bat","spr_glassdoor_bat");
end;
private.get_bat_beg = function()
  ObjDelete("gfx_glassdoor_bat")
end;
private.get_bat_end = function()
  if common_impl.ZzCompleteCheck("get_bat") then ObjSet( common_impl.hint["get_bat"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bat", private.get_bat_inv );
cmn.AddSubscriber( "get_bat", private.get_bat_beg, private.room_objname );
cmn.AddSubscriber( "get_bat", private.get_bat_end, private.room_objname );
cmn.AddSubscriber( "get_bat", private.get_bat_logic );
--------------------------------------------------------------------
function public.get_bat()
  cmn.SetEventDone( "get_bat" );
  cmn.CallEventHandler( "get_bat" );
  if common_impl.ZzCompleteCheck("get_bat") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_slipofpaper" ] = { type = "use", inv_obj = "inv_slipofpaper", use_place = "gfx_glassdoor_slipofpaper_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.use_slipofpaper_logic = function()
  ObjSet( "gfx_glassdoor_corkscrew_glassdoor_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_slipofpaper_inv = function()
  common_impl.ProcessMultiUseAll("slipofpaper", "slipofpaper")
end;
private.use_slipofpaper_beg = function()
  ObjDelete( "gfx_glassdoor_slipofpaper_zone" );
end;
private.use_slipofpaper_end = function()
  if common_impl.ZzCompleteCheck("use_slipofpaper") then ObjSet( common_impl.hint["use_slipofpaper"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_key", {animfunc = "use_corkscrew", frame = 0 } );
  ObjSet( "spr_cellar_slipofpaper2", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_slipofpaper", private.use_slipofpaper_inv );
cmn.AddSubscriber( "use_slipofpaper", private.use_slipofpaper_beg, private.room_objname );
cmn.AddSubscriber( "use_slipofpaper", private.use_slipofpaper_end, private.room_objname );
cmn.AddSubscriber( "use_slipofpaper", private.use_slipofpaper_logic );
cmn.AddSubscriber( "use_slipofpaper_inv", private.use_slipofpaper_inv, private.room_objname );
cmn.AddSubscriber( "use_slipofpaper_beg", private.use_slipofpaper_beg, private.room_objname );
cmn.AddSubscriber( "use_slipofpaper_end", private.use_slipofpaper_end, private.room_objname );
cmn.AddSubscriber( "use_slipofpaper_end", private.use_slipofpaper_logic );
--------------------------------------------------------------------------------------------
function public.use_slipofpaper( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_slipofpaper" );
    cmn.CallEventHandler( "use_slipofpaper_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_slipofpaper") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_slipofpaper_inv" );
  cmn.CallEventHandler( "use_slipofpaper_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_key", "use_paper", func_end );
  SoundSfx( "aud_use_slipofpaper_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_corkscrew_glassdoor" ] = { type = "use", inv_obj = "inv_corkscrew", use_place = "gfx_glassdoor_corkscrew_glassdoor_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.use_corkscrew_glassdoor_logic = function()
  ObjSet( "gfx_glassdoor_clk_reslipofpaper_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_corkscrew_glassdoor_inv = function()
  common_impl.ProcessMultiUseAll("corkscrew", "corkscrew_glassdoor")
end;
private.use_corkscrew_glassdoor_beg = function()
  ObjDelete( "gfx_glassdoor_corkscrew_glassdoor_zone" );
end;
private.use_corkscrew_glassdoor_end = function()
  if common_impl.ZzCompleteCheck("use_corkscrew_glassdoor") then ObjSet( common_impl.hint["use_corkscrew_glassdoor"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_key", {animfunc = "use_paper2", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_corkscrew_glassdoor", private.use_corkscrew_glassdoor_inv );
cmn.AddSubscriber( "use_corkscrew_glassdoor", private.use_corkscrew_glassdoor_beg, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_glassdoor", private.use_corkscrew_glassdoor_end, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_glassdoor", private.use_corkscrew_glassdoor_logic );
cmn.AddSubscriber( "use_corkscrew_glassdoor_inv", private.use_corkscrew_glassdoor_inv, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_glassdoor_beg", private.use_corkscrew_glassdoor_beg, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_glassdoor_end", private.use_corkscrew_glassdoor_end, private.room_objname );
cmn.AddSubscriber( "use_corkscrew_glassdoor_end", private.use_corkscrew_glassdoor_logic );
--------------------------------------------------------------------------------------------
function public.use_corkscrew_glassdoor( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_corkscrew_glassdoor" );
    cmn.CallEventHandler( "use_corkscrew_glassdoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_corkscrew_glassdoor") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_corkscrew_glassdoor_inv" );
  cmn.CallEventHandler( "use_corkscrew_glassdoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_key", "use_corkscrew", func_end );
  SoundSfx( "aud_use_corkscrew_glassdoor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_reslipofpaper" ] = { type = "click", use_place = "gfx_glassdoor_clk_reslipofpaper_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.clk_reslipofpaper_logic = function()
  ObjSet( "gfx_glassdoor_clk_keyonkeyhole_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_reslipofpaper_beg = function()
  ObjDelete( "gfx_glassdoor_clk_reslipofpaper_zone" );
end;
private.clk_reslipofpaper_end = function()
  if common_impl.ZzCompleteCheck("clk_reslipofpaper") then ObjSet( common_impl.hint["clk_reslipofpaper"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_key", {animfunc = "use_key", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_reslipofpaper", private.clk_reslipofpaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_reslipofpaper", private.clk_reslipofpaper_end, private.room_objname );
cmn.AddSubscriber( "clk_reslipofpaper", private.clk_reslipofpaper_logic );
cmn.AddSubscriber( "clk_reslipofpaper_beg", private.clk_reslipofpaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_reslipofpaper_end", private.clk_reslipofpaper_end, private.room_objname );
cmn.AddSubscriber( "clk_reslipofpaper_end", private.clk_reslipofpaper_logic );
--------------------------------------------------------------------------------------------
function public.clk_reslipofpaper()

  local func_end = function()
    cmn.SetEventDone( "clk_reslipofpaper" );
    cmn.CallEventHandler( "clk_reslipofpaper_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_reslipofpaper") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_reslipofpaper_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_key", "use_paper2", func_end );
  SoundSfx( "aud_clk_reslipofpaper_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_keyonkeyhole" ] = { type = "click", use_place = "gfx_glassdoor_clk_keyonkeyhole_zone", room = "rm_cellar", zz = "zz_glassdoor", zz_gate = "gzz_cellar_glassdoor" };

private.clk_keyonkeyhole_logic = function()
   ObjSet( "grm_cellar_backyard", { visible = 1, input = 1, active = 1 } )
   if port.isPortable() == 1 then
     port.GrmEventLightOn("grm_cellar_backyard_focus");
   end;
end;
private.clk_keyonkeyhole_beg = function()
  ObjDelete( "gfx_glassdoor_clk_keyonkeyhole_zone" );
end;
private.clk_keyonkeyhole_end = function()
  if common_impl.ZzCompleteCheck("clk_keyonkeyhole") then ObjSet( common_impl.hint["clk_keyonkeyhole"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_glassdoor_anm_key", {animfunc = "use_key", frame = 999 } );
  ObjSet( "anm_cellar_anm_door_to_backyard",{animfunc="door_to_backyard_open", frame=999, playing=0});  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_keyonkeyhole", private.clk_keyonkeyhole_beg, private.room_objname );
cmn.AddSubscriber( "clk_keyonkeyhole", private.clk_keyonkeyhole_end, private.room_objname );
cmn.AddSubscriber( "clk_keyonkeyhole", private.clk_keyonkeyhole_logic );
cmn.AddSubscriber( "clk_keyonkeyhole_beg", private.clk_keyonkeyhole_beg, private.room_objname );
cmn.AddSubscriber( "clk_keyonkeyhole_end", private.clk_keyonkeyhole_end, private.room_objname );
cmn.AddSubscriber( "clk_keyonkeyhole_end", private.clk_keyonkeyhole_logic );
--------------------------------------------------------------------------------------------
function public.clk_keyonkeyhole()

  local func_end = function()
    cmn.SetEventDone( "clk_keyonkeyhole" );
    cmn.CallEventHandler( "clk_keyonkeyhole_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_keyonkeyhole") then ld.CloseSubRoom() end;
  end;

  local f_step = function()
    ld.CloseSubRoom()
     SoundSfx( "aud_open_backyard_cellar" );
     ld.StartTimer( 0.5, function()
        AnimPlay( "anm_cellar_anm_door_to_backyard", "door_to_backyard_open", func_end )    
        end)
  end
  cmn.CallEventHandler( "clk_keyonkeyhole_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_glassdoor_anm_key", "use_key", f_step );
  SoundSfx( "aud_clk_keyonkeyhole_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_storage *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_penknife" ] = { type = "get", get_obj = "spr_storage_penknife", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.get_penknife_logic = function()
  
end;
private.get_penknife_inv = function()
  interface.InventoryItemAdd("inv_penknife","spr_storage_penknife");
end;
private.get_penknife_beg = function()
  ObjDelete("gfx_storage_penknife")
end;
private.get_penknife_end = function()
  if common_impl.ZzCompleteCheck("get_penknife") then ObjSet( common_impl.hint["get_penknife"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_storage_penknife_sh");
end;

cmn.AddSubscriber( "get_penknife", private.get_penknife_inv );
cmn.AddSubscriber( "get_penknife", private.get_penknife_beg, private.room_objname );
cmn.AddSubscriber( "get_penknife", private.get_penknife_end, private.room_objname );
cmn.AddSubscriber( "get_penknife", private.get_penknife_logic );
--------------------------------------------------------------------
function public.get_penknife()
  cmn.SetEventDone( "get_penknife" );
  cmn.CallEventHandler( "get_penknife" );
  if common_impl.ZzCompleteCheck("get_penknife") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_spatula_zone() 
  common_impl.ShowBbt( 'need_spatula' )
  --ld.Lock(1)
  --SoundSfx( "" );
  --ld.AnimPlay("anm_storage_anm_cork","corkscrew_idle",function()ld.Lock(0)end)
end; 


common_impl.hint[ "use_spatula" ] = { type = "use", inv_obj = "inv_spatula", use_place = "gfx_storage_spatula_zone", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.use_spatula_logic = function()
  ObjSet( "spr_storage_corkscrew", {visible = 1, input = 1  } )
  ObjSet( "spr_storage_owl", {input = 1 } )

end;
private.use_spatula_inv = function()
  common_impl.ProcessMultiUseAll("spatula", "spatula")
end;
private.use_spatula_beg = function()
  ObjDelete( "gfx_storage_spatula_zone" );
end;
private.use_spatula_end = function()
  if common_impl.ZzCompleteCheck("use_spatula") then ObjSet( common_impl.hint["use_spatula"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_storage_anm_cork");
  ObjSet( "gfx_storage_owl", {visible = 1} );
  ObjSet( "spr_storage_corkscrew_sh", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_spatula", private.use_spatula_inv );
cmn.AddSubscriber( "use_spatula", private.use_spatula_beg, private.room_objname );
cmn.AddSubscriber( "use_spatula", private.use_spatula_end, private.room_objname );
cmn.AddSubscriber( "use_spatula", private.use_spatula_logic );
cmn.AddSubscriber( "use_spatula_inv", private.use_spatula_inv, private.room_objname );
cmn.AddSubscriber( "use_spatula_beg", private.use_spatula_beg, private.room_objname );
cmn.AddSubscriber( "use_spatula_end", private.use_spatula_end, private.room_objname );
cmn.AddSubscriber( "use_spatula_end", private.use_spatula_logic );
--------------------------------------------------------------------------------------------
function public.use_spatula( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_spatula" );
    cmn.CallEventHandler( "use_spatula_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_spatula") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_spatula_inv" );
  cmn.CallEventHandler( "use_spatula_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_storage_anm_cork", "use_spatula", func_end );
  SoundSfx( "aud_use_spatula_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_corkscrew" ] = { type = "get", get_obj = "spr_storage_corkscrew", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.get_corkscrew_logic = function()
  
end;
private.get_corkscrew_inv = function()
  interface.InventoryItemAdd("inv_corkscrew","spr_storage_corkscrew");
end;
private.get_corkscrew_beg = function()
  ObjDelete("gfx_storage_corkscrew")
end;
private.get_corkscrew_end = function()
  if common_impl.ZzCompleteCheck("get_corkscrew") then ObjSet( common_impl.hint["get_corkscrew"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_storage_corkscrew_sh");
end;

cmn.AddSubscriber( "get_corkscrew", private.get_corkscrew_inv );
cmn.AddSubscriber( "get_corkscrew", private.get_corkscrew_beg, private.room_objname );
cmn.AddSubscriber( "get_corkscrew", private.get_corkscrew_end, private.room_objname );
cmn.AddSubscriber( "get_corkscrew", private.get_corkscrew_logic );
--------------------------------------------------------------------
function public.get_corkscrew()
  cmn.SetEventDone( "get_corkscrew" );
  cmn.CallEventHandler( "get_corkscrew" );
  if common_impl.ZzCompleteCheck("get_corkscrew") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_owl" ] = { type = "get", get_obj = "spr_storage_owl", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.get_owl_logic = function()
  
end;
private.get_owl_inv = function()
  interface.InventoryItemAdd("inv_owl","spr_storage_owl");
end;
private.get_owl_beg = function()
  ObjDelete("gfx_storage_owl")
end;
private.get_owl_end = function()
  if common_impl.ZzCompleteCheck("get_owl") then ObjSet( common_impl.hint["get_owl"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_owl", private.get_owl_inv );
cmn.AddSubscriber( "get_owl", private.get_owl_beg, private.room_objname );
cmn.AddSubscriber( "get_owl", private.get_owl_end, private.room_objname );
cmn.AddSubscriber( "get_owl", private.get_owl_logic );
--------------------------------------------------------------------
function public.get_owl()
  cmn.SetEventDone( "get_owl" );
  cmn.CallEventHandler( "get_owl" );
  if common_impl.ZzCompleteCheck("get_owl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_doorstorage_zone() 
  common_impl.ShowBbt( 'need_buttonstorage' );
  ld.Lock(1)
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay("anm_storage_anm_door","door_idle2",function()ld.Lock(0)end)
end;
  
common_impl.hint[ "clk_doorstorage" ] = { type = "click", use_place = "gfx_storage_doorstorage_zone", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.clk_doorstorage_logic = function()
  ObjSet( "gfx_storage_buttonstorage_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_doorstorage_beg = function()
  ObjDelete( "gfx_storage_doorstorage_zone" );
end;
private.clk_doorstorage_end = function()
  if common_impl.ZzCompleteCheck("clk_doorstorage") then ObjSet( common_impl.hint["clk_doorstorage"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_storage_anm_door", {animfunc = "door_idle2", frame = 0 } );
  ObjDelete("spr_cellar_button_broken");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doorstorage", private.clk_doorstorage_beg, private.room_objname );
cmn.AddSubscriber( "clk_doorstorage", private.clk_doorstorage_end, private.room_objname );
cmn.AddSubscriber( "clk_doorstorage", private.clk_doorstorage_logic );
cmn.AddSubscriber( "clk_doorstorage_beg", private.clk_doorstorage_beg, private.room_objname );
cmn.AddSubscriber( "clk_doorstorage_end", private.clk_doorstorage_end, private.room_objname );
cmn.AddSubscriber( "clk_doorstorage_end", private.clk_doorstorage_logic );
--------------------------------------------------------------------------------------------
function public.clk_doorstorage()

  local func_end = function()
    cmn.SetEventDone( "clk_doorstorage" );
    cmn.CallEventHandler( "clk_doorstorage_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_doorstorage") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_doorstorage_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_storage_anm_door", "door_idle", func_end );
  SoundSfx( "aud_touch_spring_cellar" )
  --func_end()

end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_buttonstorage" ] = { type = "use", inv_obj = "inv_buttonstorage", use_place = "gfx_storage_buttonstorage_zone", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.use_buttonstorage_logic = function()
  ObjSet( "spr_storage_feather1", { input = 1 } );
  ObjSet( "spr_storage_note", { input = 1 } );

end;
private.use_buttonstorage_inv = function()
  common_impl.ProcessMultiUseAll("buttonstorage", "buttonstorage")
end;
private.use_buttonstorage_beg = function()
  ObjDelete( "gfx_storage_buttonstorage_zone" );
end;
private.use_buttonstorage_end = function()
  if common_impl.ZzCompleteCheck("use_buttonstorage") then ObjSet( common_impl.hint["use_buttonstorage"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_storage_anm_door", {animfunc = "use_button", frame = 999 } );
  ObjDelete("spr_cellar_door_close");
  ObjSet( "spr_cellar_door_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_buttonstorage", private.use_buttonstorage_inv );
cmn.AddSubscriber( "use_buttonstorage", private.use_buttonstorage_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonstorage", private.use_buttonstorage_end, private.room_objname );
cmn.AddSubscriber( "use_buttonstorage", private.use_buttonstorage_logic );
cmn.AddSubscriber( "use_buttonstorage_inv", private.use_buttonstorage_inv, private.room_objname );
cmn.AddSubscriber( "use_buttonstorage_beg", private.use_buttonstorage_beg, private.room_objname );
cmn.AddSubscriber( "use_buttonstorage_end", private.use_buttonstorage_end, private.room_objname );
cmn.AddSubscriber( "use_buttonstorage_end", private.use_buttonstorage_logic );
--------------------------------------------------------------------------------------------
function public.use_buttonstorage( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_buttonstorage" );
    cmn.CallEventHandler( "use_buttonstorage_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_buttonstorage") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_buttonstorage_inv" );
  cmn.CallEventHandler( "use_buttonstorage_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_storage_anm_door", "use_button", func_end );
  SoundSfx( "aud_use_buttonstorage_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feather1" ] = { type = "get", get_obj = "spr_storage_feather1", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.get_feather1_logic = function()
  
end;
private.get_feather1_inv = function()
  interface.InventoryItemAdd("inv_feather1","spr_storage_feather1");
end;
private.get_feather1_beg = function()
  ObjDelete("gfx_storage_feather1")
end;
private.get_feather1_end = function()
  if common_impl.ZzCompleteCheck("get_feather1") then ObjSet( common_impl.hint["get_feather1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_storage_feather1_sh");
  ObjDelete("spr_cellar_feather1");
end;

cmn.AddSubscriber( "get_feather1", private.get_feather1_inv );
cmn.AddSubscriber( "get_feather1", private.get_feather1_beg, private.room_objname );
cmn.AddSubscriber( "get_feather1", private.get_feather1_end, private.room_objname );
cmn.AddSubscriber( "get_feather1", private.get_feather1_logic );
--------------------------------------------------------------------
function public.get_feather1()
  cmn.SetEventDone( "get_feather1" );
  cmn.CallEventHandler( "get_feather1" );
  if common_impl.ZzCompleteCheck("get_feather1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.clk_idle_sunflower_zone() 
  common_impl.ShowBbt( 'need_sunflower' );
  ld.Lock(1)
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay("anm_storage_anm_sunflower","cap_idle",function()ld.Lock(0)end)
end;
  
common_impl.hint[ "use_sunflower" ] = { type = "use", inv_obj = "inv_sunflower", use_place = "gfx_storage_sunflower_zone", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.use_sunflower_logic = function()
  ObjSet( "spr_storage_letterr", {  input = 1} )

end;
private.use_sunflower_inv = function()
  common_impl.ProcessMultiUseAll("sunflower", "sunflower")
end;
private.use_sunflower_beg = function()
  ObjDelete( "gfx_storage_sunflower_zone" );
end;
private.use_sunflower_end = function()
  if common_impl.ZzCompleteCheck("use_sunflower") then ObjSet( common_impl.hint["use_sunflower"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_storage_anm_sunflower", {animfunc = "use_sunflower", frame = 999 } );
  ObjDelete("spr_cellar_cap");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sunflower", private.use_sunflower_inv );
cmn.AddSubscriber( "use_sunflower", private.use_sunflower_beg, private.room_objname );
cmn.AddSubscriber( "use_sunflower", private.use_sunflower_end, private.room_objname );
cmn.AddSubscriber( "use_sunflower", private.use_sunflower_logic );
cmn.AddSubscriber( "use_sunflower_inv", private.use_sunflower_inv, private.room_objname );
cmn.AddSubscriber( "use_sunflower_beg", private.use_sunflower_beg, private.room_objname );
cmn.AddSubscriber( "use_sunflower_end", private.use_sunflower_end, private.room_objname );
cmn.AddSubscriber( "use_sunflower_end", private.use_sunflower_logic );
--------------------------------------------------------------------------------------------
function public.use_sunflower( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sunflower" );
    cmn.CallEventHandler( "use_sunflower_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sunflower") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sunflower_inv" );
  cmn.CallEventHandler( "use_sunflower_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_storage_anm_sunflower", "use_sunflower", func_end );
  SoundSfx( "aud_use_sunflower_cellar" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_letterr" ] = { type = "get", get_obj = "spr_storage_letterr", room = "rm_cellar", zz = "zz_storage", zz_gate = "gzz_cellar_storage" };

private.get_letterr_logic = function()
  
end;
private.get_letterr_inv = function()
  interface.InventoryItemAdd("inv_letterr","spr_storage_letterr");
end;
private.get_letterr_beg = function()
  ObjDelete("gfx_storage_letterr")
end;
private.get_letterr_end = function()
  if common_impl.ZzCompleteCheck("get_letterr") then ObjSet( common_impl.hint["get_letterr"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_storage_letterr_sh");
  ObjDelete("spr_cellar_letterr");
end;

cmn.AddSubscriber( "get_letterr", private.get_letterr_inv );
cmn.AddSubscriber( "get_letterr", private.get_letterr_beg, private.room_objname );
cmn.AddSubscriber( "get_letterr", private.get_letterr_end, private.room_objname );
cmn.AddSubscriber( "get_letterr", private.get_letterr_logic );
--------------------------------------------------------------------
function public.get_letterr()
  cmn.SetEventDone( "get_letterr" );
  cmn.CallEventHandler( "get_letterr" );
  if common_impl.ZzCompleteCheck("get_letterr") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_prison_for_cellar = function()
    if ld.CheckRequirements( {"win_prison"} ) then
      ObjSet( "gmg_cellar_prison", {input = 0, visible = 0} );
      ObjSet( "anm_cellar_anm_prison", {animfunc = "prison_open", frame = 999 } );
      ObjSet( "anim_cellar_anim_lekar1", {animfunc = "default", frame = 0, playing = 1, alp = 1} );
      ObjDelete("anm_cellar_anm_man");
      ObjSet("gfx_cellar_portrait_zone",{visible = 1, input = 1, active = 1})
      
    end
  end;
  cmn.AddSubscriber("win_prison", win_prison_for_cellar, private.room_objname )
  local win_winestore_for_cellar = function()
    if ld.CheckRequirements( {"win_winestore"} ) then
      ObjSet( "gho_cellar_winestore", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_winestore", win_winestore_for_cellar, private.room_objname )
  
  
  
  private.clk_outro2_forcellar = function()
    ObjDelete("anim_cellar_anim_lekar1");
  end;
  
  cmn.AddSubscriber( "clk_outro2_end", private.clk_outro2_forcellar);
  cmn.AddSubscriber( "clk_outro2", private.clk_outro2_forcellar);
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_cellar();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cellar_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_storage" );
  function zz_storage.Open()
  end;
  function zz_storage.PreOpen()
  end;
  function zz_storage.PreClose()
  end;
  function zz_storage.Close()
  end;

  subroom.Define( "zz_glassdoor" );
  function zz_glassdoor.Open()
  end;
  function zz_glassdoor.PreOpen()
  end;
  function zz_glassdoor.PreClose()
  end;
  function zz_glassdoor.Close()
    
  end;

  subroom.Define( "zz_warehouse" );
  function zz_warehouse.Open()
  end;
  function zz_warehouse.PreOpen()
  end;
  function zz_warehouse.PreClose()
  end;
  function zz_warehouse.Close()
    
  end;

  subroom.Define( "zz_grille" );
  function zz_grille.Open()
  end;
  function zz_grille.PreOpen()
  end;
  function zz_grille.PreClose()
    if cmn.IsEventDone("clk_slipofpaper_open") and not cmn.IsEventDone("clk_slipofpaper_close") then 
      public.clk_slipofpaper_close();
  end;
  end;
  function zz_grille.Close()
  end;
  
end;
--*********************************************************************************************************************