-- name=rm_grove
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_grove";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_grove()
  if not ( cmn.IsEventDone( "opn_grove" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_grove" );
      cmn.CallEventHandler( "opn_grove" )
      ld.ShowBbt( "opn_grove" );
      SoundTheme( "aud_danger_moment1_mus" );
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_grove = function() end;
local opn_grove_logic = function() end;
cmn.AddSubscriber( "opn_grove", opn_grove_logic )
cmn.AddSubscriber( "opn_grove", opn_grove, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_caveentrance *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_animbeast" ] = { type = "click", use_place = "gfx_caveentrance_clk_animbeast_zone", room = "rm_grove", zz = "zz_caveentrance", zz_gate = "gzz_grove_caveentrance" };

private.clk_animbeast_logic = function()
  ObjSet( "gfx_caveentrance_hairpin_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_caveentrance_flint_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_animbeast_beg = function()
  ObjDelete( "gfx_caveentrance_clk_animbeast_zone" );
end;
private.clk_animbeast_end = function()
  if common_impl.ZzCompleteCheck("clk_animbeast") then ObjSet( common_impl.hint["clk_animbeast"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_caveentrance_anm_eye");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_animbeast", private.clk_animbeast_beg, private.room_objname );
cmn.AddSubscriber( "clk_animbeast", private.clk_animbeast_end, private.room_objname );
cmn.AddSubscriber( "clk_animbeast", private.clk_animbeast_logic );
cmn.AddSubscriber( "clk_animbeast_beg", private.clk_animbeast_beg, private.room_objname );
cmn.AddSubscriber( "clk_animbeast_end", private.clk_animbeast_end, private.room_objname );
cmn.AddSubscriber( "clk_animbeast_end", private.clk_animbeast_logic );
--------------------------------------------------------------------------------------------
function public.clk_animbeast()

  local func_end = function()
    cmn.SetEventDone( "clk_animbeast" );
    cmn.CallEventHandler( "clk_animbeast_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_animbeast") then ld.CloseSubRoom() end;
    ld.ShowBbt("after_anim_beast");
    SoundTheme( "aud_danger_moment3_mus" );
  end;

  cmn.CallEventHandler( "clk_animbeast_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_caveentrance_anm_eye", "eye_beast", func_end );
  SoundSfx( "aud_clk_animbeast_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_hairpin_zone_clk()  --rm_grove.use_hairpin_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_hairpin' );
  end 
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_caveentrance_anm", "cap_idle", func_end )
end;  




common_impl.hint[ "use_hairpin" ] = { type = "use", inv_obj = "inv_hairpin", use_place = "gfx_caveentrance_hairpin_zone", room = "rm_grove", zz = "zz_caveentrance", zz_gate = "gzz_grove_caveentrance" };

private.use_hairpin_logic = function()
  ObjSet( "spr_caveentrance_beak", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_caveentrance_beak", {visible = 1} );
end;
private.use_hairpin_inv = function()
  common_impl.ProcessMultiUseAll("hairpin", "hairpin")
end;
private.use_hairpin_beg = function()
  ObjDelete( "gfx_caveentrance_hairpin_zone" );
end;
private.use_hairpin_end = function()
  if common_impl.ZzCompleteCheck("use_hairpin") then ObjSet( common_impl.hint["use_hairpin"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_caveentrance_anm", {animfunc = "use_flint", frame = 0 } );
  ObjDelete("spr_grove_cap_close");
  ObjSet( "spr_grove_cap_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hairpin", private.use_hairpin_inv );
cmn.AddSubscriber( "use_hairpin", private.use_hairpin_beg, private.room_objname );
cmn.AddSubscriber( "use_hairpin", private.use_hairpin_end, private.room_objname );
cmn.AddSubscriber( "use_hairpin", private.use_hairpin_logic );
cmn.AddSubscriber( "use_hairpin_inv", private.use_hairpin_inv, private.room_objname );
cmn.AddSubscriber( "use_hairpin_beg", private.use_hairpin_beg, private.room_objname );
cmn.AddSubscriber( "use_hairpin_end", private.use_hairpin_end, private.room_objname );
cmn.AddSubscriber( "use_hairpin_end", private.use_hairpin_logic );
--------------------------------------------------------------------------------------------
function public.use_hairpin( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hairpin" );
    cmn.CallEventHandler( "use_hairpin_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hairpin") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hairpin_inv" );
  cmn.CallEventHandler( "use_hairpin_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_caveentrance_anm", "use_pin", func_end );
  SoundSfx( "aud_use_hairpin_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_beak" ] = { type = "get", get_obj = "spr_caveentrance_beak", room = "rm_grove", zz = "zz_caveentrance", zz_gate = "gzz_grove_caveentrance" };

private.get_beak_logic = function()
  ObjSet( "gfx_caveentrance_flint_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_beak_inv = function()
  interface.InventoryItemAdd("inv_beak","spr_caveentrance_beak");
end;
private.get_beak_beg = function()
  ObjDelete("gfx_caveentrance_beak")
end;
private.get_beak_end = function()
  if common_impl.ZzCompleteCheck("get_beak") then ObjSet( common_impl.hint["get_beak"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_caveentrance_beak_sh");
  ObjDelete("spr_grove_beak2");
end;

cmn.AddSubscriber( "get_beak", private.get_beak_inv );
cmn.AddSubscriber( "get_beak", private.get_beak_beg, private.room_objname );
cmn.AddSubscriber( "get_beak", private.get_beak_end, private.room_objname );
cmn.AddSubscriber( "get_beak", private.get_beak_logic );
--------------------------------------------------------------------
function public.get_beak()
  cmn.SetEventDone( "get_beak" );
  cmn.CallEventHandler( "get_beak" );
  if common_impl.ZzCompleteCheck("get_beak") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_flint" ] = { type = "use", inv_obj = "inv_flint", use_place = "gfx_caveentrance_flint_zone", room = "rm_grove", zz = "zz_caveentrance", zz_gate = "gzz_grove_caveentrance" };

private.use_flint_logic = function()
  ObjSet( "grm_grove_cave", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_grove_cave_focus");
  end;
end;
private.use_flint_inv = function()
  common_impl.ProcessMultiUseAll("flint", "flint")
end;
private.use_flint_beg = function()
  ObjDelete( "gfx_caveentrance_flint_zone" );
end;
private.use_flint_end = function()
  if common_impl.ZzCompleteCheck("use_flint") then ObjSet( common_impl.hint["use_flint"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_caveentrance_anm", {animfunc = "use_flint", frame = 999 } );
  ObjSet( "anm_grove_anm", {playing = 1, visible = 1 } );
  ObjDelete("obj_grove_caveentrance_tr_root");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_flint", private.use_flint_inv );
cmn.AddSubscriber( "use_flint", private.use_flint_beg, private.room_objname );
cmn.AddSubscriber( "use_flint", private.use_flint_end, private.room_objname );
cmn.AddSubscriber( "use_flint", private.use_flint_logic );
cmn.AddSubscriber( "use_flint_inv", private.use_flint_inv, private.room_objname );
cmn.AddSubscriber( "use_flint_beg", private.use_flint_beg, private.room_objname );
cmn.AddSubscriber( "use_flint_end", private.use_flint_end, private.room_objname );
cmn.AddSubscriber( "use_flint_end", private.use_flint_logic );
--------------------------------------------------------------------------------------------
function public.use_flint( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_flint" );
    cmn.CallEventHandler( "use_flint_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_flint") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_flint_inv" );
  cmn.CallEventHandler( "use_flint_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_caveentrance_anm", "use_flint", func_end );
  SoundSfx( "aud_use_flint_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_inhut *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hook_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_hook' );
  end
  
  ld.Lock(1);
  SoundSfx( "aud_touch_bell_grove" );
  ld.AnimPlay( "anm_inhut_anm_hook", "bell_idle", func_end )
end;  


common_impl.hint[ "use_hook" ] = { type = "use", inv_obj = "inv_hook", use_place = "gfx_inhut_hook_zone", room = "rm_grove", zz = "zz_inhut", zz_gate = "gzz_grove_inhut" };

private.use_hook_logic = function()
  ObjSet( "spr_inhut_fringe", { visible = 1, input = 1, active = 1 } )

end;
private.use_hook_inv = function()
  common_impl.ProcessMultiUseAll("hook", "hook")
end;
private.use_hook_beg = function()
  ObjDelete( "gfx_inhut_hook_zone" );
end;
private.use_hook_end = function()
  if common_impl.ZzCompleteCheck("use_hook") then ObjSet( common_impl.hint["use_hook"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_inhut_anm_hook", {animfunc = "use_hook", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hook", private.use_hook_inv );
cmn.AddSubscriber( "use_hook", private.use_hook_beg, private.room_objname );
cmn.AddSubscriber( "use_hook", private.use_hook_end, private.room_objname );
cmn.AddSubscriber( "use_hook", private.use_hook_logic );
cmn.AddSubscriber( "use_hook_inv", private.use_hook_inv, private.room_objname );
cmn.AddSubscriber( "use_hook_beg", private.use_hook_beg, private.room_objname );
cmn.AddSubscriber( "use_hook_end", private.use_hook_end, private.room_objname );
cmn.AddSubscriber( "use_hook_end", private.use_hook_logic );
--------------------------------------------------------------------------------------------
function public.use_hook( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hook" );
    cmn.CallEventHandler( "use_hook_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hook") then ld.CloseSubRoom() end;
    public.get_fringe();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hook_inv" );
  cmn.CallEventHandler( "use_hook_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_inhut_anm_hook", "use_hook", func_end );
  SoundSfx( "aud_use_hook_grove" )
  --func_end()

end;
------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fringe" ] = { type = "get", get_obj = "spr_inhut_fringe", room = "rm_grove", zz = "zz_inhut", zz_gate = "gzz_grove_inhut" };

private.get_fringe_logic = function()
  
end;
private.get_fringe_inv = function()
  interface.InventoryItemAdd("inv_fringe","spr_inhut_fringe");
end;
private.get_fringe_beg = function()
  ObjDelete("gfx_inhut_fringe")
end;
private.get_fringe_end = function()
  if common_impl.ZzCompleteCheck("get_fringe") then ObjSet( common_impl.hint["get_fringe"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fringe", private.get_fringe_inv );
cmn.AddSubscriber( "get_fringe", private.get_fringe_beg, private.room_objname );
cmn.AddSubscriber( "get_fringe", private.get_fringe_end, private.room_objname );
cmn.AddSubscriber( "get_fringe", private.get_fringe_logic );
--------------------------------------------------------------------
function public.get_fringe()
  ObjSet( "spr_inhut_fringe", {visible = 1} );
  cmn.SetEventDone( "get_fringe" );
  cmn.CallEventHandler( "get_fringe" );
  if common_impl.ZzCompleteCheck("get_fringe") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_feathermg" ] = { type = "use", inv_obj = "inv_feathermg", use_place = "gfx_inhut_feathermg_zone", room = "rm_grove", zz = "zz_inhut", zz_gate = "gzz_grove_inhut" };

private.use_feathermg_logic = function()
  ObjSet( "gmg_grove_hutdoor", { visible = 1, input = 1, active = 1 } )

end;
private.use_feathermg_inv = function()
  common_impl.ProcessMultiUseAll("feathermg", "feathermg")
end;
private.use_feathermg_beg = function()
  ObjDelete( "gfx_inhut_feathermg_zone" );
end;
private.use_feathermg_end = function()
  if common_impl.ZzCompleteCheck("use_feathermg") then ObjSet( common_impl.hint["use_feathermg"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_inhut_anm_feather");
  ObjDelete("spr_grove_mmg_door_cap");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_feathermg", private.use_feathermg_inv );
cmn.AddSubscriber( "use_feathermg", private.use_feathermg_beg, private.room_objname );
cmn.AddSubscriber( "use_feathermg", private.use_feathermg_end, private.room_objname );
cmn.AddSubscriber( "use_feathermg", private.use_feathermg_logic );
cmn.AddSubscriber( "use_feathermg_inv", private.use_feathermg_inv, private.room_objname );
cmn.AddSubscriber( "use_feathermg_beg", private.use_feathermg_beg, private.room_objname );
cmn.AddSubscriber( "use_feathermg_end", private.use_feathermg_end, private.room_objname );
cmn.AddSubscriber( "use_feathermg_end", private.use_feathermg_logic );
--------------------------------------------------------------------------------------------
function public.use_feathermg( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_feathermg" );
    cmn.CallEventHandler( "use_feathermg_end" );
    --common_impl.Lock(0);
    -- if common_impl.ZzCompleteCheck("use_feathermg") then ld.CloseSubRoom() end;
    ld.CloseSubRoom();
    ld.StartTimer( 0.3, function() common_impl.Lock(0); common.GotoRoom( "mg_hutdoor" ); end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_feathermg_inv" );
  cmn.CallEventHandler( "use_feathermg_beg" );
  common_impl.Lock(1);

  local func_preend = function()
    ld.AnimPlay( "anm_inhut_anm_feather", "open_mmg", func_end )
  end;  
  
  
  ld.AnimPlay( "anm_inhut_anm_feather", "use_feather2", func_preend );
  SoundSfx( "aud_use_feathermg_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pond *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_fringe_zone_clk() --rm_grove.use_fringe_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_fringe' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_weed" );
  ld.AnimPlay( "anm_pond_anm", "web_idle", func_end )
end;  




common_impl.hint[ "use_fringe" ] = { type = "use", inv_obj = "inv_fringe", use_place = "gfx_pond_fringe_zone", room = "rm_grove", zz = "zz_pond", zz_gate = "gzz_grove_pond" };

private.use_fringe_logic = function()
  ObjSet( "spr_pond_feathermg1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pond_eyepupil", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_pond_emptyflask_zone", {input = 1, visible = 1, active = 1} );
  
  ObjSet( "gfx_pond_feathermg1", {visible = 1} );
  ObjSet( "gfx_pond_eyepupil", {visible = 1} );
end;
private.use_fringe_inv = function()
  common_impl.ProcessMultiUseAll("fringe", "fringe")
end;
private.use_fringe_beg = function()
  ObjDelete( "gfx_pond_fringe_zone" );
end;
private.use_fringe_end = function()
  if common_impl.ZzCompleteCheck("use_fringe") then ObjSet( common_impl.hint["use_fringe"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_pond_anm", {animfunc = "use_bottle", frame = 0 } );
  ObjDelete("spr_grove_web");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fringe", private.use_fringe_inv );
cmn.AddSubscriber( "use_fringe", private.use_fringe_beg, private.room_objname );
cmn.AddSubscriber( "use_fringe", private.use_fringe_end, private.room_objname );
cmn.AddSubscriber( "use_fringe", private.use_fringe_logic );
cmn.AddSubscriber( "use_fringe_inv", private.use_fringe_inv, private.room_objname );
cmn.AddSubscriber( "use_fringe_beg", private.use_fringe_beg, private.room_objname );
cmn.AddSubscriber( "use_fringe_end", private.use_fringe_end, private.room_objname );
cmn.AddSubscriber( "use_fringe_end", private.use_fringe_logic );
--------------------------------------------------------------------------------------------
function public.use_fringe( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fringe" );
    cmn.CallEventHandler( "use_fringe_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_fringe") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fringe_inv" );
  cmn.CallEventHandler( "use_fringe_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pond_anm", "use_fringe", func_end );
  SoundSfx( "aud_use_fringe_grove" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feathermg1" ] = { type = "get", get_obj = "spr_pond_feathermg1", room = "rm_grove", zz = "zz_pond", zz_gate = "gzz_grove_pond" };

private.get_feathermg1_logic = function()
  
end;
private.get_feathermg1_inv = function()
  interface.InventoryItemAdd("inv_feathermg","spr_pond_feathermg1",function() level_inv.ProcessGetFeathermgAll( "get_feathermg1" ) end);
end;
private.get_feathermg1_beg = function()
  ObjDelete("gfx_pond_feathermg1")
end;
private.get_feathermg1_end = function()
  if common_impl.ZzCompleteCheck("get_feathermg1") then ObjSet( common_impl.hint["get_feathermg1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pond_feathermg1_shad");
end;

cmn.AddSubscriber( "get_feathermg1", private.get_feathermg1_inv );
cmn.AddSubscriber( "get_feathermg1", private.get_feathermg1_beg, private.room_objname );
cmn.AddSubscriber( "get_feathermg1", private.get_feathermg1_end, private.room_objname );
cmn.AddSubscriber( "get_feathermg1", private.get_feathermg1_logic );
--------------------------------------------------------------------
function public.get_feathermg1()
  cmn.SetEventDone( "get_feathermg1" );
  cmn.CallEventHandler( "get_feathermg1" );
  if common_impl.ZzCompleteCheck("get_feathermg1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_eyepupil" ] = { type = "get", get_obj = "spr_pond_eyepupil", room = "rm_grove", zz = "zz_pond", zz_gate = "gzz_grove_pond" };

private.get_eyepupil_logic = function()
  
end;
private.get_eyepupil_inv = function()
  interface.InventoryItemAdd("inv_eyepupil","spr_pond_eyepupil");
end;
private.get_eyepupil_beg = function()
  ObjDelete("gfx_pond_eyepupil")
end;
private.get_eyepupil_end = function()
  if common_impl.ZzCompleteCheck("get_eyepupil") then ObjSet( common_impl.hint["get_eyepupil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_pond_eyepupil_sh")
end;

cmn.AddSubscriber( "get_eyepupil", private.get_eyepupil_inv );
cmn.AddSubscriber( "get_eyepupil", private.get_eyepupil_beg, private.room_objname );
cmn.AddSubscriber( "get_eyepupil", private.get_eyepupil_end, private.room_objname );
cmn.AddSubscriber( "get_eyepupil", private.get_eyepupil_logic );
--------------------------------------------------------------------
function public.get_eyepupil()
  cmn.SetEventDone( "get_eyepupil" );
  cmn.CallEventHandler( "get_eyepupil" );
  if common_impl.ZzCompleteCheck("get_eyepupil") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_emptyflask" ] = { type = "use", inv_obj = "inv_emptyflask", use_place = "gfx_pond_emptyflask_zone", room = "rm_grove", zz = "zz_pond", zz_gate = "gzz_grove_pond" };

private.use_emptyflask_logic = function()
  ObjSet( "spr_pond_waterflask", { visible = 1, input = 1, active = 1 } )

end;
private.use_emptyflask_inv = function()
  common_impl.ProcessMultiUseAll("emptyflask", "emptyflask")
end;
private.use_emptyflask_beg = function()
  ObjDelete( "gfx_pond_emptyflask_zone" );
end;
private.use_emptyflask_end = function()
  if common_impl.ZzCompleteCheck("use_emptyflask") then ObjSet( common_impl.hint["use_emptyflask"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_pond_anm");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_emptyflask", private.use_emptyflask_inv );
cmn.AddSubscriber( "use_emptyflask", private.use_emptyflask_beg, private.room_objname );
cmn.AddSubscriber( "use_emptyflask", private.use_emptyflask_end, private.room_objname );
cmn.AddSubscriber( "use_emptyflask", private.use_emptyflask_logic );
cmn.AddSubscriber( "use_emptyflask_inv", private.use_emptyflask_inv, private.room_objname );
cmn.AddSubscriber( "use_emptyflask_beg", private.use_emptyflask_beg, private.room_objname );
cmn.AddSubscriber( "use_emptyflask_end", private.use_emptyflask_end, private.room_objname );
cmn.AddSubscriber( "use_emptyflask_end", private.use_emptyflask_logic );
--------------------------------------------------------------------------------------------
function public.use_emptyflask( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_emptyflask" );
    cmn.CallEventHandler( "use_emptyflask_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_emptyflask") then ld.CloseSubRoom() end;
    public.get_waterflask();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_emptyflask_inv" );
  cmn.CallEventHandler( "use_emptyflask_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pond_anm", "use_bottle", func_end );
  SoundSfx( "aud_use_emptyflask_grove" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_waterflask" ] = { type = "get", get_obj = "spr_pond_waterflask", room = "rm_grove", zz = "zz_pond", zz_gate = "gzz_grove_pond" };

private.get_waterflask_logic = function()
  
end;
private.get_waterflask_inv = function()
  interface.InventoryItemAdd("inv_waterflask","spr_pond_waterflask");
end;
private.get_waterflask_beg = function()
  ObjDelete("gfx_pond_waterflask")
end;
private.get_waterflask_end = function()
  if common_impl.ZzCompleteCheck("get_waterflask") then ObjSet( common_impl.hint["get_waterflask"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_waterflask", private.get_waterflask_inv );
cmn.AddSubscriber( "get_waterflask", private.get_waterflask_beg, private.room_objname );
cmn.AddSubscriber( "get_waterflask", private.get_waterflask_end, private.room_objname );
cmn.AddSubscriber( "get_waterflask", private.get_waterflask_logic );
--------------------------------------------------------------------
function public.get_waterflask()
  cmn.SetEventDone( "get_waterflask" );
  cmn.CallEventHandler( "get_waterflask" );
  if common_impl.ZzCompleteCheck("get_waterflask") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_totem *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_eyepupil_zone_clk()  --rm_grove.use_eyepupil_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_eyepupil' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_very_small_metal" );
  ld.AnimPlay( "anm_totem_anm_eye", "hairpin_idle", func_end )
  
end;  

common_impl.hint[ "use_eyepupil" ] = { type = "use", inv_obj = "inv_eyepupil", use_place = "gfx_totem_eyepupil_zone", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.use_eyepupil_logic = function()
  -- ObjSet( "gfx_totem_clk_eyetotem_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_totem_hairpin", { visible = 0, input = 1, active = 1 } );
  ObjSet( "gfx_totem_hairpin", { active = 1, visible = 1} );
end;
private.use_eyepupil_inv = function()
  common_impl.ProcessMultiUseAll("eyepupil", "eyepupil")
end;
private.use_eyepupil_beg = function()
  ObjDelete( "gfx_totem_eyepupil_zone" );
end;
private.use_eyepupil_end = function()
  if common_impl.ZzCompleteCheck("use_eyepupil") then ObjSet( common_impl.hint["use_eyepupil"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_totem_anm_eye", {animfunc = "use_eye", frame = 999 } );
  ObjSet( "spr_grove_eye", {visible = 1} );
  ObjDelete("spr_grove_hairpin");
  ObjSet( "spr_grove_hairpin_open", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_eyepupil", private.use_eyepupil_inv );
cmn.AddSubscriber( "use_eyepupil", private.use_eyepupil_beg, private.room_objname );
cmn.AddSubscriber( "use_eyepupil", private.use_eyepupil_end, private.room_objname );
cmn.AddSubscriber( "use_eyepupil", private.use_eyepupil_logic );
cmn.AddSubscriber( "use_eyepupil_inv", private.use_eyepupil_inv, private.room_objname );
cmn.AddSubscriber( "use_eyepupil_beg", private.use_eyepupil_beg, private.room_objname );
cmn.AddSubscriber( "use_eyepupil_end", private.use_eyepupil_end, private.room_objname );
cmn.AddSubscriber( "use_eyepupil_end", private.use_eyepupil_logic );
--------------------------------------------------------------------------------------------
function public.use_eyepupil( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_eyepupil" );
    cmn.CallEventHandler( "use_eyepupil_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_eyepupil") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_eyepupil_inv" );
  cmn.CallEventHandler( "use_eyepupil_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_totem_anm_eye", "use_eye", func_end );
  SoundSfx( "aud_use_eyepupil_grove" )
  -- func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--common_impl.hint[ "clk_eyetotem" ] = { type = "click", use_place = "gfx_totem_clk_eyetotem_zone", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };
--
--private.clk_eyetotem_logic = function()
--  ObjSet( "spr_totem_hairpin", { visible = 1, input = 1, active = 1 } )
--
--end;
--private.clk_eyetotem_beg = function()
--  ObjDelete( "gfx_totem_clk_eyetotem_zone" );
--end;
--private.clk_eyetotem_end = function()
--  if common_impl.ZzCompleteCheck("clk_eyetotem") then ObjSet( common_impl.hint["clk_eyetotem"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
----------------------------------------------------------------------------------------------
--cmn.AddSubscriber( "clk_eyetotem", private.clk_eyetotem_beg, private.room_objname );
--cmn.AddSubscriber( "clk_eyetotem", private.clk_eyetotem_end, private.room_objname );
--cmn.AddSubscriber( "clk_eyetotem", private.clk_eyetotem_logic );
--cmn.AddSubscriber( "clk_eyetotem_beg", private.clk_eyetotem_beg, private.room_objname );
--cmn.AddSubscriber( "clk_eyetotem_end", private.clk_eyetotem_end, private.room_objname );
--cmn.AddSubscriber( "clk_eyetotem_end", private.clk_eyetotem_logic );
----------------------------------------------------------------------------------------------
--function public.clk_eyetotem()
--
--  local func_end = function()
--    cmn.SetEventDone( "clk_eyetotem" );
--    cmn.CallEventHandler( "clk_eyetotem_end" );
--    common_impl.Lock(0);
--    if common_impl.ZzCompleteCheck("clk_eyetotem") then ld.CloseSubRoom() end;
--  end;
--
--  cmn.CallEventHandler( "clk_eyetotem_beg" );
--  common_impl.Lock(1);
--
--  --ld.AnimPlay( "", "", func_end );
--  SoundSfx( "aud_clk_eyetotem_grove" )
--  func_end()
--
--end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hairpin" ] = { type = "get", get_obj = "spr_totem_hairpin", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.get_hairpin_logic = function()
  
end;
private.get_hairpin_inv = function()
  interface.InventoryItemAdd("inv_hairpin","spr_totem_hairpin");
end;
private.get_hairpin_beg = function()
  ObjDelete("gfx_totem_hairpin")
end;
private.get_hairpin_end = function()
  if common_impl.ZzCompleteCheck("get_hairpin") then ObjSet( common_impl.hint["get_hairpin"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_totem_anm_eye", {animfunc = "eye_end", frame = 0 } );
  ObjDelete("spr_grove_hairpin_open");
end;

cmn.AddSubscriber( "get_hairpin", private.get_hairpin_inv );
cmn.AddSubscriber( "get_hairpin", private.get_hairpin_beg, private.room_objname );
cmn.AddSubscriber( "get_hairpin", private.get_hairpin_end, private.room_objname );
cmn.AddSubscriber( "get_hairpin", private.get_hairpin_logic );
--------------------------------------------------------------------
function public.get_hairpin()
  ObjSet( "spr_totem_hairpin", {visible = 1} );
  cmn.SetEventDone( "get_hairpin" );
  cmn.CallEventHandler( "get_hairpin" );
  if common_impl.ZzCompleteCheck("get_hairpin") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_beak" ] = { type = "use", inv_obj = "inv_beak", use_place = "gfx_totem_beak_zone", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.use_beak_logic = function()
  ObjSet( "obj_totem_mmg_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_beak_inv = function()
  common_impl.ProcessMultiUseAll("beak", "beak")
end;
private.use_beak_beg = function()
  ObjDelete( "gfx_totem_beak_zone" );
end;
private.use_beak_end = function()
  if common_impl.ZzCompleteCheck("use_beak") then ObjSet( common_impl.hint["use_beak"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_totem_anm_beak", {animfunc = "beak_end", frame = 999 } );
  ObjSet( "spr_grove_mmg_start", {visible = 1} );
  ObjSet( "spr_grove_beak", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_beak", private.use_beak_inv );
cmn.AddSubscriber( "use_beak", private.use_beak_beg, private.room_objname );
cmn.AddSubscriber( "use_beak", private.use_beak_end, private.room_objname );
cmn.AddSubscriber( "use_beak", private.use_beak_logic );
cmn.AddSubscriber( "use_beak_inv", private.use_beak_inv, private.room_objname );
cmn.AddSubscriber( "use_beak_beg", private.use_beak_beg, private.room_objname );
cmn.AddSubscriber( "use_beak_end", private.use_beak_end, private.room_objname );
cmn.AddSubscriber( "use_beak_end", private.use_beak_logic );
--------------------------------------------------------------------------------------------
function public.use_beak( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_beak" );
    cmn.CallEventHandler( "use_beak_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_beak") then ld.CloseSubRoom() end;
    private.init_totemgame();
    cmn.MiniGameShow( "totemgame" ); 
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_beak_inv" );
  cmn.CallEventHandler( "use_beak_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_totem_anm_beak", "use_beak", func_end );
  SoundSfx( "aud_use_beak_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_totemgame" ] = { type = "click", use_place = "obj_totem_mmg_root", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.win_totemgame_logic = function()
  if cmn.IsEventDone("win_totemgame") then 
     ObjSet( "spr_totem_flint", { visible = 1, input = 1, active = 1 } )
     ObjDelete("obj_totem_mmg_root");
  end;
end;
private.win_totemgame_beg = function()
  -- ObjDelete( "gfx_totem_win_totemgame_zone" );
end;
private.win_totemgame_end = function()
  if cmn.IsEventDone("win_totemgame") then 
      if common_impl.ZzCompleteCheck("win_totemgame") then ObjSet( common_impl.hint["win_totemgame"].zz_gate, { visible = 0, input = 0 } ); end;
      ObjSet( "anm_totem_anm_beak", {animfunc = "mmg_end", frame = 0 } );
      ObjSet( "spr_totem_flint_sh", {visible = 1} );
      ObjDelete("spr_grove_mmg_start");
      ObjSet( "spr_grove_mmg_win", {visible = 1} );
      ObjSet( "spr_grove_flint", {visible = 1} );
  end;    
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_totemgame", private.win_totemgame_beg, private.room_objname );
cmn.AddSubscriber( "win_totemgame", private.win_totemgame_end, private.room_objname );
cmn.AddSubscriber( "win_totemgame", private.win_totemgame_logic );
cmn.AddSubscriber( "win_totemgame_beg", private.win_totemgame_beg, private.room_objname );
cmn.AddSubscriber( "win_totemgame_end", private.win_totemgame_end, private.room_objname );
cmn.AddSubscriber( "win_totemgame_end", private.win_totemgame_logic );
--------------------------------------------------------------------------------------------
function public.win_totemgame()

  local func_end = function()
    cmn.SetEventDone( "win_totemgame" );
    cmn.CallEventHandler( "win_totemgame_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_totemgame") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_totemgame_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "totemgame", true ); 
  ObjSet( "obj_totem_mmg_root", {visible = 0} );
  ld.AnimPlay( "anm_totem_anm_beak", "mmg_win", func_end );
  SoundSfx( "aud_mg_totem_win" );
  --func_end()

end;

private.totemgame_fp_array = {4,3,1,2};

function private.init_totemgame()
  
  if not (cmn.IsEventStart("win_totemgame")) then
    ng_global.progress["std"]["win_totemgame"].state = ld.TableCopy(private.totemgame_fp_array);
    
  else  
   
  end
  private.win_totemgame_stand_on_pos()
end;

-----------------------------------

function  private.win_totemgame_stand_on_pos(without_win_ver)
  for i=1,4,1 do 
    local pos_buf = {ObjGet("obj_totem_pos"..i.."_root").pos_x,ObjGet("obj_totem_pos"..i.."_root").pos_y }
    ObjSet( "spr_totem_"..ng_global.progress["std"]["win_totemgame"].state[i], {pos_x = pos_buf[1], pos_y = pos_buf[2], drag=1, input=1} );
  end; 
 
  if without_win_ver~=1 then private.win_totemgame_win_ver(); end; 
end;

function private.win_totemgame_win_ver()
  count = 0;
  for i=1,4,1 do 
    if  ng_global.progress["std"]["win_totemgame"].state[i] == i then count = count+1; end;
  end;  
  
  if count == 4 then  public.win_totemgame(); end;
end;  
----------------------------------------
function public.win_totemgame_part_startdrag(num)
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_totem_"..num, {pos_z = 40} );
  SoundSfx( "aud_get" );
end;  

function public.win_totemgame_drag(num)
  if not ApplyObj("zz_totem","spr_totem_"..num) then 
    ObjStopDrag("spr_totem_"..num);
  end;  
end;

function public.win_totemgame_state_change(num1,num2)
  -- ld.LogTrace( "win_totemgame_state_change "..num1.." "..num2 );
  local num1i, num2i = 0,0;
  for i=1,4,1 do 
    if ng_global.progress["std"]["win_totemgame"].state[i]==num1 then num1i = i end;
    if ng_global.progress["std"]["win_totemgame"].state[i]==num2 then num2i = i end;
  end;  
  
  ng_global.progress["std"]["win_totemgame"].state[num1i] = num2;
  ng_global.progress["std"]["win_totemgame"].state[num2i] = num1;
end;  

function public.win_totemgame_dragdrop(num)
  SoundSfx( "aud_mg_totem_set" );
  
  local select_part = 0;
  for i=1,4,1 do 
    if i~=num then 
      --local obj = ObjGet("spr_totem_"..i);
      if ApplyObj("obj_totem_part"..i.."_root","obj_totem_part"..num.."_root") then
         public.win_totemgame_state_change(num,i); 
         private.win_totemgame_stand_on_pos(1);
         ObjSet( "spr_totem_"..num, {pos_z = 1} ); select_part = i; break; end;
    end;  
  end; 
  ld.SetCursor(CURSOR_DEFAULT); 
  ObjSet( "spr_totem_"..num, {pos_z = 1} );
 -- if select_part~=0 then ObjStartDrag("spr_totem_"..select_part); end;
  if select_part~=0 then 
    local pos_s = {ObjGet("spr_totem_"..select_part).pos_x,ObjGet("spr_totem_"..select_part).pos_y}
    local pos_n = {ObjGet("spr_totem_"..num).pos_x,ObjGet("spr_totem_"..num).pos_y}; 
    ObjSet( "spr_totem_"..select_part, {pos_x = pos_n[1], pos_y = pos_n[2]} );
    ld.StartTimer( 0.1, function()  ObjStartDrag("spr_totem_"..select_part); ObjSet( "spr_totem_"..select_part, {pos_x = pos_s[1], pos_y = pos_s[2]} );  end )
  else
     private.win_totemgame_stand_on_pos();
  end;    
end;  
----------------------------------
private.totemgam_first_init_flag = false; 
function private.totemgam_first_init()
  if private.totemgam_first_init_flag == false then 
    for i=1,4,1 do 
       ObjSet( "spr_totem_"..i,{event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_startdrag = "rm_grove.win_totemgame_part_startdrag("..i..");",
                event_drag="rm_grove.win_totemgame_drag("..i..");", event_dragdrop="rm_grove.win_totemgame_dragdrop("..i..");"});
    end;  
  end;
 
  private.totemgam_first_init_flag = true;  
end;  
------------------------------------------
function private.win_totemgame_reset()
  local func_end = function()
    ng_global.progress["std"]["win_totemgame"].state = ld.TableCopy(private.totemgame_fp_array);
    private.win_totemgame_stand_on_pos();
    ObjAnimate( "obj_totem_mg_parts_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} );
  end;  
  
  
  ld.Lock(1);
  ObjAnimate( "obj_totem_mg_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;


function private.win_totemgame_skip()
 local func_end = function()
    ng_global.progress["std"]["win_totemgame"].state = {1,2,3,4};
    private.win_totemgame_stand_on_pos(1);
    ObjAnimate( "obj_totem_mg_parts_root", 8, 0, 0, function()  private.win_totemgame_stand_on_pos(); end, {0,0,0, 0.3,0,1} );
  end;  
  
  
  ld.Lock(1);
  ObjAnimate( "obj_totem_mg_parts_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_flint" ] = { type = "get", get_obj = "spr_totem_flint", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.get_flint_logic = function()
  
end;
private.get_flint_inv = function()
  interface.InventoryItemAdd("inv_flint","spr_totem_flint");
end;
private.get_flint_beg = function()
  ObjDelete("gfx_totem_flint")
end;
private.get_flint_end = function()
  if common_impl.ZzCompleteCheck("get_flint") then ObjSet( common_impl.hint["get_flint"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_totem_flint_sh");
  ObjDelete("spr_grove_flint");
end;

cmn.AddSubscriber( "get_flint", private.get_flint_inv );
cmn.AddSubscriber( "get_flint", private.get_flint_beg, private.room_objname );
cmn.AddSubscriber( "get_flint", private.get_flint_end, private.room_objname );
cmn.AddSubscriber( "get_flint", private.get_flint_logic );
--------------------------------------------------------------------
function public.get_flint()
  cmn.SetEventDone( "get_flint" );
  cmn.CallEventHandler( "get_flint" );
  if common_impl.ZzCompleteCheck("get_flint") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_chisel" ] = { type = "use", inv_obj = "inv_chisel", use_place = "gfx_totem_chisel_zone", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.use_chisel_logic = function()
  ObjSet( "spr_totem_feathermg2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_totem_partchimeras", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_totem_partchimeras", { active = 1, visible = 1} );

end;
private.use_chisel_inv = function()
  common_impl.ProcessMultiUseAll("chisel", "chisel")
end;
private.use_chisel_beg = function()
  ObjDelete( "gfx_totem_chisel_zone" );
end;
private.use_chisel_end = function()
  if common_impl.ZzCompleteCheck("use_chisel") then ObjSet( common_impl.hint["use_chisel"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_totem_anm_chisel", {animfunc = "use_chisel", frame = 999 } );
  ObjDelete("spr_grove_feathermg2");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_chisel", private.use_chisel_inv );
cmn.AddSubscriber( "use_chisel", private.use_chisel_beg, private.room_objname );
cmn.AddSubscriber( "use_chisel", private.use_chisel_end, private.room_objname );
cmn.AddSubscriber( "use_chisel", private.use_chisel_logic );
cmn.AddSubscriber( "use_chisel_inv", private.use_chisel_inv, private.room_objname );
cmn.AddSubscriber( "use_chisel_beg", private.use_chisel_beg, private.room_objname );
cmn.AddSubscriber( "use_chisel_end", private.use_chisel_end, private.room_objname );
cmn.AddSubscriber( "use_chisel_end", private.use_chisel_logic );
--------------------------------------------------------------------------------------------
function public.use_chisel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_chisel" );
    cmn.CallEventHandler( "use_chisel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_chisel") then ld.CloseSubRoom() end;
    public.get_feathermg2();
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_chisel_inv" );
  cmn.CallEventHandler( "use_chisel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_totem_anm_chisel", "use_chisel", func_end );
  SoundSfx( "aud_use_chisel_grove" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feathermg2" ] = { type = "get", get_obj = "spr_totem_feathermg2", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.get_feathermg2_logic = function()
  
end;
private.get_feathermg2_inv = function()
  interface.InventoryItemAdd("inv_feathermg","spr_totem_feathermg2",function() level_inv.ProcessGetFeathermgAll( "get_feathermg2" ) end);
end;
private.get_feathermg2_beg = function()
  ObjDelete("gfx_totem_feathermg2")
end;
private.get_feathermg2_end = function()
  if common_impl.ZzCompleteCheck("get_feathermg2") then ObjSet( common_impl.hint["get_feathermg2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_feathermg2", private.get_feathermg2_inv );
cmn.AddSubscriber( "get_feathermg2", private.get_feathermg2_beg, private.room_objname );
cmn.AddSubscriber( "get_feathermg2", private.get_feathermg2_end, private.room_objname );
cmn.AddSubscriber( "get_feathermg2", private.get_feathermg2_logic );
--------------------------------------------------------------------
function public.get_feathermg2()
  cmn.SetEventDone( "get_feathermg2" );
  cmn.CallEventHandler( "get_feathermg2" );
  if common_impl.ZzCompleteCheck("get_feathermg2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_partchimeras" ] = { type = "get", get_obj = "spr_totem_partchimeras", room = "rm_grove", zz = "zz_totem", zz_gate = "gzz_grove_totem" };

private.get_partchimeras_logic = function()
  
end;
private.get_partchimeras_inv = function()
  interface.InventoryItemAdd("inv_partchimeras","spr_totem_partchimeras");
end;
private.get_partchimeras_beg = function()
  ObjDelete("gfx_totem_partchimeras")
end;
private.get_partchimeras_end = function()
  if common_impl.ZzCompleteCheck("get_partchimeras") then ObjSet( common_impl.hint["get_partchimeras"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_totem_anm_chisel");
  ObjDelete("spr_grove_partchimeras");
end;

cmn.AddSubscriber( "get_partchimeras", private.get_partchimeras_inv );
cmn.AddSubscriber( "get_partchimeras", private.get_partchimeras_beg, private.room_objname );
cmn.AddSubscriber( "get_partchimeras", private.get_partchimeras_end, private.room_objname );
cmn.AddSubscriber( "get_partchimeras", private.get_partchimeras_logic );
--------------------------------------------------------------------
function public.get_partchimeras()
  ObjSet( "spr_totem_partchimeras", {visible = 1} );
  cmn.SetEventDone( "get_partchimeras" );
  cmn.CallEventHandler( "get_partchimeras" );
  if common_impl.ZzCompleteCheck("get_partchimeras") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_hutdoor_for_grove = function()
    if ld.CheckRequirements( {"win_hutdoor"} ) then
      ObjSet( "gmg_grove_hutdoor", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_hutdoor", win_hutdoor_for_grove, private.room_objname )

end;

--------------------------------------------------------
  local win_hutdoor_for_hutdoor_logic = function()
    if ld.CheckRequirements( {"win_hutdoor"} ) then
      ObjDelete("spr_grove_door_close");
      ObjSet( "spr_grove_door_open", {visible = 1} );
    end
  end;
   
  cmn.AddSubscriber("win_hutdoor", win_hutdoor_for_hutdoor_logic )
---------------------------------------------------------------------
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

   if ( mg_name == "zz_totem" ) and not ld.CheckRequirements( { "win_totemgame" } ) then  
     private.win_totemgame_reset()
  end; 
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_totem" ) and not ld.CheckRequirements( { "win_totemgame" } ) then  
    private.win_totemgame_skip()
  end;

end
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_grove();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_grove_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_totem" );
  function zz_totem.Open()
  end;
  function zz_totem.PreOpen()
     if not cmn.IsEventDone("win_totemgame") then 
      private.totemgam_first_init() 
    end;  
    
    if cmn.IsEventStart("win_totemgame") and not cmn.IsEventDone("win_totemgame") then 
      cmn.MiniGameShow( "totemgame" ); 
      private.init_totemgame()
    end;  
  end;
  function zz_totem.PreClose()
  end;
  function zz_totem.Close()
    if cmn.IsEventStart("win_totemgame") and not cmn.IsEventDone("win_totemgame") then 
        cmn.MiniGameHide( "totemgame" ); 
    end;  
  end;

  subroom.Define( "zz_pond" );
  function zz_pond.Open()
  end;
  function zz_pond.PreOpen()
  end;
  function zz_pond.PreClose()
  end;
  function zz_pond.Close()
  end;

  subroom.Define( "zz_inhut" );
  function zz_inhut.Open()
  end;
  function zz_inhut.PreOpen()
  end;
  function zz_inhut.PreClose()
  end;
  function zz_inhut.Close()
  end;

  subroom.Define( "zz_caveentrance" );
  function zz_caveentrance.Open()
    if not cmn.IsEventDone("clk_animbeast") then 
      public.clk_animbeast();
    end;  
  end;
  function zz_caveentrance.PreOpen()
  end;
  function zz_caveentrance.PreClose()
  end;
  function zz_caveentrance.Close()
  end;
  
end;
--*********************************************************************************************************************
--- other funcs 
function public.inhut_handle_clk()
  local func_end = function()
    ld.Lock(0);
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_hut_handle_grove" );
  ld.AnimPlay( "anm_inhut_anm_handle", "handle_idle", func_end )
end;  