-- name=rm_housedoctor
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_housedoctor";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("obj_housedoctor_textopn", "spr_housedoctor_text","housedoctor_table")
  ld.NoteInit("spr_library_text_t", "spr_library_text","library_text")
  --------------------------------------------------------------------------------------------
function private.opn_housedoctor()
  if not ( cmn.IsEventDone( "opn_housedoctor" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_housedoctor" );
      cmn.CallEventHandler( "opn_housedoctor" )
      -- ld.ShowBbtOpn( private.room_objname )
      ld.ShowBbt("opn_housedoctor");
      SoundTheme( "aud_adventure1_mus" );
  end;
    func_end();
  end;
end;
--------------------------------------------------------------------
local opn_housedoctor = function() end;
local opn_housedoctor_logic = function() end;
cmn.AddSubscriber( "opn_housedoctor", opn_housedoctor_logic )
cmn.AddSubscriber( "opn_housedoctor", opn_housedoctor, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_elk *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_paten" ] = { type = "get", get_obj = "spr_elk_paten", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.get_paten_logic = function()
  
end;
private.get_paten_inv = function()
  interface.InventoryItemAdd("inv_paten","spr_elk_paten");
end;
private.get_paten_beg = function()
  ObjDelete("gfx_elk_paten")
end;
private.get_paten_end = function()
  if common_impl.ZzCompleteCheck("get_paten") then ObjSet( common_impl.hint["get_paten"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_elk_paten_sh");
  ObjDelete("spr_housedoctor_tr19");
end;

cmn.AddSubscriber( "get_paten", private.get_paten_inv );
cmn.AddSubscriber( "get_paten", private.get_paten_beg, private.room_objname );
cmn.AddSubscriber( "get_paten", private.get_paten_end, private.room_objname );
cmn.AddSubscriber( "get_paten", private.get_paten_logic );
--------------------------------------------------------------------
function public.get_paten()
  cmn.SetEventDone( "get_paten" );
  cmn.CallEventHandler( "get_paten" );
  if common_impl.ZzCompleteCheck("get_paten") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_horn" ] = { type = "use", inv_obj = "inv_horn", use_place = "gfx_elk_horn_zone", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.use_horn_logic = function()
  ObjSet( "spr_elk_blackkey", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_elk_blackkey", {active=1, visible=1} );
  ObjSet( "gfx_elk_eye_zone", {active=1, input = 1, visible = 1} );
end;
private.use_horn_inv = function()
  common_impl.ProcessMultiUseAll("horn", "horn")
end;
private.use_horn_beg = function()
  ObjDelete( "gfx_elk_horn_zone" );
end;
private.use_horn_end = function()
  if common_impl.ZzCompleteCheck("use_horn") then ObjSet( common_impl.hint["use_horn"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_elk_anm_horn", {animfunc = "use_horn", frame = 999 } );
  ObjSet( "spr_housedoctor_tr1", {visible = 1} );
  ObjSet( "spr_housedoctor_tr20", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_horn", private.use_horn_inv );
cmn.AddSubscriber( "use_horn", private.use_horn_beg, private.room_objname );
cmn.AddSubscriber( "use_horn", private.use_horn_end, private.room_objname );
cmn.AddSubscriber( "use_horn", private.use_horn_logic );
cmn.AddSubscriber( "use_horn_inv", private.use_horn_inv, private.room_objname );
cmn.AddSubscriber( "use_horn_beg", private.use_horn_beg, private.room_objname );
cmn.AddSubscriber( "use_horn_end", private.use_horn_end, private.room_objname );
cmn.AddSubscriber( "use_horn_end", private.use_horn_logic );
--------------------------------------------------------------------------------------------
function public.use_horn( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_horn" );
    cmn.CallEventHandler( "use_horn_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_horn") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_horn_inv" );
  cmn.CallEventHandler( "use_horn_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_elk_anm_horn", "use_horn", func_end );
  SoundSfx( "aud_use_horn_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_blackkey" ] = { type = "get", get_obj = "spr_elk_blackkey", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.get_blackkey_logic = function()
  
end;
private.get_blackkey_inv = function()
  interface.InventoryItemAdd("inv_blackkey","spr_elk_blackkey");
end;
private.get_blackkey_beg = function()
  ObjDelete("gfx_elk_blackkey")
end;
private.get_blackkey_end = function()
  if common_impl.ZzCompleteCheck("get_blackkey") then ObjSet( common_impl.hint["get_blackkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_elk_anm_horn", {animfunc = "end_horn", frame = 0 } );
  ObjDelete("spr_housedoctor_tr20");
end;

cmn.AddSubscriber( "get_blackkey", private.get_blackkey_inv );
cmn.AddSubscriber( "get_blackkey", private.get_blackkey_beg, private.room_objname );
cmn.AddSubscriber( "get_blackkey", private.get_blackkey_end, private.room_objname );
cmn.AddSubscriber( "get_blackkey", private.get_blackkey_logic );
--------------------------------------------------------------------
function public.get_blackkey()
  ObjSet( "spr_elk_blackkey", {visible = 1} );
  cmn.SetEventDone( "get_blackkey" );
  cmn.CallEventHandler( "get_blackkey" );
  if common_impl.ZzCompleteCheck("get_blackkey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_redberry" ] = { type = "use", inv_obj = "inv_redberry", use_place = "gfx_elk_redberry_zone", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.use_redberry_logic = function()
  if ld.CheckRequirements( {"use_redberry","use_yellowberry","use_greenberry"} ) then
    ObjSet( "spr_elk_laboratorykey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_redberry_inv = function()
  common_impl.ProcessMultiUseAll("redberry", "redberry")
end;
private.use_redberry_beg = function()
  ObjDelete( "gfx_elk_redberry_zone" );
end;
private.use_redberry_end = function()
  if common_impl.ZzCompleteCheck("use_redberry") then ObjSet( common_impl.hint["use_redberry"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_redberry","use_yellowberry","use_greenberry"} ) then
    ObjDelete("anm_elk_anm_b1")
    ObjDelete("anm_elk_anm_b2")
    ObjDelete("anm_elk_anm_b3")
    ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b", frame = 0, visible=1 } );
  else
    ObjSet( "anm_elk_anm_b1", {animfunc = "use_b1", frame = 999, pos_z=22 } );
  end;  
  ObjSet( "spr_housedoctor_tr4", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_redberry", private.use_redberry_inv );
cmn.AddSubscriber( "use_redberry", private.use_redberry_beg, private.room_objname );
cmn.AddSubscriber( "use_redberry", private.use_redberry_end, private.room_objname );
cmn.AddSubscriber( "use_redberry", private.use_redberry_logic );
cmn.AddSubscriber( "use_redberry_inv", private.use_redberry_inv, private.room_objname );
cmn.AddSubscriber( "use_redberry_beg", private.use_redberry_beg, private.room_objname );
cmn.AddSubscriber( "use_redberry_end", private.use_redberry_end, private.room_objname );
cmn.AddSubscriber( "use_redberry_end", private.use_redberry_logic );
--------------------------------------------------------------------------------------------
function public.use_redberry( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_redberry" );
    cmn.CallEventHandler( "use_redberry_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_redberry") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_yellowberry","use_greenberry"} ) then
       ObjSet( "anm_elk_anm_b1", {visible = 0} );
       ObjSet( "anm_elk_anm_b2", {visible = 0} );
       ObjSet( "anm_elk_anm_b3", {visible = 0} );
       ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b1", frame = 0, visible=1 } );
       SoundSfx( "aud_touch_berry_housedoctor" )
       ld.AnimPlay( "anm_elk_anm_end_b1", "end_b1", func_end )
     else 
       func_end();
     end;  
  end;  
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_redberry_inv" );
  cmn.CallEventHandler( "use_redberry_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_elk_anm_b1", "use_b1", func_preend );
  SoundSfx( "aud_use_berry_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_yellowberry" ] = { type = "use", inv_obj = "inv_yellowberry", use_place = "gfx_elk_yellowberry_zone", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.use_yellowberry_logic = function()
  if ld.CheckRequirements( {"use_yellowberry","use_redberry","use_greenberry"} ) then
    ObjSet( "spr_elk_laboratorykey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_yellowberry_inv = function()
  common_impl.ProcessMultiUseAll("yellowberry", "yellowberry")
end;
private.use_yellowberry_beg = function()
  ObjDelete( "gfx_elk_yellowberry_zone" );
end;
private.use_yellowberry_end = function()
  if common_impl.ZzCompleteCheck("use_yellowberry") then ObjSet( common_impl.hint["use_yellowberry"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_redberry","use_yellowberry","use_greenberry"} ) then
    ObjDelete("anm_elk_anm_b1")
    ObjDelete("anm_elk_anm_b2")
    ObjDelete("anm_elk_anm_b3")
    ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b", frame = 0, visible=1 } );
  else
    ObjSet( "anm_elk_anm_b2", {animfunc = "use_b2", frame = 999, pos_z=22 } );
  end;  
  ObjSet( "spr_housedoctor_tr3", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_yellowberry", private.use_yellowberry_inv );
cmn.AddSubscriber( "use_yellowberry", private.use_yellowberry_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowberry", private.use_yellowberry_end, private.room_objname );
cmn.AddSubscriber( "use_yellowberry", private.use_yellowberry_logic );
cmn.AddSubscriber( "use_yellowberry_inv", private.use_yellowberry_inv, private.room_objname );
cmn.AddSubscriber( "use_yellowberry_beg", private.use_yellowberry_beg, private.room_objname );
cmn.AddSubscriber( "use_yellowberry_end", private.use_yellowberry_end, private.room_objname );
cmn.AddSubscriber( "use_yellowberry_end", private.use_yellowberry_logic );
--------------------------------------------------------------------------------------------
function public.use_yellowberry( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_yellowberry" );
    cmn.CallEventHandler( "use_yellowberry_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_yellowberry") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_redberry","use_greenberry"} ) then
       ObjSet( "anm_elk_anm_b1", {visible = 0} );
       ObjSet( "anm_elk_anm_b2", {visible = 0} );
       ObjSet( "anm_elk_anm_b3", {visible = 0} );
       ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b1", frame = 0, visible=1 } );
       SoundSfx( "aud_touch_berry_housedoctor" )
       ld.AnimPlay( "anm_elk_anm_end_b1", "end_b1", func_end )
     else 
       func_end();
     end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_yellowberry_inv" );
  cmn.CallEventHandler( "use_yellowberry_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_elk_anm_b2", "use_b2", func_preend );
  SoundSfx( "aud_use_berry_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_greenberry" ] = { type = "use", inv_obj = "inv_greenberry", use_place = "gfx_elk_greenberry_zone", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.use_greenberry_logic = function()
  if ld.CheckRequirements( {"use_greenberry","use_redberry","use_yellowberry"} ) then
    ObjSet( "spr_elk_laboratorykey", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_greenberry_inv = function()
  common_impl.ProcessMultiUseAll("greenberry", "greenberry")
end;
private.use_greenberry_beg = function()
  ObjDelete( "gfx_elk_greenberry_zone" );
end;
private.use_greenberry_end = function()
  if common_impl.ZzCompleteCheck("use_greenberry") then ObjSet( common_impl.hint["use_greenberry"].zz_gate, { visible = 0, input = 0 } ); end;
  if ld.CheckRequirements( {"use_redberry","use_yellowberry","use_greenberry"} ) then
    ObjDelete("anm_elk_anm_b1")
    ObjDelete("anm_elk_anm_b2")
    ObjDelete("anm_elk_anm_b3")
    ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b", frame = 0, visible=1 } );
  else
    ObjSet( "anm_elk_anm_b3", {animfunc = "use_b3", frame = 999, pos_z=22 } );
  end;  
  ObjSet( "spr_housedoctor_tr5", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_greenberry", private.use_greenberry_inv );
cmn.AddSubscriber( "use_greenberry", private.use_greenberry_beg, private.room_objname );
cmn.AddSubscriber( "use_greenberry", private.use_greenberry_end, private.room_objname );
cmn.AddSubscriber( "use_greenberry", private.use_greenberry_logic );
cmn.AddSubscriber( "use_greenberry_inv", private.use_greenberry_inv, private.room_objname );
cmn.AddSubscriber( "use_greenberry_beg", private.use_greenberry_beg, private.room_objname );
cmn.AddSubscriber( "use_greenberry_end", private.use_greenberry_end, private.room_objname );
cmn.AddSubscriber( "use_greenberry_end", private.use_greenberry_logic );
--------------------------------------------------------------------------------------------
function public.use_greenberry( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_greenberry" );
    cmn.CallEventHandler( "use_greenberry_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_greenberry") then ld.CloseSubRoom() end;
  end;

  local func_preend = function()
     if ld.CheckRequirements( {"use_yellowberry","use_redberry"} ) then
       ObjSet( "anm_elk_anm_b1", {visible = 0} );
       ObjSet( "anm_elk_anm_b2", {visible = 0} );
       ObjSet( "anm_elk_anm_b3", {visible = 0} );
       ObjSet( "anm_elk_anm_end_b1", {animfunc = "end_b1", frame = 0, visible=1 } );
       SoundSfx( "aud_touch_berry_housedoctor" )
       ld.AnimPlay( "anm_elk_anm_end_b1", "end_b1", func_end )
     else 
       func_end();
     end;  
  end;  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_greenberry_inv" );
  cmn.CallEventHandler( "use_greenberry_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_elk_anm_b3", "use_b3", func_preend );
  SoundSfx( "aud_use_berry_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_laboratorykey" ] = { type = "get", get_obj = "spr_elk_laboratorykey", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.get_laboratorykey_logic = function()
  
end;
private.get_laboratorykey_inv = function()
  interface.InventoryItemAdd("inv_laboratorykey","spr_elk_laboratorykey");
end;
private.get_laboratorykey_beg = function()
  ObjDelete("gfx_elk_laboratorykey")
end;
private.get_laboratorykey_end = function()
  if common_impl.ZzCompleteCheck("get_laboratorykey") then ObjSet( common_impl.hint["get_laboratorykey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_laboratorykey", private.get_laboratorykey_inv );
cmn.AddSubscriber( "get_laboratorykey", private.get_laboratorykey_beg, private.room_objname );
cmn.AddSubscriber( "get_laboratorykey", private.get_laboratorykey_end, private.room_objname );
cmn.AddSubscriber( "get_laboratorykey", private.get_laboratorykey_logic );
--------------------------------------------------------------------
function public.get_laboratorykey()
  cmn.SetEventDone( "get_laboratorykey" );
  cmn.CallEventHandler( "get_laboratorykey" );
  if common_impl.ZzCompleteCheck("get_laboratorykey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_eye" ] = { type = "use", inv_obj = "inv_eye", use_place = "gfx_elk_eye_zone", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.use_eye_logic = function()
  ObjSet( "spr_elk_handledragon", { visible = 0, input = 1, active = 1 } )
  ObjSet( "gfx_elk_handledragon", {active=1, visible = 1} );
end;
private.use_eye_inv = function()
  common_impl.ProcessMultiUseAll("eye", "eye")
end;
private.use_eye_beg = function()
  ObjDelete( "gfx_elk_eye_zone" );
end;
private.use_eye_end = function()
  if common_impl.ZzCompleteCheck("use_eye") then ObjSet( common_impl.hint["use_eye"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_elk_anm_eye", {animfunc = "use_eye", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_eye", private.use_eye_inv );
cmn.AddSubscriber( "use_eye", private.use_eye_beg, private.room_objname );
cmn.AddSubscriber( "use_eye", private.use_eye_end, private.room_objname );
cmn.AddSubscriber( "use_eye", private.use_eye_logic );
cmn.AddSubscriber( "use_eye_inv", private.use_eye_inv, private.room_objname );
cmn.AddSubscriber( "use_eye_beg", private.use_eye_beg, private.room_objname );
cmn.AddSubscriber( "use_eye_end", private.use_eye_end, private.room_objname );
cmn.AddSubscriber( "use_eye_end", private.use_eye_logic );
--------------------------------------------------------------------------------------------
function public.use_eye( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_eye" );
    cmn.CallEventHandler( "use_eye_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_eye") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_eye_inv" );
  cmn.CallEventHandler( "use_eye_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_elk_anm_eye", "use_eye", func_end );
  SoundSfx( "aud_use_eye_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_handledragon" ] = { type = "get", get_obj = "spr_elk_handledragon", room = "rm_housedoctor", zz = "zz_elk", zz_gate = "gzz_housedoctor_elk" };

private.get_handledragon_logic = function()
  
end;
private.get_handledragon_inv = function()
  interface.InventoryItemAdd("inv_handledragon","spr_elk_handledragon");
end;
private.get_handledragon_beg = function()
  ObjDelete("gfx_elk_handledragon")
end;
private.get_handledragon_end = function()
  if common_impl.ZzCompleteCheck("get_handledragon") then ObjSet( common_impl.hint["get_handledragon"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_elk_anm_eye", {animfunc = "en_eye", frame = 0 } );
end;

cmn.AddSubscriber( "get_handledragon", private.get_handledragon_inv );
cmn.AddSubscriber( "get_handledragon", private.get_handledragon_beg, private.room_objname );
cmn.AddSubscriber( "get_handledragon", private.get_handledragon_end, private.room_objname );
cmn.AddSubscriber( "get_handledragon", private.get_handledragon_logic );
--------------------------------------------------------------------
function public.get_handledragon()
  ObjSet( "spr_elk_handledragon", {visible = 1} );
  cmn.SetEventDone( "get_handledragon" );
  cmn.CallEventHandler( "get_handledragon" );
  if common_impl.ZzCompleteCheck("get_handledragon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_chest *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_redberry" ] = { type = "get", get_obj = "spr_chest_redberry", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.get_redberry_logic = function()
  ObjSet( "gfx_chest_blackkey_zone", {active=1, input = 1, visible = 1} );
end;
private.get_redberry_inv = function()
  interface.InventoryItemAdd("inv_redberry","spr_chest_redberry");
end;
private.get_redberry_beg = function()
  ObjDelete("gfx_chest_redberry")
end;
private.get_redberry_end = function()
  if common_impl.ZzCompleteCheck("get_redberry") then ObjSet( common_impl.hint["get_redberry"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_chest_sh_redberry");
  ObjDelete("spr_housedoctor_tr6b");
  ObjDelete("spr_chest_tr_redberry1");
  ObjDelete("spr_chest_sh_redberry1");
end;

cmn.AddSubscriber( "get_redberry", private.get_redberry_inv );
cmn.AddSubscriber( "get_redberry", private.get_redberry_beg, private.room_objname );
cmn.AddSubscriber( "get_redberry", private.get_redberry_end, private.room_objname );
cmn.AddSubscriber( "get_redberry", private.get_redberry_logic );
--------------------------------------------------------------------
function public.get_redberry()
  cmn.SetEventDone( "get_redberry" );
  cmn.CallEventHandler( "get_redberry" );
  if common_impl.ZzCompleteCheck("get_redberry") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_paten_zone_clk()  --rm_housedoctor.use_paten_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_paten' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_chest_anm_right", "idle_1", func_end )
end;  



common_impl.hint[ "use_paten" ] = { type = "use", inv_obj = "inv_paten", use_place = "gfx_chest_paten_zone", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.use_paten_logic = function()
  ObjSet( "spr_chest_sickle", { visible = 1, input = 1, active = 1 } )

end;
private.use_paten_inv = function()
  common_impl.ProcessMultiUseAll("paten", "paten")
end;
private.use_paten_beg = function()
  ObjDelete( "gfx_chest_paten_zone" );
end;
private.use_paten_end = function()
  if common_impl.ZzCompleteCheck("use_paten") then ObjSet( common_impl.hint["use_paten"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_chest_anm_right", {animfunc = "end_sickle", frame = 0 } );
  ObjSet( "spr_chest_sh_sickle", {visible = 1} );
  ObjSet( "spr_housedoctor_tr12", {visible = 1} );
  ObjSet( "spr_housedoctor_tr8", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_paten", private.use_paten_inv );
cmn.AddSubscriber( "use_paten", private.use_paten_beg, private.room_objname );
cmn.AddSubscriber( "use_paten", private.use_paten_end, private.room_objname );
cmn.AddSubscriber( "use_paten", private.use_paten_logic );
cmn.AddSubscriber( "use_paten_inv", private.use_paten_inv, private.room_objname );
cmn.AddSubscriber( "use_paten_beg", private.use_paten_beg, private.room_objname );
cmn.AddSubscriber( "use_paten_end", private.use_paten_end, private.room_objname );
cmn.AddSubscriber( "use_paten_end", private.use_paten_logic );
--------------------------------------------------------------------------------------------
function public.use_paten( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_paten" );
    cmn.CallEventHandler( "use_paten_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_paten") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_paten_inv" );
  cmn.CallEventHandler( "use_paten_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_chest_anm_right", "use_paten", func_end );
  SoundSfx( "aud_use_paten_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sickle" ] = { type = "get", get_obj = "spr_chest_sickle", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.get_sickle_logic = function()
  
end;
private.get_sickle_inv = function()
  interface.InventoryItemAdd("inv_sickle","spr_chest_sickle");
end;
private.get_sickle_beg = function()
  ObjDelete("gfx_chest_sickle")
end;
private.get_sickle_end = function()
  if common_impl.ZzCompleteCheck("get_sickle") then ObjSet( common_impl.hint["get_sickle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_chest_sh_sickle")
  ObjDelete("spr_housedoctor_tr8")
end;

cmn.AddSubscriber( "get_sickle", private.get_sickle_inv );
cmn.AddSubscriber( "get_sickle", private.get_sickle_beg, private.room_objname );
cmn.AddSubscriber( "get_sickle", private.get_sickle_end, private.room_objname );
cmn.AddSubscriber( "get_sickle", private.get_sickle_logic );
--------------------------------------------------------------------
function public.get_sickle()
  cmn.SetEventDone( "get_sickle" );
  cmn.CallEventHandler( "get_sickle" );
  if common_impl.ZzCompleteCheck("get_sickle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_blackkey_zone_clk()  --rm_housedoctor.use_blackkey_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_blackkey' )
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_small_wood" );
  ld.AnimPlay( "anm_chest_anm_left", "idle_2", func_end )
end;  

common_impl.hint[ "use_blackkey" ] = { type = "use", inv_obj = "inv_blackkey", use_place = "gfx_chest_blackkey_zone", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.use_blackkey_logic = function()
  ObjSet( "spr_chest_book", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_chest_yellowberry", { visible = 1, input = 1, active = 1 } )

end;
private.use_blackkey_inv = function()
  common_impl.ProcessMultiUseAll("blackkey", "blackkey")
end;
private.use_blackkey_beg = function()
  ObjDelete( "gfx_chest_blackkey_zone" );
end;
private.use_blackkey_end = function()
  if common_impl.ZzCompleteCheck("use_blackkey") then ObjSet( common_impl.hint["use_blackkey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "spr_chest_sh_yellowberry", {visible = 1} );
  ObjSet( "spr_chest_sh_book", {visible=1} );
  ObjSet( "anm_chest_anm_left", {animfunc = "end_berry", frame = 0 } );
  ObjSet( "spr_housedoctor_tr9", {visible = 1} );
  ObjSet( "spr_housedoctor_tr6", {visible = 1} );
  ObjSet( "spr_housedoctor_tr7", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_blackkey", private.use_blackkey_inv );
cmn.AddSubscriber( "use_blackkey", private.use_blackkey_beg, private.room_objname );
cmn.AddSubscriber( "use_blackkey", private.use_blackkey_end, private.room_objname );
cmn.AddSubscriber( "use_blackkey", private.use_blackkey_logic );
cmn.AddSubscriber( "use_blackkey_inv", private.use_blackkey_inv, private.room_objname );
cmn.AddSubscriber( "use_blackkey_beg", private.use_blackkey_beg, private.room_objname );
cmn.AddSubscriber( "use_blackkey_end", private.use_blackkey_end, private.room_objname );
cmn.AddSubscriber( "use_blackkey_end", private.use_blackkey_logic );
--------------------------------------------------------------------------------------------
function public.use_blackkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_blackkey" );
    cmn.CallEventHandler( "use_blackkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_blackkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_blackkey_inv" );
  cmn.CallEventHandler( "use_blackkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_chest_anm_left", "use_key", func_end );
  SoundSfx( "aud_use_blackkey_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_book" ] = { type = "get", get_obj = "spr_chest_book", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.get_book_logic = function()
  
end;
private.get_book_inv = function()
  interface.InventoryItemAdd("inv_book","spr_chest_book");
end;
private.get_book_beg = function()
  ObjDelete("gfx_chest_book")
end;
private.get_book_end = function()
  if common_impl.ZzCompleteCheck("get_book") then ObjSet( common_impl.hint["get_book"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_chest_sh_book")
  ObjDelete("spr_housedoctor_tr7");
end;

cmn.AddSubscriber( "get_book", private.get_book_inv );
cmn.AddSubscriber( "get_book", private.get_book_beg, private.room_objname );
cmn.AddSubscriber( "get_book", private.get_book_end, private.room_objname );
cmn.AddSubscriber( "get_book", private.get_book_logic );
--------------------------------------------------------------------
function public.get_book()
  cmn.SetEventDone( "get_book" );
  cmn.CallEventHandler( "get_book" );
  if common_impl.ZzCompleteCheck("get_book") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_yellowberry" ] = { type = "get", get_obj = "spr_chest_yellowberry", room = "rm_housedoctor", zz = "zz_chest", zz_gate = "gzz_housedoctor_chest" };

private.get_yellowberry_logic = function()
  
end;
private.get_yellowberry_inv = function()
  interface.InventoryItemAdd("inv_yellowberry","spr_chest_yellowberry");
end;
private.get_yellowberry_beg = function()
  ObjDelete("gfx_chest_yellowberry")
end;
private.get_yellowberry_end = function()
  if common_impl.ZzCompleteCheck("get_yellowberry") then ObjSet( common_impl.hint["get_yellowberry"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_chest_sh_yellowberry")
  ObjDelete("spr_housedoctor_tr6")
end;

cmn.AddSubscriber( "get_yellowberry", private.get_yellowberry_inv );
cmn.AddSubscriber( "get_yellowberry", private.get_yellowberry_beg, private.room_objname );
cmn.AddSubscriber( "get_yellowberry", private.get_yellowberry_end, private.room_objname );
cmn.AddSubscriber( "get_yellowberry", private.get_yellowberry_logic );
--------------------------------------------------------------------
function public.get_yellowberry()
  cmn.SetEventDone( "get_yellowberry" );
  cmn.CallEventHandler( "get_yellowberry" );
  if common_impl.ZzCompleteCheck("get_yellowberry") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_library *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_camomile2" ] = { type = "get", get_obj = "spr_library_camomile2", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.get_camomile2_logic = function()
 
end;
private.get_camomile2_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_library_camomile2",function() level_inv.ProcessGetCamomileAll( "get_camomile2" ) end);
end;
private.get_camomile2_beg = function()
  ObjDelete("gfx_library_camomile2")
end;
private.get_camomile2_end = function()
  if common_impl.ZzCompleteCheck("get_camomile2") then ObjSet( common_impl.hint["get_camomile2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_library_camomile2_sh");
  ObjDelete("spr_housedoctor_tr15");
end;

cmn.AddSubscriber( "get_camomile2", private.get_camomile2_inv );
cmn.AddSubscriber( "get_camomile2", private.get_camomile2_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile2", private.get_camomile2_end, private.room_objname );
cmn.AddSubscriber( "get_camomile2", private.get_camomile2_logic );
--------------------------------------------------------------------
function public.get_camomile2()
  cmn.SetEventDone( "get_camomile2" );
  cmn.CallEventHandler( "get_camomile2" );
  if common_impl.ZzCompleteCheck("get_camomile2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_book_zone_clk()   --rm_housedoctor.use_book_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_book' );
  end;  
  
  ld.Lock(1);
  ld.AnimPlay( "anm_library_anm_book", "idle_door", func_end )
end;  


common_impl.hint[ "use_book" ] = { type = "use", inv_obj = "inv_book", use_place = "gfx_library_book_zone", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.use_book_logic = function()
  ObjSet( "obj_library_mmg_root", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_book_inv = function()
  common_impl.ProcessMultiUseAll("book", "book")
end;
private.use_book_beg = function()
  ObjDelete( "gfx_library_book_zone" );
end;
private.use_book_end = function()
  if common_impl.ZzCompleteCheck("use_book") then ObjSet( common_impl.hint["use_book"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "obj_library_book4_root", {visible = 1} );
  ObjDelete("anm_library_anm_book");
  ObjDelete("spr_housedoctor_tr13");
  ObjSet( "spr_housedoctor_tr14", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_book", private.use_book_inv );
cmn.AddSubscriber( "use_book", private.use_book_beg, private.room_objname );
cmn.AddSubscriber( "use_book", private.use_book_end, private.room_objname );
cmn.AddSubscriber( "use_book", private.use_book_logic );
cmn.AddSubscriber( "use_book_inv", private.use_book_inv, private.room_objname );
cmn.AddSubscriber( "use_book_beg", private.use_book_beg, private.room_objname );
cmn.AddSubscriber( "use_book_end", private.use_book_end, private.room_objname );
cmn.AddSubscriber( "use_book_end", private.use_book_logic );
--------------------------------------------------------------------------------------------
function public.use_book( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_book" );
    cmn.CallEventHandler( "use_book_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_book") then ld.CloseSubRoom() end;
       private.init_books()    
       cmn.MiniGameShow( "books" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_book_inv" );
  cmn.CallEventHandler( "use_book_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_library_anm_book", "use_book", func_end );
  SoundSfx( "aud_use_book_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_books" ] = { type = "click", use_place = "obj_library_mmg_root", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.win_books_logic = function()
  if cmn.IsEventDone("win_books") then 
    ObjSet( "spr_library_medal", { visible = 0, input = 1, active = 1 } )
    ObjSet( "obj_library_mmg_root", {input=0, pos_z=3} );
    ObjSet( "gfx_library_medal", {active = 1, visible = 1} );
  end;
end;
private.win_books_beg = function()
  -- ObjDelete( "gfx_library_win_books_zone" );
end;
private.win_books_end = function()
  if cmn.IsEventDone("win_books") then 
    if common_impl.ZzCompleteCheck("win_books") then ObjSet( common_impl.hint["win_books"].zz_gate, { visible = 0, input = 0 } ); end;
    for i=1,6,1 do
      local my_array ={14,54,94 ,174 ,214 ,134 };
      ObjSet("obj_library_book"..i.."_root",{pos_x= my_array[i]});
    end;
    ObjSet( "spr_housedoctor_tr21", {visible = 1} );  
    ObjSet( "anm_library_anm_book_win", {animfunc = "end_mmg", frame = 999, pos_z=4 } );
  end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_books", private.win_books_beg, private.room_objname );
cmn.AddSubscriber( "win_books", private.win_books_end, private.room_objname );
cmn.AddSubscriber( "win_books", private.win_books_logic );
cmn.AddSubscriber( "win_books_beg", private.win_books_beg, private.room_objname );
cmn.AddSubscriber( "win_books_end", private.win_books_end, private.room_objname );
cmn.AddSubscriber( "win_books_end", private.win_books_logic );
--------------------------------------------------------------------------------------------
function public.win_books()

  local func_end = function()
    cmn.SetEventDone( "win_books" );
    cmn.CallEventHandler( "win_books_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_books") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_books_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  
  local func_preend = function()
    cmn.MiniGameHide( "books", true); 
    SoundSfx( "aud_mmg_books_open" );
    ld.AnimPlay( "anm_library_anm_book_win", "end_mmg", func_end );
  end;  
  
  
  ld.Lock(1);
  SoundSfx( "aud_mmg_books_win" );
  for i=1,6,1 do 
    ObjAnimate( "spr_library_book"..i.."_lb", 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );
  end;  
  ld.AnimPlay( "anm_library_anm_book_win_anm", "victory1", func_preend )  
    --ld.StartTimer( 1.3,func_preend );   
  
  
end;

local win_books_pos_array={14,54,94 ,174 ,214 ,134 };
private.win_book_fp_array = {5,1,2,4,3,6};

function private.init_books()
  --private.win_books_first_init();
  if not (cmn.IsEventStart("win_books")) then
    ng_global.progress["std"]["win_books"].state = {}
    -- private.win_books_state= ld.TableCopy(private.win_books_fp_array);
    ng_global.progress["std"]["win_books"].state = ld.TableCopy(private.win_book_fp_array);
  else  
    --private.win_books_state=ng_global.progress["std"]["win_books"].state;
  end
  private.win_books_stand_pos();  
end

private.win_books_first_init_flag = false;
function private.win_books_first_init()
  if private.win_books_first_init_flag==false then 
    for i=1,6,1 do 
      ObjSet( "obj_library_book"..i.."_root", {event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="rm_housedoctor.win_books_part_mdown("..i..");"} );
    end;  
    --  ObjSet( "obj_library_book_clk_zone", {event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="rm_housedoctor.win_books_empty_pos_mdown();"} );

    --- create lights
    local lights_y_step={8,8,9,8,8,9};
    
    for i=1,6,1 do 
      ObjCreate("spr_library_book"..i.."_lb","spr");
      ObjAttach("spr_library_book"..i.."_lb","obj_library_book"..i.."_root");
      ObjSet( "spr_library_book"..i.."_lb", {input=0, visible=1, alp=0, res="assets/levels/level/rm_housedoctor/zz_library/r_l1"} );
      
    --  ObjCreate("spr_library_book"..i.."_lr","spr");
    --  ObjAttach("spr_library_book"..i.."_lr","obj_library_book"..i.."_root");
    --  ObjSet( "spr_library_book"..i.."_lr", {input=0, visible=1, alp=0, res="assets/levels/level/rm_housedoctor/zz_library/r_l"} );
      ObjCreate("spr_library_book"..i.."_l","spr");
      ObjAttach("spr_library_book"..i.."_l","obj_library_book"..i.."_root");
      ObjSet( "spr_library_book"..i.."_l", {pos_y = lights_y_step[i], input=0, visible=1, alp=0, res="assets/levels/level/rm_housedoctor/zz_library/l"..i} );
    end;  

  end;  
  private.win_books_first_init_flag = true;
  
  if not cmn.IsEventStart("win_books") then 
    for i=1,6,1 do 
        ObjSet( "obj_library_book"..private.win_book_fp_array[i].."_root",{pos_x=win_books_pos_array[i] });
    end;  
  end;  
end;  




function private.win_books_stand_pos(without_win_ver)
  private.win_books_select_part=0;
  for i=1,6,1 do  
     ObjSet( "obj_library_book"..ng_global.progress["std"]["win_books"].state[i].."_root", {pos_x=win_books_pos_array[i], pos_z=1} );
  end;
 
  for i=1,6,1 do 
    ObjSet( "spr_library_book"..i.."_lb", {alp=0} );
    ObjSet( "spr_library_book"..i.."_l", {alp=0} );
  end;   
  
  if without_win_ver~=1 then  private.win_books_ver(); end;
end;  
----------------------------------------------------
function private.win_books_show_state()
  local my_str=""
  for i=1,6,1 do 
    my_str=my_str.." "..ng_global.progress["std"]["win_books"].state[i];
  end;  
  --  ld.LogTrace( my_str );
end;  
----------------
function private.win_books_ver()
  local win_array={1,2,3,4,5,6}
  local count=0;
  for i=1,6,1 do 
    if ng_global.progress["std"]["win_books"].state[i] == win_array[i] then count=count+1; end;
  end;  
  
 -- ld.LogTrace( "count = "..count );
 -- private.win_books_show_state();
  if count==6 then public.win_books(); end;
end;  
---------------------------------------------------- 
 
private.win_books_select_part=0;
function public.win_books_part_mdown(num)
  local func_end = function()
    ld.Lock(0);   
    private.win_books_select_part=0;
     private.win_books_stand_pos();
  end;  
  
  SoundSfx( "aud_mmg_books_click" ); 
  if private.win_books_select_part==0 then 
    private.win_books_select_part=num;
    ObjSet( "spr_library_book"..num.."_lb", {alp=1} );
    ObjSet( "spr_library_book"..num.."_l", {alp=1} );
  elseif private.win_books_select_part==num then 
    private.win_books_select_part=0;
    ObjSet( "spr_library_book"..num.."_lb", {alp=0} );
    ObjSet( "spr_library_book"..num.."_l", {alp=0} );
  else
  --ld.Lock(1)
  --ObjAnimate( "spr_library_book"..num.."_lr", 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
  --ObjAnimate( "spr_library_book"..private.win_books_select_part.."_lb", 8, 0, 0, function() end, {0,0,1, 0.25,0,1, 0.5,0,0} );
    
    local cur_pos_p = private.win_books_get_part_pos(private.win_books_select_part);
    local cur_pos_e = private.win_books_get_part_pos(num);
    
    ObjSet( "spr_library_book"..num.."_lb", {alp=1} );
    ObjSet( "spr_library_book"..num.."_l", {alp=1} );
    
    
    ng_global.progress["std"]["win_books"].state[cur_pos_e] = private.win_books_select_part;
    ng_global.progress["std"]["win_books"].state[cur_pos_p] = num; 
    
    ld.Lock(1);
    SoundSfx( "aud_mmg_books_move" );
    ObjSet( "obj_library_book"..private.win_books_select_part.."_root", {pos_z=20} );
    ObjAnimate( "obj_library_book"..private.win_books_select_part.."_root", 0, 0, 0, function() end, {0,0,win_books_pos_array[cur_pos_p], 0.3,0,win_books_pos_array[cur_pos_e]} );
    ObjSet( "obj_library_book"..num.."_root", {pos_z=20} );
    ObjAnimate( "obj_library_book"..num.."_root", 0, 0, 0, func_end, {0,0,win_books_pos_array[cur_pos_e], 0.3,0,win_books_pos_array[cur_pos_p]} );
    
    
  end;
end;  
---------------------------------------------------
function private.win_books_get_part_pos(num)
  for i=1,6,1 do 
    if  ng_global.progress["std"]["win_books"].state[i]==num then return i; end;
  end;  
  return 0;
end;  
------------------------------------------------------------------------------
--function public.win_books_empty_pos_mdown()
--  local cur_pos_p0 = private.win_books_get_part_pos(private.win_books_select_part);
--  local cur_pos_e0 = private.win_books_get_part_pos(0);
--  
--  if private.win_books_select_part~=0 then 
--    if  math.abs(cur_pos_p0-cur_pos_e0)<=2 then
--        local cur_pos_p = private.win_books_get_part_pos(private.win_books_select_part);
--        local cur_pos_e = private.win_books_get_part_pos(0);
--        local func_end = function()
--          ld.Lock(0);
--          ObjSet( "obj_library_book"..private.win_books_select_part.."_root", {pos_z=0} );
--          ObjSet( "obj_library_book_clk_zone", {pos_x = win_books_pos_array[cur_pos_p]} );
--          private.win_books_stand_pos();
--        end;  
--        
--        ld.Lock(1);
--        ng_global.progress["std"]["win_books"].state[cur_pos_e] = private.win_books_select_part;
--        ng_global.progress["std"]["win_books"].state[cur_pos_p] = 0; 
--        ObjSet( "obj_library_book"..private.win_books_select_part.."_root", {pos_z=20} );
--        ObjAnimate( "obj_library_book"..private.win_books_select_part.."_root", 0, 0, 0, func_end, {0,0,win_books_pos_array[cur_pos_p], 0.3,0,win_books_pos_array[cur_pos_e]} );
--      elseif math.abs(cur_pos_p0-cur_pos_e0)>2 then 
--         local func_end = function()
--           ld.Lock(0);
--           private.win_books_stand_pos();
--         end;     
--        
--         ld.Lock(1);
--         ObjAnimate( "spr_library_book"..private.win_books_select_part.."_lr", 8, 0, 0, func_end, {0,0,0, 0.25,0,1, 0.5,0,0} );
--      end;   
--  
--   else   
--     local func_end = function()
--       ld.Lock(0);
--       private.win_books_stand_pos();
--     end;     
--    
--     ld.Lock(1);
--     for i=1,6,1 do 
--        ObjAnimate( "spr_library_book"..i.."_lr", 8, 0, 0, function() end, {0,0,0, 0.25,0,1, 0.5,0,0} );
--     end;  
--     ld.StartTimer( 0.5,func_end );   
--   end; 
--   private.win_books_select_part=0; 
--end;  
-----------------------------------------------------
function  private.win_books_skip()
  local func_end = function()
    ng_global.progress["std"]["win_books"].state={1,2,3,4,5,6};
    private.win_books_stand_pos(1); --without win_ver
    ObjAnimate( "obj_library_mmg_root", 8, 0, 0, function() private.win_books_stand_pos(); end, {0,0,0, 0.25,0,1} );  
  end;

  ld.Lock(1);
  ObjAnimate( "obj_library_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );  
end;  
---------------------------------------------------
function  private.win_books_reset()
  local func_end = function()
    ng_global.progress["std"]["win_books"].state = ld.TableCopy(private.win_book_fp_array);
    private.win_books_stand_pos(1); --without win_ver
    ObjAnimate( "obj_library_mmg_root", 8, 0, 0, function() private.win_books_stand_pos(); ld.Lock(0); end, {0,0,0, 0.25,0,1} );  
  end;

  ld.Lock(1);
  ObjAnimate( "obj_library_mmg_root", 8, 0, 0, func_end, {0,0,1, 0.25,0,0} );  
end;  
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medal" ] = { type = "get", get_obj = "spr_library_medal", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.get_medal_logic = function()
  
end;
private.get_medal_inv = function()
  interface.InventoryItemAdd("inv_medal","spr_library_medal");
end;
private.get_medal_beg = function()
  ObjDelete("gfx_library_medal")
end;
private.get_medal_end = function()
  if common_impl.ZzCompleteCheck("get_medal") then ObjSet( common_impl.hint["get_medal"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_library_anm_book_win", {animfunc = "end_mmg1", frame = 0, pos_z=4 } );
  ObjDelete("spr_housedoctor_tr21");
end;

cmn.AddSubscriber( "get_medal", private.get_medal_inv );
cmn.AddSubscriber( "get_medal", private.get_medal_beg, private.room_objname );
cmn.AddSubscriber( "get_medal", private.get_medal_end, private.room_objname );
cmn.AddSubscriber( "get_medal", private.get_medal_logic );
--------------------------------------------------------------------
function public.get_medal()
  ObjSet( "spr_library_medal", {visible = 1} );
  cmn.SetEventDone( "get_medal" );
  cmn.CallEventHandler( "get_medal" );
  if common_impl.ZzCompleteCheck("get_medal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_brush_zone_clk() --rm_housedoctor.use_brush_zone_clk()
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_brush' );
  end;  
  
  ld.Lock(1);
  SoundSfx( "aud_touch_web_housedoctor" );
  ld.AnimPlay( "anm_library_anm_brush", "cklick_web", func_end )
  
end;  

common_impl.hint[ "use_brush" ] = { type = "use", inv_obj = "inv_brush", use_place = "gfx_library_brush_zone", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.use_brush_logic = function()
  ObjSet( "spr_library_bridle", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_library_mainland1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_library_mainland1", {active=1, visible = 1} );

end;
private.use_brush_inv = function()
  common_impl.ProcessMultiUseAll("brush", "brush")
end;
private.use_brush_beg = function()
  ObjDelete( "gfx_library_brush_zone" );
end;
private.use_brush_end = function()
  if common_impl.ZzCompleteCheck("use_brush") then ObjSet( common_impl.hint["use_brush"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_library_anm_brush");
  ObjSet( "spr_library_bridle_sh", {visible = 1} );
  ObjDelete("spr_housedoctor_tr18");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_brush", private.use_brush_inv );
cmn.AddSubscriber( "use_brush", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush", private.use_brush_logic );
cmn.AddSubscriber( "use_brush_inv", private.use_brush_inv, private.room_objname );
cmn.AddSubscriber( "use_brush_beg", private.use_brush_beg, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_end, private.room_objname );
cmn.AddSubscriber( "use_brush_end", private.use_brush_logic );
--------------------------------------------------------------------------------------------
function public.use_brush( obj )

  local func_end = function()
    ObjSet( "anm_library_anm_brush", {pos_z=5} );
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_brush" );
    cmn.CallEventHandler( "use_brush_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_brush") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_brush_inv" );
  cmn.CallEventHandler( "use_brush_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_library_anm_brush", {pos_z=32} );
  ld.AnimPlay( "anm_library_anm_brush", "use_brush", func_end );
  SoundSfx( "aud_use_brush_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bridle" ] = { type = "get", get_obj = "spr_library_bridle", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.get_bridle_logic = function()
  
end;
private.get_bridle_inv = function()
  interface.InventoryItemAdd("inv_bridle","spr_library_bridle");
end;
private.get_bridle_beg = function()
  ObjDelete("gfx_library_bridle")
end;
private.get_bridle_end = function()
  if common_impl.ZzCompleteCheck("get_bridle") then ObjSet( common_impl.hint["get_bridle"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_library_bridle_sh");
  ObjDelete("spr_housedoctor_tr16");
end;

cmn.AddSubscriber( "get_bridle", private.get_bridle_inv );
cmn.AddSubscriber( "get_bridle", private.get_bridle_beg, private.room_objname );
cmn.AddSubscriber( "get_bridle", private.get_bridle_end, private.room_objname );
cmn.AddSubscriber( "get_bridle", private.get_bridle_logic );
--------------------------------------------------------------------
function public.get_bridle()
  cmn.SetEventDone( "get_bridle" );
  cmn.CallEventHandler( "get_bridle" );
  if common_impl.ZzCompleteCheck("get_bridle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mainland1" ] = { type = "get", get_obj = "spr_library_mainland1", room = "rm_housedoctor", zz = "zz_library", zz_gate = "gzz_housedoctor_library" };

private.get_mainland1_logic = function()
  
end;
private.get_mainland1_inv = function()
  interface.InventoryItemAdd("inv_mainland1","spr_library_mainland1");
end;
private.get_mainland1_beg = function()
  ObjDelete("gfx_library_mainland1")
end;
private.get_mainland1_end = function()
  if common_impl.ZzCompleteCheck("get_mainland1") then ObjSet( common_impl.hint["get_mainland1"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_library_mainland1_sh");
  ObjDelete("spr_housedoctor_tr17");
end;

cmn.AddSubscriber( "get_mainland1", private.get_mainland1_inv );
cmn.AddSubscriber( "get_mainland1", private.get_mainland1_beg, private.room_objname );
cmn.AddSubscriber( "get_mainland1", private.get_mainland1_end, private.room_objname );
cmn.AddSubscriber( "get_mainland1", private.get_mainland1_logic );
--------------------------------------------------------------------
function public.get_mainland1()
  cmn.SetEventDone( "get_mainland1" );
  cmn.CallEventHandler( "get_mainland1" );
  if common_impl.ZzCompleteCheck("get_mainland1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_laboratorydoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_camomile5" ] = { type = "get", get_obj = "spr_laboratorydoor_camomile5", room = "rm_housedoctor", zz = "zz_laboratorydoor", zz_gate = "gzz_housedoctor_laboratorydoor" };

private.get_camomile5_logic = function()
  ObjSet( "gfx_laboratorydoor_laboratorykey_zone", {active=1, input = 1, visible = 1} );
end;
private.get_camomile5_inv = function()
  interface.InventoryItemAdd("inv_camomile","spr_laboratorydoor_camomile5",function() level_inv.ProcessGetCamomileAll( "get_camomile5" ) end);
end;
private.get_camomile5_beg = function()
  ObjDelete("gfx_laboratorydoor_camomile5")
end;
private.get_camomile5_end = function()
  if common_impl.ZzCompleteCheck("get_camomile5") then ObjSet( common_impl.hint["get_camomile5"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_laboratorydoor_back_c");
  ObjDelete("spr_laboratorydoor_camomile5_sh");
  ObjDelete("spr_housedoctor_tr10");
end;

cmn.AddSubscriber( "get_camomile5", private.get_camomile5_inv );
cmn.AddSubscriber( "get_camomile5", private.get_camomile5_beg, private.room_objname );
cmn.AddSubscriber( "get_camomile5", private.get_camomile5_end, private.room_objname );
cmn.AddSubscriber( "get_camomile5", private.get_camomile5_logic );
--------------------------------------------------------------------
function public.get_camomile5()
  cmn.SetEventDone( "get_camomile5" );
  cmn.CallEventHandler( "get_camomile5" );
  if common_impl.ZzCompleteCheck("get_camomile5") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coin" ] = { type = "use", inv_obj = "inv_coin", use_place = "gfx_laboratorydoor_coin_zone", room = "rm_housedoctor", zz = "zz_laboratorydoor", zz_gate = "gzz_housedoctor_laboratorydoor" };

private.use_coin_logic = function()
  --  ObjSet( "spr_laboratorydoor_paw2", { visible = 1, input = 1, active = 1 } )

end;
private.use_coin_inv = function()
  common_impl.ProcessMultiUseAll("coin", "coin")
end;
private.use_coin_beg = function()
  ObjDelete( "gfx_laboratorydoor_coin_zone" );
end;
private.use_coin_end = function()
  if common_impl.ZzCompleteCheck("use_coin") then ObjSet( common_impl.hint["use_coin"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("anm_laboratorydoor_anm_coin")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coin", private.use_coin_inv );
cmn.AddSubscriber( "use_coin", private.use_coin_beg, private.room_objname );
cmn.AddSubscriber( "use_coin", private.use_coin_end, private.room_objname );
cmn.AddSubscriber( "use_coin", private.use_coin_logic );
cmn.AddSubscriber( "use_coin_inv", private.use_coin_inv, private.room_objname );
cmn.AddSubscriber( "use_coin_beg", private.use_coin_beg, private.room_objname );
cmn.AddSubscriber( "use_coin_end", private.use_coin_end, private.room_objname );
cmn.AddSubscriber( "use_coin_end", private.use_coin_logic );
--------------------------------------------------------------------------------------------
function public.use_coin( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coin" );
    cmn.CallEventHandler( "use_coin_end" );
    public.get_paw2()
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coin") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coin_inv" );
  cmn.CallEventHandler( "use_coin_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_laboratorydoor_anm_coin", "use_coin", func_end );
  SoundSfx( "aud_use_coin_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_paw2" ] = { type = "get", get_obj = "spr_laboratorydoor_paw2", room = "rm_housedoctor", zz = "zz_laboratorydoor", zz_gate = "gzz_housedoctor_laboratorydoor" };

private.get_paw2_logic = function()
  
end;
private.get_paw2_inv = function()
  interface.InventoryItemAdd("inv_paw2","spr_laboratorydoor_paw2");
end;
private.get_paw2_beg = function()
  ObjDelete("gfx_laboratorydoor_paw2")
end;
private.get_paw2_end = function()
  if common_impl.ZzCompleteCheck("get_paw2") then ObjSet( common_impl.hint["get_paw2"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_housedoctor_tr11");
end;

cmn.AddSubscriber( "get_paw2", private.get_paw2_inv );
cmn.AddSubscriber( "get_paw2", private.get_paw2_beg, private.room_objname );
cmn.AddSubscriber( "get_paw2", private.get_paw2_end, private.room_objname );
cmn.AddSubscriber( "get_paw2", private.get_paw2_logic );
--------------------------------------------------------------------
function public.get_paw2()
  ObjSet( "spr_laboratorydoor_paw2", {active=1, visible = 1} );
  cmn.SetEventDone( "get_paw2" );
  cmn.CallEventHandler( "get_paw2" );
  if common_impl.ZzCompleteCheck("get_paw2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_laboratorykey_zone_clk()  --rm_housedoctor.use_laboratorykey_zone_clk();
  local func_end = function()
    ld.Lock(0);
    common_impl.ShowBbt( 'need_laboratorykey' )
  end;

  ld.Lock(1);  
  SoundSfx( "aud_touch_handle_housedoctor" );
  ld.AnimPlay( "anm_laboratorydoor_anm_door", "idle_door", func_end )
  
end;  


common_impl.hint[ "use_laboratorykey" ] = { type = "use", inv_obj = "inv_laboratorykey", use_place = "gfx_laboratorydoor_laboratorykey_zone", room = "rm_housedoctor", zz = "zz_laboratorydoor", zz_gate = "gzz_housedoctor_laboratorydoor" };

private.use_laboratorykey_logic = function()
  --if cmn.IsEventDone("use_laboratorykey") and cmn.IsEventDone("get_camomile5") then 
    ObjSet( "gfx_laboratorydoor_clk_onlaboratorykey_zone", { visible = 1, input = 1, active = 1 } )
  -- end;
end;
private.use_laboratorykey_inv = function()
  common_impl.ProcessMultiUseAll("laboratorykey", "laboratorykey")
end;
private.use_laboratorykey_beg = function()
  ObjDelete( "gfx_laboratorydoor_laboratorykey_zone" );
end;
private.use_laboratorykey_end = function()
  if common_impl.ZzCompleteCheck("use_laboratorykey") then ObjSet( common_impl.hint["use_laboratorykey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_laboratorydoor_anm_door", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_housedoctor_tr23", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_laboratorykey", private.use_laboratorykey_inv );
cmn.AddSubscriber( "use_laboratorykey", private.use_laboratorykey_beg, private.room_objname );
cmn.AddSubscriber( "use_laboratorykey", private.use_laboratorykey_end, private.room_objname );
cmn.AddSubscriber( "use_laboratorykey", private.use_laboratorykey_logic );
cmn.AddSubscriber( "use_laboratorykey_inv", private.use_laboratorykey_inv, private.room_objname );
cmn.AddSubscriber( "use_laboratorykey_beg", private.use_laboratorykey_beg, private.room_objname );
cmn.AddSubscriber( "use_laboratorykey_end", private.use_laboratorykey_end, private.room_objname );
cmn.AddSubscriber( "use_laboratorykey_end", private.use_laboratorykey_logic );
--------------------------------------------------------------------------------------------
function public.use_laboratorykey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_laboratorykey" );
    cmn.CallEventHandler( "use_laboratorykey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_laboratorykey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_laboratorykey_inv" );
  cmn.CallEventHandler( "use_laboratorykey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_laboratorydoor_anm_door", "use_key", func_end );
  SoundSfx( "aud_use_laboratorykey_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_onlaboratorykey" ] = { type = "click", use_place = "gfx_laboratorydoor_clk_onlaboratorykey_zone", room = "rm_housedoctor", zz = "zz_laboratorydoor", zz_gate = "gzz_housedoctor_laboratorydoor" };

private.clk_onlaboratorykey_logic = function()
  ObjSet( "grm_housedoctor_laboratory", { visible = 1, input = 1, active = 1 } )
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_housedoctor_laboratory_focus");
  end;
end;
private.clk_onlaboratorykey_beg = function()
  ObjDelete( "gfx_laboratorydoor_clk_onlaboratorykey_zone" );
end;
private.clk_onlaboratorykey_end = function()
  if common_impl.ZzCompleteCheck("clk_onlaboratorykey") then ObjSet( common_impl.hint["clk_onlaboratorykey"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_laboratorydoor_anm_door", {animfunc = "use_key1", frame = 999 } );
  ObjSet( "spr_housedoctor_tr22", {visible = 1} );
  ObjDelete("spr_housedoctor_tr23");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_onlaboratorykey", private.clk_onlaboratorykey_beg, private.room_objname );
cmn.AddSubscriber( "clk_onlaboratorykey", private.clk_onlaboratorykey_end, private.room_objname );
cmn.AddSubscriber( "clk_onlaboratorykey", private.clk_onlaboratorykey_logic );
cmn.AddSubscriber( "clk_onlaboratorykey_beg", private.clk_onlaboratorykey_beg, private.room_objname );
cmn.AddSubscriber( "clk_onlaboratorykey_end", private.clk_onlaboratorykey_end, private.room_objname );
cmn.AddSubscriber( "clk_onlaboratorykey_end", private.clk_onlaboratorykey_logic );
--------------------------------------------------------------------------------------------
function public.clk_onlaboratorykey()

  local func_end = function()
    cmn.SetEventDone( "clk_onlaboratorykey" );
    cmn.CallEventHandler( "clk_onlaboratorykey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_onlaboratorykey") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_onlaboratorykey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_laboratorydoor_anm_door", "use_key1", func_end );
  SoundSfx( "aud_clk_onlaboratorykey_housedoctor" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_nursery *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_notelekar_nursery" ] = { type = "use", inv_obj = "inv_notelekar", use_place = "gfx_nursery_notelekar_nursery_zone", room = "rm_housedoctor", zz = "zz_nursery", zz_gate = "gzz_housedoctor_nursery" };

private.use_notelekar_nursery_logic = function()
  ObjSet( "obj_nursery_mg_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_notelekar_nursery_inv = function()
  --common_impl.ProcessMultiUseAll("notelekar", "notelekar_nursery")
  interface.InventoryItemRemove("inv_notelekar");
end;
private.use_notelekar_nursery_beg = function()
  ObjDelete( "gfx_nursery_notelekar_nursery_zone" );
end;
private.use_notelekar_nursery_end = function()
  if common_impl.ZzCompleteCheck("use_notelekar_nursery") then ObjSet( common_impl.hint["use_notelekar_nursery"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet( "anm_nursery_anm", {animfunc = "paper1", frame = 999 } );
  ObjSet( "spr_housedoctor_paper", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_notelekar_nursery", private.use_notelekar_nursery_inv );
cmn.AddSubscriber( "use_notelekar_nursery", private.use_notelekar_nursery_beg, private.room_objname );
cmn.AddSubscriber( "use_notelekar_nursery", private.use_notelekar_nursery_end, private.room_objname );
cmn.AddSubscriber( "use_notelekar_nursery", private.use_notelekar_nursery_logic );
cmn.AddSubscriber( "use_notelekar_nursery_inv", private.use_notelekar_nursery_inv, private.room_objname );
cmn.AddSubscriber( "use_notelekar_nursery_beg", private.use_notelekar_nursery_beg, private.room_objname );
cmn.AddSubscriber( "use_notelekar_nursery_end", private.use_notelekar_nursery_end, private.room_objname );
cmn.AddSubscriber( "use_notelekar_nursery_end", private.use_notelekar_nursery_logic );
--------------------------------------------------------------------------------------------
function public.use_notelekar_nursery( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_notelekar_nursery" );
    cmn.CallEventHandler( "use_notelekar_nursery_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_notelekar_nursery") then ld.CloseSubRoom() end;
    private.init_nurserydoor()    
    cmn.MiniGameShow( "nurserydoor" );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_notelekar_nursery_inv" );
  cmn.CallEventHandler( "use_notelekar_nursery_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_nursery_anm", "paper1", func_end );
  SoundSfx( "aud_use_notelekar_nursery" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_nurserydoor" ] = { type = "click", use_place = "obj_nursery_mg_root", room = "rm_housedoctor", zz = "zz_nursery", zz_gate = "gzz_housedoctor_nursery" };

private.win_nurserydoor_logic = function()
  if cmn.IsEventDone("win_nurserydoor") then 
     ObjSet( "gho_housedoctor_chimera", { visible = 1, input = 1, active = 1 } )
     interface.InventoryItemAdd("inv_notelekar","spr_nursery_paper");
  end;
end;
private.win_nurserydoor_beg = function()
  -- ObjDelete( "gfx_nursery_win_nurserydoor_zone" );
end;
private.win_nurserydoor_end = function()
  if cmn.IsEventDone("win_nurserydoor") then 
     if common_impl.ZzCompleteCheck("win_nurserydoor") then ObjSet( common_impl.hint["win_nurserydoor"].zz_gate, { visible = 0, input = 0 } ); end;
     ObjSet( "spr_housedoctor_ho", {visible = 1} );
     ObjDelete("anm_nursery_anm");
     ObjDelete("spr_housedoctor_paper");
  end;   
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_nurserydoor", private.win_nurserydoor_beg, private.room_objname );
cmn.AddSubscriber( "win_nurserydoor", private.win_nurserydoor_end, private.room_objname );
cmn.AddSubscriber( "win_nurserydoor", private.win_nurserydoor_logic );
cmn.AddSubscriber( "win_nurserydoor_beg", private.win_nurserydoor_beg, private.room_objname );
cmn.AddSubscriber( "win_nurserydoor_end", private.win_nurserydoor_end, private.room_objname );
cmn.AddSubscriber( "win_nurserydoor_end", private.win_nurserydoor_logic );
--------------------------------------------------------------------------------------------
function public.win_nurserydoor()

  local func_end = function()
    ObjSet( "spr_nursery_paper", {visible = 1} );
    cmn.SetEventDone( "win_nurserydoor" );
    cmn.CallEventHandler( "win_nurserydoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_nurserydoor") then ld.CloseSubRoom() end;
    ld.ShowBbt("after_get_notelekar");
  end;

  cmn.CallEventHandler( "win_nurserydoor_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()
  
  cmn.MiniGameHide( "nurserydoor" ,true); 
  for i=1,7,1 do 
    ObjSet( "spr_nursery_part_"..i.."lg", {color_r=0, color_g=1, color_b=0, alp=0} );
    ObjAnimate( "spr_nursery_part_"..i.."lg", 8, 0, 0, function() end, {0,0,0, 0.5,0,1, 1,0,0} );
  end;  
  ld.StartTimer( 1, func_end );  
  SoundSfx( "aud_mg_nursery_win" );
end;

private.win_nurserydoor_circle_coords = {{-88, -10},{87, -10}}
private.win_nurserydoor_rad = 87;
private.win_nurserydoor_angs = {0,90,180,270};

private.win_nurserydoor_place_pos = {{0,-1},{1,0},{0,1},{-1,0}}

private.win_nurserydoor_fp = {{5,4,6,7},{1,2,3,4}};
private.win_nurserydoor_connect = {2,4};

private.win_nurserydoor_first_init_flag = false;
function private.win_nurserydoor_first_init()
  if private.win_nurserydoor_first_init_flag == false then 
    for i=1,2,1 do 
      -- create circle_root
      ObjCreate("obj_nursery_circle_root_"..i,"obj");
      ObjAttach("obj_nursery_circle_root_"..i,"obj_nursery_mg_root");
      ObjSet( "obj_nursery_circle_root_"..i, {input=0, pos_x = private.win_nurserydoor_circle_coords[i][1], pos_y = private.win_nurserydoor_circle_coords [i][2]  } );
      
      --create little pos 
      
      for j=1,4,1 do 
         ObjCreate("obj_nursery_place_root_"..i.."_"..j,"obj");
         ObjAttach("obj_nursery_place_root_"..i.."_"..j,"obj_nursery_circle_root_"..i);
         ObjSet( "obj_nursery_place_root_"..i.."_"..j, {input=0, pos_x=private.win_nurserydoor_place_pos[j][1]*private.win_nurserydoor_rad, pos_y=private.win_nurserydoor_place_pos[j][2]*private.win_nurserydoor_rad } );
      end;  
    end;  
     
    -- create parts 
   for i=1,7,1 do 
     ObjCreate("spr_nursery_part_"..i,"spr");
     local but_ind = 2; 
     if i==4 then but_ind = 1; end;
     if i>4 then but_ind =  3;  end;
     ObjSet( "spr_nursery_part_"..i, {res = "assets/levels/level/rm_housedoctor/zz_nursery/button"..but_ind} );  
     
     -- create_lights 
     ObjCreate("spr_nursery_part_"..i.."lg","spr");
     ObjSet( "spr_nursery_part_"..i.."lg", {res = "assets/levels/level/rm_housedoctor/zz_nursery/light", alp=0} );  
     ObjAttach( "spr_nursery_part_"..i.."lg",  "spr_nursery_part_"..i);
   end;  
   
   if not cmn.IsEventStart("win_nurserydoor") then 
     for i=1,2,1 do 
       for j=1,4,1 do 
          ObjAttach("spr_nursery_part_"..private.win_nurserydoor_fp[i][j],"obj_nursery_place_root_"..i.."_"..j); 
        end  
      end;  
   else
      private.win_nurserydoor_stand_pos();  
   end;
  
    
  end;
  private.win_nurserydoor_first_init = true;  
end;  



function private.init_nurserydoor()
  --private.win_books_first_init();
  if not (cmn.IsEventStart("win_nurserydoor")) then
    ng_global.progress["std"]["win_nurserydoor"].state = {}
    -- private.win_books_state= ld.TableCopy(private.win_books_fp_array);
    ng_global.progress["std"]["win_nurserydoor"].state = ld.TableCopy(private.win_nurserydoor_fp);
  else  
    --private.win_books_state=ng_global.progress["std"]["win_books"].state;
  end
  private.win_nurserydoor_stand_pos();  
end

function private.win_nurserydoor_stand_pos(without_win_ver)
  for i=1,2,1 do 
    ObjSet( "obj_nursery_circle_root_"..i, { ang=0} );
    for j=1,4,1 do 
      ObjAttach("spr_nursery_part_"..ng_global.progress["std"]["win_nurserydoor"].state[i][j],"obj_nursery_place_root_"..i.."_"..j); 
      ObjSet( "obj_nursery_place_root_"..i.."_"..j, {ang=0} );
    end  
  end;  
  
  if without_win_ver~=1 then private.win_nurserydoor_win_ver(); end;
end;  


function private.win_nurserydoor_win_ver()
  local count=0;
  for i=1,2,1 do 
    for j=1,4,1 do 
      if private.win_nurserydoor_connect[i]~=j then 
         if i==1 and ng_global.progress["std"]["win_nurserydoor"].state[i][j]>=1 and ng_global.progress["std"]["win_nurserydoor"].state[i][j]<=3 then 
           count=count+1;
         elseif i==2 and  ng_global.progress["std"]["win_nurserydoor"].state[i][j]>=5 and ng_global.progress["std"]["win_nurserydoor"].state[i][j]<=7 then 
            count=count+1;
         end;  
      end;  
    end;  
  end;  

  if count == 6 then  public.win_nurserydoor(); end;  
end



function  public.win_nurserydoor_button_mdown(num) --1 bkue, 2 red  --rm_housedoctor.win_nurserydoor_button_mdown()
  
  local func_end = function()
    local buf = ng_global.progress["std"]["win_nurserydoor"].state[num][4];
    for i=3,1,-1 do 
      ng_global.progress["std"]["win_nurserydoor"].state[num][i+1] = ld.TableCopy(ng_global.progress["std"]["win_nurserydoor"].state[num][i]); 
    end; 
    ng_global.progress["std"]["win_nurserydoor"].state[num][1] = buf; 
    
    local othernum = 2; 
    if num == 2 then othernum=1; end;
    ng_global.progress["std"]["win_nurserydoor"].state[othernum][ private.win_nurserydoor_connect[ othernum ] ] = ld.TableCopy(ng_global.progress["std"]["win_nurserydoor"].state[num][ private.win_nurserydoor_connect[ num ] ]);
    ld.Lock(0);
    private.win_nurserydoor_stand_pos();
  end;  
  
  
  ld.Lock(1);
  local move_ang = -math.pi/2;
  local attached_part = ng_global.progress["std"]["win_nurserydoor"].state[num][private.win_nurserydoor_connect[num] ];
  ObjAttach("spr_nursery_part_"..attached_part, "obj_nursery_place_root_"..num.."_"..private.win_nurserydoor_connect[num] )
  
  for i=1,4,1 do 
    ObjAnimate( "obj_nursery_place_root_"..num.."_"..i, 7, 0, 0, function() end, {0,0,0, 0.3,0,-move_ang} );
  end;  
  ObjAnimate( "obj_nursery_circle_root_"..num, 7, 0, 0, func_end, {0,0,0, 0.3,0,move_ang} );
  
  local color_ar = {"blue","red"}
  ObjAnimate( "spr_nursery_"..color_ar[num], 6, 0, 0, function() end, {0,0,1,1, 0.15,0,0.8,0.8, 0.3,0,1,1} );
  SoundSfx( "aud_mg_nursery_rotate" );  
end;  
  
  
function public.win_nurserydoor_reset()
  local func_end = function()
    ng_global.progress["std"]["win_nurserydoor"].state = ld.TableCopy(private.win_nurserydoor_fp);
    private.win_nurserydoor_stand_pos();
    ObjAnimate( "obj_nursery_mg_root", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.3,0,1} ); 
  end
  
  ld.Lock(1);
  ObjAnimate( "obj_nursery_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;  
 

function public.win_nurserydoor_skip()
  local func_end = function()
    ng_global.progress["std"]["win_nurserydoor"].state = {{1,4,2,3},{5,6,7,4}};
    private.win_nurserydoor_stand_pos(1);
    ObjAnimate( "obj_nursery_mg_root", 8, 0, 0, function() private.win_nurserydoor_stand_pos(); end, {0,0,0, 0.3,0,1} ); 
  end
  
  ld.Lock(1);
  ObjAnimate( "obj_nursery_mg_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
end;   
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_chimera_for_housedoctor = function()
    if ld.CheckRequirements( {"win_chimera"} ) then
      ObjSet( "gho_housedoctor_chimera", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_chimera", win_chimera_for_housedoctor, private.room_objname )

end;
--*********************************************************************************************************************
------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_library" ) and not ld.CheckRequirements( { "win_books" } ) then  
    private.win_books_reset()
  end;

  if ( mg_name == "zz_nursery" ) and not ld.CheckRequirements( { "win_nurserydoor" } ) then  
    public.win_nurserydoor_reset()
  end;
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
  
  if ( mg_name == "zz_library" ) and not ld.CheckRequirements( { "win_books" } ) then
    private.win_books_skip()
  end;
  
  if ( mg_name == "zz_nursery" ) and not ld.CheckRequirements( { "win_nurserydoor" } ) then  
    public.win_nurserydoor_skip()
  end;
end
--*********************************************************************************************************************

function public.Load()
  if not cmn.IsEventDone("win_nurserydoor") then 
     private.win_nurserydoor_first_init();
  end;  
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_housedoctor();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_housedoctor_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_nursery" );
  function zz_nursery.Open()
    if cmn.IsEventStart("win_nurserydoor") and not cmn.IsEventDone("win_nurserydoor") then 
        cmn.MiniGameShow( "nurserydoor" ); 
        private.init_nurserydoor()
    end;  
  end;
  function zz_nursery.PreOpen()
  end;
  function zz_nursery.PreClose()
  end;
  function zz_nursery.Close()
    if cmn.IsEventStart("win_nurserydoor") and not cmn.IsEventDone("win_nurserydoor") then 
       cmn.MiniGameHide( "nurserydoor" ); 
    end; 
  end;

  subroom.Define( "zz_laboratorydoor" );
  function zz_laboratorydoor.Open()
  end;
  function zz_laboratorydoor.PreOpen()
  end;
  function zz_laboratorydoor.PreClose()
  end;
  function zz_laboratorydoor.Close()
  end;

  subroom.Define( "zz_library" );
  function zz_library.Open()
  end;
  function zz_library.PreOpen()
     if not cmn.IsEventDone("win_books") then 
       private.win_books_first_init();
     end; 
    
    
      if cmn.IsEventStart("win_books") and not cmn.IsEventDone("win_books") then 
        cmn.MiniGameShow( "books" ); 
        private.init_books()
     end;  
  end;
  function zz_library.PreClose()
  end;
  function zz_library.Close()
    if cmn.IsEventStart("win_books") and not cmn.IsEventDone("win_books") then 
       cmn.MiniGameHide( "books" ); 
    end; 
  end;

  subroom.Define( "zz_chest" );
  function zz_chest.Open()
  end;
  function zz_chest.PreOpen()
  end;
  function zz_chest.PreClose()
  end;
  function zz_chest.Close()
  end;

  subroom.Define( "zz_elk" );
  function zz_elk.Open()
  end;
  function zz_elk.PreOpen()
  end;
  function zz_elk.PreClose()
  end;
  function zz_elk.Close()
  end;
  
end;
--*********************************************************************************************************************