-- name=mg_demonriddleext
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_demonriddleext";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_demonriddleext" ] = {type = "win", use_place = "mg_demonriddleext", room = "rm_cryptext", zz = "mg_demonriddleext", zz_gate = "gmg_cryptext_demonriddleext" };

  local win_demonriddleext_logic = function()
    if ld.CheckRequirements( {"win_demonriddleext"} ) then
      ObjSet( "spr_demonriddleext_demonsignext", {active=1, input = 1, visible=0} );
      ObjSet( "gfx_demonriddleext_demonsignext", {active = 1, visible = 1} );
    end
  end;
  local win_demonriddleext = function()
    if ld.CheckRequirements( {"win_demonriddleext"} ) then
      ObjDelete("spr_demonriddleext_panel");
      ObjSet( "obj_demonriddleext_lvl3_root", {input = 0, alp=1, visible = 1} );
      for i=1,4,1 do 
        for j=1,4,1 do 
          ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[i]..j, {alp=0, input=0} );
        end;  
      end;  
      for i=1,4,1 do 
         ObjSet( "spr_demonriddleext_a"..i, {alp=1} );
      end;
       
      ObjSet( "anm_demonriddleext_anm_demon", {visible=1, animfunc = "giv", frame = 999, playing=0 } );
      ObjDelete("obj_demonriddleext_lipsyng_root"); 
    end
  end;
  cmn.AddSubscriber("win_demonriddleext", win_demonriddleext, private.room_objname )
  cmn.AddSubscriber("win_demonriddleext", win_demonriddleext_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_demonsignext" ] = { type = "get", get_obj = "spr_demonriddleext_demonsignext", room = "rm_cryptext", zz = "mg_demonriddleext", zz_gate = "gmg_cryptext_demonriddleext" };

private.get_demonsignext_logic = function()
  ObjSet( "gmg_cryptext_demonriddleext", {active=0, input=0, visible=0} );
  ObjSet( "grm_cryptext_toyworldext", { active = 1, input = 1, visible = 1} );
  if port.isPortable() == 1 then
    port.GrmEventLightOn("grm_cryptext_toyworldext_focus");
  end;
  ObjSet( "obj_cryptext_lekar_clk2_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "anm_cryptext_anm_back", {animfunc = "man", frame = 0, playing = 1 } );
end;
private.get_demonsignext_inv = function()
  interface.InventoryItemAdd("inv_demonsignext","spr_demonriddleext_demonsignext");
end;
private.get_demonsignext_beg = function()
  ObjDelete("gfx_demonriddleext_demonsignext")
end;
private.get_demonsignext_end = function()
  
end;

cmn.AddSubscriber( "get_demonsignext", private.get_demonsignext_inv );
cmn.AddSubscriber( "get_demonsignext", private.get_demonsignext_beg, private.room_objname );
cmn.AddSubscriber( "get_demonsignext", private.get_demonsignext_end, private.room_objname );
cmn.AddSubscriber( "get_demonsignext", private.get_demonsignext_logic );
--------------------------------------------------------------------
function public.get_demonsignext()
  ld.Lock(1);
  ObjSet( "spr_demonriddleext_demonsignext", {visible = 1} );
  cmn.CallEventHandler( "get_demonsignext" );
  
  ld.AnimPlay( "anm_demonriddleext_anm_demon", "giv1", function()
    ld.Lock(0);
    cmn.SetEventDone( "get_demonsignext" );
    if common_impl.ZzCompleteCheck( "get_demonsignext" ) then cmn.GotoRoom( "rm_cryptext" ); end;
    end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;


local vids_time_array={2,2,2,12}
local vids_array = {"_barnes_14_voc","_barnes_15_voc","_barnes_16_voc","_barnes_17_voc"};
local demonriddleext_chimeraman_dialogs_name="tsk_demonriddleext_chimeraman_dlg";
function public.demonriddleext_chimeraman_dialogs(num)
  local func_end2 = function()
    if num==4 then 
      ld.Lock(1);
      SoundSfx( "aud_get_to_us" )
      ld.AnimPlay( "anm_demonriddleext_anm_demon", "giv", function() private.Win(); end);  
    else    
      ld.Lock(0);    
    end;  
  end;  
  
  local func_end = function()
    ObjSet( "txt_demonriddleext_panel", {text="tsk_demonriddleext_chimeraman_dlg"..num} );
    ObjAnimate( "txt_demonriddleext_panel", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
    
    SoundVoice("aud"..vids_array[num]);
    --  ld.LogTrace( "vid_demonriddleext"..vids_array[num] );
    VidPlay("vid_demonriddleext"..vids_array[num], func_end2); 
  end;  
  
  if num>1 then ObjDetach("vid_demonriddleext"..vids_array[num-1]); end;
  ObjAttach("vid_demonriddleext"..vids_array[num],"obj_demonriddleext_lipsyng_root");
  SoundVoice(0);
  ld.Lock(1);
  ObjAnimate( "txt_demonriddleext_panel", 8, 0, 0, func_end, {0,0,ObjGet("txt_demonriddleext_panel").alp, 0.3,0,0} );
end;  



private.demonriddleext_lvl1_part_win_pos = {{152,124},{266,107},{388,126},{481,124},{134,210},{232,189},{374,205},{479,209},{156,313},{246,312},{360,311},{481,329},{145,408},{257,411},{364,408},{462,420}};
private.demonriddleext_fp_lvl1 = {};

private.demonriddleext_lvl2_color_array={"blue","dark_blu","brown","ocher","purple","magenta","dark_brown","silver","sapphirine"};
private.demonriddleext_lvl2_parts_count={5,5,3,4,4,5,4,4,4};
private.demonriddleext_fp_lvl2 = {};

private.demonriddleext_lvl3_part_index_array = {"a","b","c","d"};

private.demonriddleext_first_init_flag = false;
function private.demonriddleext_first_init()
  if private.demonriddleext_first_init_flag==false then 
    --- lvl 1
    -- create drop zones for puzlles
      for i=1,#private.demonriddleext_lvl1_part_win_pos,1 do 
        ObjCreate("obj_demonriddleext_part_drop_zone_"..i,"obj");
        ObjAttach("obj_demonriddleext_part_drop_zone_"..i,"obj_demonriddleext_lvl1_root");
        ObjSet( "obj_demonriddleext_part_drop_zone_"..i, {inputrect_init=1, inputrect_w=20, inputrect_h=20, inputrect_x=-10, inputrect_y=-10, pos_x=private.demonriddleext_lvl1_part_win_pos[i][1], pos_y = private.demonriddleext_lvl1_part_win_pos[i][2], input=1 } );
      end;
    -- create apply zones for puzzles
       for i=1,#private.demonriddleext_lvl1_part_win_pos,1 do 
         ObjCreate("obj_demonriddleext_part_apply_zone_"..i,"obj");
         ObjAttach("obj_demonriddleext_part_apply_zone_"..i,"spr_demonriddleext_f"..i);
         ObjSet( "obj_demonriddleext_part_apply_zone_"..i, {inputrect_init=1, inputrect_w=30, inputrect_h=30, inputrect_x=-15, inputrect_y=-15, input=0 } );
      end;
    --- select parts_fp and angles 
       for i=1,#private.demonriddleext_lvl1_part_win_pos,1 do 
          local obj = ObjGet("spr_demonriddleext_f"..i);
          private.demonriddleext_fp_lvl1[i]={obj.pos_x, obj.pos_y, obj.ang};
       end;    
    ---- off parts lights and set events  
      for i=1,#private.demonriddleext_lvl1_part_win_pos,1 do 
        ObjSet( "spr_demonriddleext_f"..i.."_lig", {alp=0, color_r=102/255, color_g=102/255, color_b=122/255} );
        ObjSet( "spr_demonriddleext_f"..i, {input=1, event_menter="ld.SetCursor(CURSOR_HAND)", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="mg_demonriddleext.demonriddleext_puzzle_mdown("..i..");", event_startdrag="mg_demonriddleext.demonriddleext_puzzle_startdrag("..i..");", event_dragdrop="mg_demonriddleext.demonriddleext_dragdrop("..i..");"} );
      end;  
    -----
    for i=1,3,1 do 
      ObjSet( "obj_demonriddleext_lvl"..i.."_root", {alp=0, input=0, visible=1} );
    end;  
    
    
    ---------------- lvl 2
    -- alp=0
    for i=1,#private.demonriddleext_lvl2_parts_count,1 do 
      private.demonriddleext_fp_lvl2[i]={};
      for j=1,private.demonriddleext_lvl2_parts_count[i],1 do 
        private.demonriddleext_fp_lvl2[i][j]=0;
        ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j, {alp=0, input=0, pos_z=10} );
      end;  
    end;  
    -- brush color alp=0
    for i=1,9,1 do 
      ObjSet( "spr_demonriddleext_smear1", {alp=0, input=0} );
    end;  
    
    --- brush sets 
    ObjSet( "spr_demonriddleext_tassel", {event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);", event_mdown="mg_demonriddleext.demonriddleext_brush_mdown();", event_startdrag = "mg_demonriddleext.demonriddleext_brush_startdrag();", event_dragdrop="mg_demonriddleext.demoriddle_brush_dragdrop();"} );
    ObjSet( "spr_demonriddleext_tassel", {input=1 } );   
    
    
    --------------------- lvl 3
    --- alp=0;
    for i=1,4,1 do 
      for j=1,4,1 do 
        ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[i]..j, {alp=0, input=0} );
      end;  
    end;  
    
    ------ events and arrow lights 
    for i=1,4,1 do 
      for j=1,2,1 do 
        ObjSet( "spr_demonriddleext_lig_arrow"..i.."_"..j, {alp=0, input=0} );
        
        ObjSet( "spr_demonriddleext_arrow"..i.."_"..j, {input=1, event_mdown="mg_demonriddleext.demonriddleext_arrow_mdown("..i..","..j..");", event_menter="mg_demonriddleext.demonriddleext_arrow_menter("..i..","..j..");", event_mleave="mg_demonriddleext.demonriddleext_arrow_mleave("..i..","..j..");"} );
      end;  
    end;  
  end;
  private.demonriddleext_first_init_flag = true;  
end;  

----------------------------------------------------------
function private.demonriddleext_stand_on_pos_lvl(skip_stand_lvl3)  
  local cur_level = ng_global.progress["ext"]["win_demonriddleext"].state[1];
  if cur_level == 1 then
    public.demonriddleext_chimeraman_dialogs(1);
    ObjSet( "obj_demonriddleext_lvl1_root", {input=1, alp=1, visible = 1} );
    private.demonriddleext_stand_on_pos_lvl1();
  elseif cur_level == 2 then  
    public.demonriddleext_chimeraman_dialogs(2); 
    ObjSet( "obj_demonriddleext_lvl1_root", {input=0, alp=0, visible = 0} );
    ObjSet( "obj_demonriddleext_lvl2_root", {input=1, alp=1, visible = 1} );
    private.demonriddleext_stand_on_pos_lvl2();
  elseif cur_level == 3 then   
    public.demonriddleext_chimeraman_dialogs(3);
    ObjSet( "obj_demonriddleext_lvl1_root", {input=0, alp=0, visible = 0} );
    ObjSet( "obj_demonriddleext_lvl2_root", {input=0, alp=0, visible = 0} );
    if skip_stand_lvl3~=1 then 
      ObjSet( "obj_demonriddleext_lvl3_root", {input=1, alp=1, visible = 1} );
      private.demonriddleext_stand_on_pos_lvl3();
    else 
      ObjSet( "obj_demonriddleext_lvl3_root", {input=1, alp=0, visible = 1} );
      private.demonriddleext_stand_on_pos_lvl3(1);
    end;  
  elseif cur_level == 4 then   
    if skip_stand_lvl3 ~=1 then
        public.demonriddleext_chimeraman_dialogs(4);
        ObjSet( "obj_demonriddleext_lvl3_root", {input = 0, alp=1} );
    end;
    for i=1,4,1 do 
      ObjSet( "spr_demonriddleext_a"..i, {alp=1} );
      ObjSet( "spr_demonriddleext_lig_a"..i, {alp=0} );
    end;
  end;  
  
end;

function private.demonriddleext_stand_on_pos_lvl1()
  local count=0;
  for i=1,#private.demonriddleext_lvl1_part_win_pos,1 do 
    ObjSet( "spr_demonriddleext_f"..i.."_lig", {alp=0} );
    ObjSet( "spr_demonriddleext_f"..i, {pos_x=ng_global.progress["ext"]["win_demonriddleext"].state[2][i][1], pos_y=ng_global.progress["ext"]["win_demonriddleext"].state[2][i][2], pos_z=5, ang=ng_global.progress["ext"]["win_demonriddleext"].state[2][i][3], input=1} );
    
    local ang = 0;
    if ng_global.progress["ext"]["win_demonriddleext"].state[2][i][1]==private.demonriddleext_lvl1_part_win_pos[i][1] and ng_global.progress["ext"]["win_demonriddleext"].state[2][i][2]==private.demonriddleext_lvl1_part_win_pos[i][2] then 
      count=count+1;
      ang=0;
      ObjSet( "spr_demonriddleext_f"..i,{input=0, ang=0});
    end;  
  end;  
  if count==#private.demonriddleext_lvl1_part_win_pos then private.demonridleext_win_lvl1(); end;
end;  


function public.demonriddleext_puzzle_mdown(num) --mg_demonriddleext.demonriddleext_puzzle_mdown()
  SoundSfx( "aud_mg_demonriddleext_get_puzzle" );

  
  ObjStartDrag("spr_demonriddleext_f"..num);
  ld.Lock(1);
  ObjSet("spr_demonriddleext_f"..num, {pos_z=30} );
  ObjAnimate( "spr_demonriddleext_f"..num.."_lig", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
  ObjAnimate( "spr_demonriddleext_f"..num, 7, 0, 0, function() ld.Lock(0); end, {0,0,ObjGet("spr_demonriddleext_f"..num).ang, 0.3,0,0} );
end;  

function public.demonriddleext_puzzle_startdrag(num) --mg_demonriddleext.demonriddleext_puzzle_startdrag(num);
  ld.SetCursor(CURSOR_HAND);
end;  

function public.demonriddleext_dragdrop(num) --mg_demonriddleext.demonriddleext_dragdrop(num);
  if ApplyObj( "obj_demonriddleext_part_apply_zone_"..num,"obj_demonriddleext_part_drop_zone_"..num ) then
      SoundSfx( "aud_mg_demonriddleext_put_right_puzzle" );
      ObjSet( "spr_demonriddleext_f"..num, {pos_x = private.demonriddleext_lvl1_part_win_pos[num][1], pos_y = private.demonriddleext_lvl1_part_win_pos[num][2], pos_z=5, ang=0} );
      ObjSet(  "spr_demonriddleext_f"..num.."_lig", {alp=0} );
      ng_global.progress["ext"]["win_demonriddleext"].state[2][num]={private.demonriddleext_lvl1_part_win_pos[num][1],private.demonriddleext_lvl1_part_win_pos[num][2],0};
  else    
      SoundSfx( "aud_mg_demonriddleext_put_puzzle" );      
    ld.Lock(1); 
    local cursor = GetZoomCursorPos();  
    
    ObjAnimate( "spr_demonriddleext_f"..num, 3, 0, 0, function() end, {0,0,cursor[1],cursor[2], 0.5,0, ng_global.progress["ext"]["win_demonriddleext"].state[2][num][1], ng_global.progress["ext"]["win_demonriddleext"].state[2][num][2]} );
    ObjAnimate( "spr_demonriddleext_f"..num, 7, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0, ng_global.progress["ext"]["win_demonriddleext"].state[2][num][3]} );
  end;
  ld.SetCursor(CURSOR_DEFAULT);  
  private.demonriddleext_stand_on_pos_lvl1();
end;  


function private.demonridleext_win_lvl1()
  local func_end = function()
    ld.Lock(0);
    SoundSfx( "aud_mg_demonriddleext_win_puzzles" ); 
    private.demonriddleext_stand_on_pos_lvl();  
  end;  
  
  ng_global.progress["ext"]["win_demonriddleext"].state[1]=2;
  ng_global.progress["ext"]["win_demonriddleext"].state[2]=ld.TableCopy(private.demonriddleext_fp_lvl2);
 -- private.demonriddleext_stand_on_pos_lvl2();
 -- ld.LogTrace( ng_global.progress["ext"]["win_demonriddleext"].state );
  ld.Lock(1);
  
  ObjAnimate( "obj_demonriddleext_lvl1_root", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjAnimate( "obj_demonriddleext_lvl2_root", 8, 0, 0, function() func_end(); end, {0,0,0, 0.5,0,1} );  
end;  
 ------------------------ level 2 

function private.demonriddleext_stand_on_pos_lvl2()
  for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2],1 do 
    for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do 
      if ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]==1 then
         ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j, {alp=1} );
      else
         ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j, {alp=0} );
      end;
    end;  
  end; 
  private.demonriddleext_set_color();
  private.demonriddleext_win_ver(); 
end; 
  
------------------- brush--- 
private.demonriddleext_select_color=0; 

function private.demonriddleext_set_color()
  for i=1,#private.demonriddleext_lvl2_color_array,1 do 
    if private.demonriddleext_select_color==i then 
      ObjSet( "spr_demonriddleext_smear"..i, {alp=1} );
    else  
      ObjSet( "spr_demonriddleext_smear"..i, {alp=0} );
    end;
  end;  
end;  

function public.demonriddleext_brush_mdown()  --mg_demonriddleext.demonriddleext_brush_mdown();
  SoundSfx( "aud_mg_demonriddleext_get_brush" ); 
  ObjSet( "spr_demonriddleext_sh_tassel", {alp=0} ); 
  ObjStartDrag("spr_demonriddleext_tassel");
  ObjAnimate( "spr_demonriddleext_tassel", 7, 0, 0, function()  end, {0,0,0, 0.2,0,0.6} );
end;  

private.demonriddleext_brush_drag_flag = false;  
function public.demonriddleext_brush_startdrag() --mg_demonriddleext.demonriddleext_brush_startdrag();
  ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); end );
  ObjSet("spr_demonriddleext_tassel", {pos_z=40});
  private.demonriddleext_brush_drag_flag=true;
end;  

function public.demoriddle_brush_dragdrop(fast_drop) --mg_demonriddleext.demoriddle_brush_dragdrop()
  local dontstop_flag = false;
  
  if fast_drop~=1 then 
        ----palitra
        for i=1,#private.demonriddleext_lvl2_color_array,1 do 
          if ApplyObj("obj_demonriddleext_brush_end","obj_demonriddleext_palitra_"..i) then 
             dontstop_flag = true;
             private.demonriddleext_select_color = i;
             private.demonriddleext_set_color();
             SoundSfx( "aud_mg_demonriddleext_dive_brush" ); 
          end;  
        end;  
         
        ------ picture 
        local picture_ap_flag = false;
        local right_picture_ap_flag = false;
        local right_picture_ap_nums={0,0};
        for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2],1 do 
          for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do 
            if ApplyObj("obj_demonriddleext_brush_end","spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j) then 
            --  ld.LogTrace( "________________________________________________" );
            --  ld.LogTrace( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j );
            --  ld.LogTrace( "private.demonriddleext_select_color = "..private.demonriddleext_select_color );
            --  ld.LogTrace( "i = "..i );
            --  ld.LogTrace( "ng_global.progress[ext][win_demonriddleext].state[2]["..i.."]["..j.."] = "..ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j] );
              dontstop_flag = true;
              -- if right color 
              picture_ap_flag = true;  
              if i==private.demonriddleext_select_color and ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]==0 then 
                 right_picture_ap_flag=true;
                 right_picture_ap_nums={i,j};
                -- ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]=1;
                -- ld.Lock(1); ld.SetCursor(CURSOR_NULL); ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j, 8, 0, 0, function() ld.Lock(0);  ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); end ); end, {0,0,0, 0.2,0,1} );
              else 
                  -- ld.Lock(1); ld.SetCursor(CURSOR_NULL); ObjAnimate( "spr_demonriddleext_f", 12, 0, 0, function() ld.Lock(0); ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); end ); end, {0,0,1,1,1, 0.2,0,1,0,0, 0.4,0,1,1,1} );
              end;  
            end;  
          end;  
        end;
            
        if picture_ap_flag==true and right_picture_ap_flag==true then 
            SoundSfx( "aud_mg_demonriddleext_true_paint" );
            ng_global.progress["ext"]["win_demonriddleext"].state[2][right_picture_ap_nums[1] ][right_picture_ap_nums[2] ]=1;
            ld.Lock(1); ld.SetCursor(CURSOR_NULL); ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[right_picture_ap_nums[1] ]..right_picture_ap_nums[2], 8, 0, 0, function() ld.Lock(0);  ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); private.demonriddleext_win_ver(); end ); end, {0,0,0, 0.2,0,1} );
        elseif picture_ap_flag==true and right_picture_ap_flag==false then 
            SoundSfx( "aud_mg_demonriddleext_wrong_paint" );
            ld.Lock(1); ld.SetCursor(CURSOR_NULL); ObjAnimate( "spr_demonriddleext_f", 12, 0, 0, function() ld.Lock(0); ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); end ); end, {0,0,1,1,1, 0.2,0,1,0,0, 0.4,0,1,1,1} );  
        end;    
    
  end;    
  ----------- ver dontstop_flag
  if dontstop_flag==true then 
    local obj=ld.TableCopy(ObjGet("spr_demonriddleext_tassel"));
    local cursor = GetZoomCursorPos();  
    ObjSet( "spr_demonriddleext_tassel", {pos_x=cursor[1], pos_y=cursor[2], event_menter="ld.SetCursor(CURSOR_NULL);", event_mleave="ld.SetCursor(CURSOR_NULL);"} );
    ld.StartTimer( 0.01, function() ld.SetCursor(CURSOR_NULL); 
                                    ObjStartDrag("spr_demonriddleext_tassel");
                                    ObjSet( "spr_demonriddleext_tassel", {pos_x=obj.pos_x, pos_y=obj.pos_y, event_menter="ld.SetCursor(CURSOR_HAND);", event_mleave="ld.SetCursor(CURSOR_DEFAULT);"} );
      end ) 
  else 
     local func_end = function() 
        private.demonriddleext_brush_drag_flag=false;
        if fast_drop~=1 then  ld.Lock(0); private.demonriddleext_stand_on_pos_lvl2(); end;
        ObjSet( "spr_demonriddleext_sh_tassel", {alp=1} );
        ld.SetCursor(CURSOR_DEFAULT);
     end;
     SoundSfx( "aud_mg_demonriddleext_put_brush" );
     ld.Lock(1); 
     local cursor = GetZoomCursorPos();  
     ObjAnimate( "spr_demonriddleext_tassel", 7, 0, 0, function() end, {0,0,0.6, 0.2,0,0} );
     ObjAnimate( "spr_demonriddleext_tassel", 3, 0, 0, func_end, {0,0,cursor[1],cursor[2], 0.3,0,ObjGet("spr_demonriddleext_tassel").pos_x, ObjGet("spr_demonriddleext_tassel").pos_y} );
  end;  
end;  
 
function private.demonriddleext_win_ver()
  local all_count=0;
  local count = 0;
  local func_end=function()
    ld.Lock(1);  ld.StartTimer( 1, function() SoundSfx( "aud_mg_demonriddleext_win_paint" );private.demonriddleext_win_lvl2(); end )
  end
  
  for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2],1 do 
    for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do 
      all_count=all_count+1;
      if ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]==1 then count=count+1; end;
    end;  
  end;  
  
  if all_count>0 and all_count==count then 
    if private.demonriddleext_brush_drag_flag==true then 
      ObjSet( "spr_demonriddleext_tassel", {event_dragdrop="mg_demonriddleext.demoriddle_brush_dragdrop(1);"} );
      ObjStopDrag("spr_demonriddleext_tassel");
      func_end();
    else 
      func_end();
    end;  
  end;  
end;  
 

function private.demonriddleext_win_lvl2()
  local func_end = function()
    ld.Lock(0);
    private.demonriddleext_stand_on_pos_lvl();  
  end;  
  
  ng_global.progress["ext"]["win_demonriddleext"].state[1]=3;
  ng_global.progress["ext"]["win_demonriddleext"].state[2]=ld.TableCopy( private.demonridleext_fp_lvl3);
  private.demonriddleext_stand_on_pos_lvl3();
 -- private.demonriddleext_stand_on_pos_lvl2();
  ld.Lock(1);
  
  ObjAnimate( "obj_demonriddleext_lvl2_root", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjAnimate( "obj_demonriddleext_lvl3_root", 8, 0, 0, function() func_end(); end, {0,0,0, 0.5,0,0, 1,0,1} );  
  ld.AnimPlay( "anm_demonriddleext_anm_demon_list", "list", function() end )  
end;  
  -------------------------------------- lvl 3 ---------------------
  
private.demonridleext_fp_lvl3={4,2,3,2};

function  private.demonriddleext_stand_on_pos_lvl3(without_win_ver)
  for i=1,4,1 do 
    for j=1,4,1 do 
      if ng_global.progress["ext"]["win_demonriddleext"].state[2][i]==j then 
        ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[j]..i, {alp=1} );
      else 
        ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[j]..i, {alp=0} );
      end;  
    end;  
  end;
  if without_win_ver~=1 then private.demonriddleext_win_ver_lvl3(); end; 
end;  
  
function public.demonriddleext_arrow_menter(num1,num2) --mg_demonriddleext.demonriddleext_arrow_menter(i,j);
  ld.SetCursor(CURSOR_HAND);
  ObjSet( "spr_demonriddleext_lig_arrow"..num1.."_"..num2, {alp=1} );
end;  

function public.demonriddleext_arrow_mleave(num1,num2) --mg_demonriddleext.demonriddleext_arrow_mleave(i,j);
  ld.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_demonriddleext_lig_arrow"..num1.."_"..num2, {alp=0} );
end; 
 
function public.demonriddleext_arrow_mdown(num1,num2) --mg_demonriddleext.demonriddleext_arrow_mdown(i,j);
  local cur_part = ng_global.progress["ext"]["win_demonriddleext"].state[2][num1];
  local coef = 0;
  if num2==1 then coef=1 else coef=-1; end;
  local next_part=cur_part+coef;
  if next_part==0 then next_part=4; end;
  if next_part==5 then next_part=1; end; 
  
  local func_end = function()
    ld.Lock(0);
    ng_global.progress["ext"]["win_demonriddleext"].state[2][num1]=next_part;  
    if ng_global.progress["ext"]["win_demonriddleext"].state[2][num1] == 1 then
      SoundSfx( "aud_mg_demonriddleext_light_part" );
    end
    private.demonriddleext_stand_on_pos_lvl3();
  end;  
  SoundSfx( "aud_mg_demonriddleext_change_part" );
  
  ld.Lock(1);
  ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[cur_part]..num1, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[next_part]..num1, 8, 0, 0, func_end, {0,0,0, 0.3,0,1} ); 
  
end;  

function private.demonriddleext_win_ver_lvl3()
  local count=0;
  for i=1,4,1 do 
    if ng_global.progress["ext"]["win_demonriddleext"].state[2][i]==1 then count=count+1; end;
  end;  
  
  if count==4 then private.demonriddleext_win_lvl3(); end;
end;  

function private.demonriddleext_win_lvl3()
  local func_end = function()
    --ld.Lock(0);
    ObjSet( "obj_demonriddleext_lvl3_root", {input = 0} );
    ng_global.progress["ext"]["win_demonriddleext"].state={4,0};
    private.demonriddleext_stand_on_pos_lvl();  
  end;
  
  ld.Lock(1);
  for i=1,4,1 do 
    ObjAnimate("spr_demonriddleext_lig_a"..i ,8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
  end;  
  ld.StartTimer( 0.51, func_end )  
end;  
----------------------------SKIP RESET  
 function public.demonridleext_reset()
  local cur_level = ng_global.progress["ext"]["win_demonriddleext"].state[1];
  if cur_level==1 then 
    local func_end = function()
      ld.Lock(0);
    end;  
    
    ld.Lock(1);
    ng_global.progress["ext"]["win_demonriddleext"].state = {1,ld.TableCopy(private.demonriddleext_fp_lvl1)};
    for i=1,#private.demonriddleext_fp_lvl1,1 do 
      ObjAnimate( "spr_demonriddleext_f"..i, 3, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_f"..i).pos_x,ObjGet("spr_demonriddleext_f"..i).pos_y, 0.5,0,ng_global.progress["ext"]["win_demonriddleext"].state[2][i][1],ng_global.progress["ext"]["win_demonriddleext"].state[2][i][2]} );
      ObjAnimate( "spr_demonriddleext_f"..i, 7, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_f"..i).ang, 0.5,0,ng_global.progress["ext"]["win_demonriddleext"].state[2][i][3]} );
    end;
    ld.StartTimer( 0.6, function() func_end();  end )  
  elseif cur_level==2 then      
    local func_end = function()
      ld.Lock(0);
      private.demonriddleext_stand_on_pos_lvl2();
    end;  
    
    ld.Lock(1);
    private.demonriddleext_select_color=0;
    ng_global.progress["ext"]["win_demonriddleext"].state = {2,ld.TableCopy(private.demonriddleext_fp_lvl2 )};
    for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2] ,1 do 
      for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do 
        ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]=0;
        ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j , 8, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j).alp, 0.3,0,0} );
      end;  
    end;
    ld.StartTimer( 0.4, function() func_end();  end )  
  elseif cur_level == 3 then 
    local func_end = function()
      private.demonriddleext_stand_on_pos_lvl3();
      for i=1,4,1 do 
        ObjAnimate( "obj_demonriddleext_lvl3_part"..i, 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
      end;
      ld.StartTimer( 0.35, function() ld.Lock(0);  end )  
    end;  
      
    ng_global.progress["ext"]["win_demonriddleext"].state = {3,ld.TableCopy(private.demonridleext_fp_lvl3)};  
    ld.Lock(1);
    for i=1,4,1 do 
       ObjAnimate( "obj_demonriddleext_lvl3_part"..i, 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
    end;
    ld.StartTimer( 0.35, func_end )     
  end;  
end;  
  --------------------------  
function public.demonridleext_skip()
  local cur_level = ng_global.progress["ext"]["win_demonriddleext"].state[1];
  ---------------------------------------------- LVL 1 -------------------------------------
  if cur_level==1 then   
    local func_end = function()
      private.demonriddleext_stand_on_pos_lvl1();
      -- ld.Lock(0);
    end;  
    
    ld.Lock(1);
    
    for i=1,#private.demonriddleext_lvl1_part_win_pos, 1 do 
       ng_global.progress["ext"]["win_demonriddleext"].state[2][i] = {private.demonriddleext_lvl1_part_win_pos[i][1],private.demonriddleext_lvl1_part_win_pos[i][2],0};
    end; 
    ng_global.progress["ext"]["win_demonriddleext"].state[1]=1; 
    
    for i=1,#private.demonriddleext_fp_lvl1,1 do 
      ObjAnimate( "spr_demonriddleext_f"..i, 3, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_f"..i).pos_x,ObjGet("spr_demonriddleext_f"..i).pos_y, 0.5,0,ng_global.progress["ext"]["win_demonriddleext"].state[2][i][1],ng_global.progress["ext"]["win_demonriddleext"].state[2][i][2]} );
      ObjAnimate( "spr_demonriddleext_f"..i, 7, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_f"..i).ang, 0.5,0,ng_global.progress["ext"]["win_demonriddleext"].state[2][i][3]} );
    end;
    ld.StartTimer( 0.6, function() func_end();  end )  
   ---------------------------------------------- LVL 2 -------------------------------------   
  elseif cur_level==2 then    
    local func_end = function()
      ld.Lock(0);
      private.demonriddleext_stand_on_pos_lvl2();
    end;  
    
    ld.Lock(1);
    private.demonriddleext_select_color=0;
    
   -- for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2],1 do 
   --   for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do
   --      ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]=1;
   --   end;  
   -- end;  
    ng_global.progress["ext"]["win_demonriddleext"].state[1]=2;
     
    
    -- ng_global.progress["ext"]["win_demonriddleext"].state = {2,ld.TableCopy(private.demonriddleext_fp_lvl2 )};
    for i=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2] ,1 do 
      for j=1,#ng_global.progress["ext"]["win_demonriddleext"].state[2][i],1 do 
        ng_global.progress["ext"]["win_demonriddleext"].state[2][i][j]=1;
        ObjAnimate( "spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j , 8, 0, 0, function() end, {0,0,ObjGet("spr_demonriddleext_"..private.demonriddleext_lvl2_color_array[i]..j).alp, 0.2,0,1} );
      end;  
    end;
      ld.StartTimer( 0.3, function() func_end();  end )  
      
 elseif cur_level == 3 then    
    ---------------------------------------------- LVL 3 -------------------------------------  
    local func_end=function()
        for i=1,4,1 do 
          ObjSet( "spr_demonriddleext_a"..i, {alp=1} );
        end;
        
        --ObjSet( "obj_demonriddleext_lvl3_root", {visible = 0} );
        ObjSet( "obj_demonriddleext_lvl3_root", {visible = 1, alp=0} );
        for i=1,4,1 do 
         for j=1,4,1 do 
           ObjSet( "spr_demonriddleext_"..private.demonriddleext_lvl3_part_index_array[i]..j, {alp=0, input=0} );
         end;  
        end;  
        ng_global.progress["ext"]["win_demonriddleext"].state[1]=4;
        private.demonriddleext_stand_on_pos_lvl(1);
        ObjAnimate( "obj_demonriddleext_lvl3_root", 8, 0, 0, function() private.demonriddleext_stand_on_pos_lvl()  end, {0,0,0, 0.3,0,1} );
    end;
      
    ld.Lock(1);
    ObjAnimate( "obj_demonriddleext_lvl"..cur_level.."_root", 8, 0, 0, func_end, {0,0,1, 0.3,0,0} );
  end;  
   
 
end; 
  
----------------------------------------------------------
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_demonriddleext"} ) then
    SoundMgTheme( true )
    ObjAnimate( "spr_demonriddleext_panel", 8, 0, 0, function() end, {0,0,0, 0.3,0,1} );
    cmn.MiniGameShow( "demonriddleext" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_cryptext_env" )
  if not ld.CheckRequirements( {"win_demonriddleext"} ) then
     ObjSet( "spr_demonriddleext_panel", {alp=0} );
     ObjSet( "txt_demonriddleext_panel", {alp=0} );
     private.demonriddleext_first_init();
     gm.load();
  end;   
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_demonriddleext"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "demonriddleext" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  public.demonridleext_reset();
end;
--*********************************************************************************************************************
function public.Skip()
  --private.Win();
  public.demonridleext_skip();
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_demonriddleext" );
  cmn.CallEventHandler( "win_demonriddleext" );
  --if common_impl.ZzCompleteCheck( "win_demonriddleext" ) then cmn.GotoRoom( "rm_cryptext" ); end;
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide(true);
  SoundMgTheme( false )
  ld.StartTimer( 0.5, private.WinEnd  );
  ObjAnimate( "spr_demonriddleext_panel", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["ext"]["win_demonriddleext"].state then
      gm.state = ld.TableCopy( ng_global.progress["ext"]["win_demonriddleext"].state )
    else  
      --ld.LogTrace( "new state" );
      ng_global.progress["ext"]["win_demonriddleext"].state = {1,ld.TableCopy(private.demonriddleext_fp_lvl1)};
    end
  
    gm.loaded  = true;
  else
  
  end;
  private.demonriddleext_stand_on_pos_lvl(); 
end
--*********************************************************************************************************************
function gm.default()

end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["ext"]["win_demonriddleext"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************
function gm.build()

end
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.event_mdown( num )
  
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;