-- name=ho_chimerascr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "chimerascr" );
  game.relations[ "ho_chimerascr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chimerascr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_chimerascr", zz_gate = "gho_housedoctor_chimerascr" };
 
  local win_chimerascr_func = function ()

    if ( cmn.IsEventDone( "win_chimerascr" ) ) then
      ObjDetach( "spr_chimerascr_win" );
   
    end;

  end;
  cmn.AddSubscriber( "win_chimerascr", win_chimerascr_func );
   --------------------------------------------------------------------------------------------
  local unmark_eee = function () 
    ObjSet( "spr_chimerascr_eee", {input = 1, visible = 1} );
    ObjDelete("gfx_chimerascr_unmark_eee_zone")
    ObjSet("anm_chimerascr_anm_ball",{animfunc="ball",frame=999})    
  end;
  cmn.AddSubscriber( "chimerascr_unmark_eee", unmark_eee, "ho_chimerascr" ); 
  -------------------------------------------------------------------------------------------- 
  local start_chimerascr_func = function ()
  if not cmn.IsEventDone("win_chimerascr") then
    if cmn.IsUnmarkedTask("chimerascr","eee") then 
      unmark_eee()
    end   
  end
  end;
  cmn.AddSubscriber( "win_chimerascr", start_chimerascr_func, "ho_chimerascr" );  

end;

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_housedoctor_env" )

  if ( not cmn.IsEventDone( "opn_chimerascr" ) ) then

    cmn.InitHo( "chimerascr" );
    cmn.SetMarkedTask( "chimerascr", "eee" );   
    cmn.SetEventDone( "opn_chimerascr" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_chimerascr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_chimerascr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_chimerascr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_chimerascr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_chimerascr_eee" },{"gfx_chimerascr_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_chimerascr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_chimerascr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_chimerascr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_chimerascr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_chimerascr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_chimerascr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_chimerascr_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_chimerascr"].found do

    local name = tostring( ng_global.progress["scr"]["win_chimerascr"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
  ObjDetach( "spr_chimerascr_win" );
end;
--*********************************************************************************************************************
function public.HoComplete()
      ObjDetach( "spr_chimerascr_win" );
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_chimerascr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_chimerascr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_eee() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "chimerascr", "eee" );
    cmn.CallEventHandler( "chimerascr_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_chimerascr_unmark_eee_zone")
  SoundSfx( "aud_ho_chimera_ball" );
  ld.AnimPlay("anm_chimerascr_anm_ball","ball",func_end) 
end