-- name=ho_dealscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "dealscr" );
  game.relations[ "ho_dealscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_dealscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_dealscr", zz_gate = "gho_livingroom_dealscr" };
 
  local win_dealscr_func = function ()

    if ( cmn.IsEventDone( "win_dealscr" ) ) then
             ObjDetach( "spr_dealscr_win" );

    end;

  end;
  cmn.AddSubscriber( "win_dealscr", win_dealscr_func );

  local complete_stage = function () 

    if ng_global.progress["scr"]["win_dealscr"].state.stage > 1 then
      ObjSet("spr_dealscr_key_box",{input=1})
      ObjSet("gfx_dealscr_key_box_zone",{visible=1,active=1,input=1})      
    end
    if ng_global.progress["scr"]["win_dealscr"].state.stage > 2 then
      ObjDelete("spr_dealscr_key_box")
      ObjDelete("gfx_dealscr_key_box_zone")   
      ObjSet("anm_dealscr_anm_table",{animfunc="open_table1_end",frame=0})   
      ObjSet("spr_dealscr_eee",{input=1})
      ObjSet("spr_dealscr_fff",{input=1})  
      ObjSet("spr_dealscr_ggg",{input=1})
      ObjSet("spr_dealscr_hhh",{input=1})        
    end
    if ng_global.progress["scr"]["win_dealscr"].state.stage > 3 then
      ObjSet("spr_dealscr_blade",{input=1})
      ObjSet("gfx_dealscr_blade_zone",{visible=1,active=1,input=1})  
    end
    if ng_global.progress["scr"]["win_dealscr"].state.stage > 4 then
      ObjDelete("spr_dealscr_blade")
      ObjDelete("gfx_dealscr_blade_zone")   
      ObjSet("anm_dealscr_anm_blade",{animfunc="bag_open_end",frame=0})   
   
      ObjSet("spr_dealscr_iii",{input=1})
      ObjSet("spr_dealscr_jjj",{input=1,visible=1})  
      ObjSet("spr_dealscr_kkk",{input=1})
      ObjSet("spr_dealscr_lll",{input=1,visible=1})      
    end
    if ng_global.progress["scr"]["win_dealscr"].state.stage > 5 then
      ObjSet("spr_dealscr_mmm",{input=1})     
    end
   
  end;
  cmn.AddSubscriber( "dealscr_complete_stage", complete_stage, "ho_dealscr" ); 
  
  local start_dealscr_func = function ()
  if not cmn.IsEventDone("win_dealscr") then
    complete_stage()
  end
  end;
  cmn.AddSubscriber( "win_dealscr", start_dealscr_func, "ho_dealscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_livingroom_env" )

  if ( not cmn.IsEventDone( "opn_dealscr" ) ) then

    cmn.InitHo( "dealscr" );

    cmn.SetEventDone( "opn_dealscr" );
    ng_global.progress["scr"]["win_dealscr"].state = {}
    ng_global.progress["scr"]["win_dealscr"].state.stage = 1
    ng_global.progress["scr"]["win_dealscr"].state.get_item=0
  end;

  
  local arr = { "aaa",
                "bbb",
                "ccc",
                "ddd",
                "eee",
                "fff",
                "ggg",
                "hhh",
                "iii",
                "jjj",
                "kkk",
                "lll",
              }
    for i = 1,#arr do 
      local item_name = "spr_dealscr_panel_"..arr[i].."_siluet"        
      local item_params = ObjGet( item_name );  
  
      ObjSet( item_name, {
        event_menter = function () interface.PopupShow("tsk_dealscr_"..arr[i] ) end,
        event_mleave = function () interface.PopupHide() end,
        inputrect_init = 1,
        inputrect_x    = - ( 0.5 * 100  ),
        inputrect_y    = - ( 0.5 * 100 ),
        inputrect_w    = 100,
        inputrect_h    = 100               
      } );
    end   
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_dealscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_dealscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_dealscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_dealscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_dealscr_eee" },{"spr_dealscr_key_box","gfx_dealscr_key_box_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_dealscr_fff" },{"spr_dealscr_key_box","gfx_dealscr_key_box_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_dealscr_ggg" },{"spr_dealscr_key_box","gfx_dealscr_key_box_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_dealscr_hhh" },{"spr_dealscr_key_box","gfx_dealscr_key_box_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_dealscr_iii" },{"spr_dealscr_blade","gfx_dealscr_blade_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_dealscr_jjj" },{"spr_dealscr_blade","gfx_dealscr_blade_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_dealscr_kkk" },{"spr_dealscr_blade","gfx_dealscr_blade_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_dealscr_lll" },{"spr_dealscr_blade","gfx_dealscr_blade_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_dealscr_mmm" } } );  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  ObjAttach("spr_dealscr_panel","int_taskpanel_impl")
  ObjSet("spr_dealscr_panel",{pos_x=0,pos_y=0})
   for j = 1, #ng_global.progress["scr"]["win_dealscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_dealscr"].found[j]["object"] );
    local task = tostring( ng_global.progress["scr"]["win_dealscr"].found[j]["task"] );
    ObjDelete( name );
    ObjDelete( "spr_dealscr_panel_"..task.."_siluet"  );
  end;
  private.LoadStage()
end;
--*********************************************************************************************************************
function public.PreClose()
  
  SoundVoice(0);
  SoundHoTheme( false );
  interface.TaskPanelHide();
  ObjDetach( "spr_dealscr_win" );
end;

function public.Close()
  ObjDetach("spr_dealscr_panel")
end

--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  if item_name ~= "mmm" then
    ld.FxAnmObj("spr_dealscr_panel_"..item_name.."_siluet",1); -- without sfx
  end
  --ObjAnimate( "spr_dealscr_panel_"..item_name.."_siluet", 6, 0, 0, "", {0,0,1,1, 0.5,0,0,0} );
  ng_global.progress["scr"]["win_dealscr"].state.get_item = ng_global.progress["scr"]["win_dealscr"].state.get_item + 1
  if ng_global.progress["scr"]["win_dealscr"].state.get_item == 4 then 
    private.CompleteStage()
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_dealscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_dealscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function private.stage_voice(num)
  if math.floor(num)==1 or math.floor(num)==3 or math.floor(num)==5 then 
    local voice_num = (num+1)/2;
    SoundVoice(0);
    SoundVoice("aud_ho_deal_lord_"..math.floor(voice_num).."_voc");
  end;
end;  


function private.CompleteStage()

  local s = ng_global.progress["scr"]["win_dealscr"].state.stage
  local f_end = function()
    private.stage_voice(s);
    ObjDetach("obj_dealscr_task_stage_"..s);
    private.LoadStage()
    cmn.CallEventHandler("dealscr_complete_stage");
  end
  ObjAnimate( "obj_dealscr_task_stage_"..s, 8, 0, 0, f_end, {0,0,1, 0.5,0,0} );
  ng_global.progress["scr"]["win_dealscr"].state.get_item = 0
  ng_global.progress["scr"]["win_dealscr"].state.stage = ng_global.progress["scr"]["win_dealscr"].state.stage + 1


end
function private.LoadStage()
  local s=ng_global.progress["scr"]["win_dealscr"].state.stage
  ObjAttach("obj_dealscr_task_stage_"..s,"obj_dealscr_panel")
  ObjAnimate( "obj_dealscr_task_stage_"..s, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
end



function public.use_key()
  if ApplyObj("spr_dealscr_key_box","gfx_dealscr_key_box_zone") then  
    local f_end = function()
      ld.Lock(0);
      private.CompleteStage()
    end
    ObjDelete("spr_dealscr_key_box")
    ObjDelete("gfx_dealscr_key_box_zone")    
    ld.Lock(1);
    SoundSfx( "aud_ho_deal_key" );
    ld.AnimPlay("anm_dealscr_anm_table","open_table",f_end)
  else 
    ObjSet("spr_dealscr_key_box",{pos_z=2})
  end
end


function public.use_blade()
  if ApplyObj("spr_dealscr_blade","gfx_dealscr_blade_zone") then  
    local f_end = function()
      ld.Lock(0);      
      private.CompleteStage()
    end
    ObjDelete("spr_dealscr_blade")
    ObjDelete("gfx_dealscr_blade_zone")    
    ld.Lock(1);
    SoundSfx( "aud_ho_deal_knife" );
    ld.AnimPlay("anm_dealscr_anm_blade","bag_open",f_end)
  else 
    ObjSet("spr_dealscr_blade",{pos_z=0})
  end
end