-- name=ho_injailscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "injailscr" );
  game.relations[ "ho_injailscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_injailscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_injailscr", zz_gate = "gho_square_injailscr" };
 
  local win_injailscr_func = function ()

    if ( cmn.IsEventDone( "win_injailscr" ) ) then
       ObjDetach("spr_injailscr_win")
    end;

  end;
  cmn.AddSubscriber( "win_injailscr", win_injailscr_func );
-----------------------------------------------------------------------------
  
  
function public.win_injailscr_close_anim()  --ho_injailscr.win_injailscr_close_anim();
  local func_end = function()
    ld.Lock(0);
    rm_secretroomscr.GotoRoom( 'rm_secretroomscr' )
  end;  
  
  ld.Lock(1);
  ObjAnimate( "ho_injailscr", 3, 0, 0, "", {0,0,0,0, 0.5,0,-200,0} );
  ObjAnimate( "ho_injailscr", 6, 0, 0, func_end, {0,0,1,1, 0.5,0,1.2,1.2, 1.5,0,1.2,1.2} );
end;  
  
----------------------------------------------------------------------------- 
  
  local unmark_fff = function () 
    ObjSet( "spr_injailscr_fff", {input = 1, alp = 1} );
    ObjDelete("gfx_injailscr_unmark_fff_zone")
    ObjDelete("spr_injailscr_unmark_fff_part_1")    
    ObjDelete("spr_injailscr_unmark_fff_part_1_sh")
    ObjSet("anm_injailscr_anm_unmark_fff",{animfunc="end_ax1",frame=0})
  end;
  cmn.AddSubscriber( "injailscr_unmark_fff", unmark_fff, "ho_injailscr" );   

  local unmark_eee = function () 
    ObjSet( "spr_injailscr_eee", {input = 1, visible = 1} );
    ObjDelete("gfx_injailscr_unmark_eee_zone")
    ObjSet("anm_injailscr_anm_unmark_eee",{animfunc="end_close1",frame=0})    
  end;
  cmn.AddSubscriber( "injailscr_unmark_eee", unmark_eee, "ho_injailscr" ); 

  
  local unmark_mmm= function () 
    ObjSet( "spr_injailscr_mmm", {input = 1,visible=1} );
    ObjDelete("anm_injailscr_anm_stone")
    ObjDelete("gfx_injailscr_unmark_mmm_zone")
    --ObjDelete("gfx_injailscr_unmark_mmm_zone2")  
    ObjDelete("spr_injailscr_sh_scrap")
    ObjDelete("spr_injailscr_scrap")   
    ObjDelete("obj_injailscr_stone_clk_zone"); 
  end;
  cmn.AddSubscriber( "injailscr_unmark_mmm", unmark_mmm, "ho_injailscr" ); 
  
  local start_injailscr_func = function ()
  if not cmn.IsEventDone("win_injailscr") then
    if cmn.IsUnmarkedTask("injailscr","fff") then 
      unmark_fff()
    end      
    if cmn.IsUnmarkedTask("injailscr","eee") then 
      unmark_eee()
    end
    if cmn.IsUnmarkedTask("injailscr","mmm") then 
      unmark_mmm()
    else
      if #ng_global.progress["scr"]["win_injailscr"].found >= 11 then
           int_taskpanel_impl.ShowTask13() 
        ObjSet("anm_injailscr_anm_stone",{animfunc="clean_stone"..ng_global.progress["scr"]["win_injailscr"].state_mmm,frame=0})
        ObjSet("spr_injailscr_mmm",{alp=1}) 
       ObjSet( "gfx_injailscr_unmark_mmm_zone", {input = 1} ); 
       ObjSet( "obj_injailscr_stone_clk_zone", {input = 1} );
        if ng_global.progress["scr"]["win_injailscr"].state_mmm > 1 then 
          --ObjSet("gfx_injailscr_unmark_mmm_zone",{input=0,visible=0})
          --ObjSet("gfx_injailscr_unmark_mmm_zone2",{input=1,visible=1})
          ObjDelete("spr_injailscr_sh_scrap")
          ObjDelete("spr_injailscr_scrap")
        end       
      end
    end     
  end
  end;
  cmn.AddSubscriber( "win_injailscr", start_injailscr_func, "ho_injailscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

end
function public.PreOpen()
  
  SoundEnv( "aud_ho_injail_env" )

  if ( not cmn.IsEventDone( "opn_injailscr" ) ) then

    cmn.InitHo( "injailscr" );
    cmn.SetMarkedTask( "injailscr", "fff" );  
    cmn.SetMarkedTask( "injailscr", "eee" );  
    cmn.SetMarkedTask( "injailscr", "mmm" );  
    
    cmn.SetEventDone( "opn_injailscr" );    
    ng_global.progress["scr"]["win_injailscr"].state_mmm = 1
    
  end;

    local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_injailscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_injailscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_injailscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_injailscr_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_injailscr_eee" },{"gfx_injailscr_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_injailscr_fff" },{"spr_injailscr_unmark_fff_part_1","gfx_injailscr_unmark_fff_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_injailscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_injailscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_injailscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_injailscr_jjj" },{"spr_injailscr_little"} } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_injailscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_injailscr_lll" } } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 1, { { "spr_injailscr_mmm" },{"gfx_injailscr_unmark_mmm_zone"},{"gfx_injailscr_unmark_mmm_zone2"} } );       
  
  SoundHoTheme( true );  
  
  interface.TaskPanelShow( ho_items );
  
   for j = 1, #ng_global.progress["scr"]["win_injailscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_injailscr"].found[j]["object"] );
   
    ObjDelete( name );
    if name == "spr_injailscr_jjj" then
      ObjDelete("spr_injailscr_little")
    end
  end;

end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
  ObjDetach("spr_injailscr_win")
  int_taskpanel_impl.ResetTaskVisible()
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  if #ng_global.progress["scr"]["win_injailscr"].found  == 12 then
    ld.Lock(1)
    SoundSfx( "aud_ho_injail_stones" );
    ld.AnimPlay("anm_injailscr_anm_stone","stone",function()
      ld.Lock(0);
      ObjSet("spr_injailscr_lll",{alp=1});
      ObjSet( "gfx_injailscr_unmark_mmm_zone", {input = 1} );
      ObjSet( "obj_injailscr_stone_clk_zone", {input = 1} );
      end)
      int_taskpanel_impl.ShowTask13();     
  end
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_injailscr_"..task_name, { pos_z = 1 } );
  cmn.HoTaskFind( "spr_injailscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_fff() 
  if ApplyObj("spr_injailscr_unmark_fff_part_1","gfx_injailscr_unmark_fff_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injailscr", "fff" );
    cmn.CallEventHandler( "injailscr_unmark_fff" );
  end
  ld.Lock(1) 
  ObjDelete("spr_injailscr_unmark_fff_part_1")
  ObjDelete("gfx_injailscr_unmark_fff_zone")
  SoundSfx( "aud_ho_injail_axe" );
  ld.AnimPlay("anm_injailscr_anm_unmark_fff","use_ax",func_end)
  else 
  ObjSet("spr_injailscr_unmark_fff_part_1",{pos_z = 1})
  ObjSet( "spr_injailscr_unmark_fff_part_1_sh", {alp = 1} );    
  end
end;


--private.injailscr_page_hint_zone = "gfx_injailscr_unmark_jjj_zone";
function public.injailscr_page_show_jjj()  --ho_injailscr.injailscr_page_show_jjj()
  local func_end = function()
      ld.Lock(0);
      int.InterfaceSetInput(0);
      ObjDelete("spr_injailscr_little");
      ObjDelete("gfx_injailscr_unmark_jjj_zone")
      ObjSet( "spr_injailscr_jjj", {input = 1, alp = 1} );
      ld.ShowBbt("injail_order");
  end;
    
  ld.Lock(1);
  
  SoundSfx( "aud_paper_open" );
   --ObjSet("anm_injailscr_anm_unmark_jjj",{animfunc="end_bed1",frame=0})
   --ObjSet("spr_injailscr_jjj_tr",{alp=1})
   ObjAnimate( "spr_injailscr_little", 8, 0, 0, function() end, {0,0,1, 0.3,0,0} );
   ObjAnimate( "spr_injailscr_jjj", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );  
end;  

 function public.find_jjj(sender, task)
   int.InterfaceSetInput(1);
   cmn.HoTaskFind( sender, task );
 end


function public.unmark_eee() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injailscr", "eee" );
    cmn.CallEventHandler( "injailscr_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_injailscr_unmark_eee_zone")
  SoundSfx( "aud_ho_injail_cloth" );
  ld.AnimPlay("anm_injailscr_anm_unmark_eee","click_close",func_end) 
end

function public.unmark_mmm() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "injailscr", "mmm" );
    cmn.CallEventHandler( "injailscr_unmark_mmm" );
  end
  local f_check = function()
    ld.Lock(0) 
    ng_global.progress["scr"]["win_injailscr"].state_mmm = ng_global.progress["scr"]["win_injailscr"].state_mmm + 1
    if ng_global.progress["scr"]["win_injailscr"].state_mmm == 2 then
      func_end()
    end
  end
  ld.Lock(1) 
  local s = ng_global.progress["scr"]["win_injailscr"].state_mmm
  ObjSet("gfx_injailscr_unmark_mmm_zone",{input=0,visible=0})
  --ObjSet("gfx_injailscr_unmark_mmm_zone2",{input=1,visible=1})
  ObjDelete("spr_injailscr_sh_scrap")
  ObjDelete("spr_injailscr_scrap")
  ObjDelete("obj_injailscr_stone_clk_zone");
  SoundSfx( "aud_ho_injail_remove_stones" );
  ld.AnimPlay("anm_injailscr_anm_stone","clean_stone"..s,f_check) 
end

function public.call_end_game_down()
  ObjSet( "spr_injailscr_mmm", { pos_z = 1} );
  cmn.HoTaskFind( "spr_injailscr_mmm", "mmm" );
                            
end;
