-- name=ho_marinescr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "marinescr" );
  game.relations[ "ho_marinescr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_marinescr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_marinescr", zz_gate = "gho_seafront_marinescr" };
 
  local win_marinescr_func = function ()

    if ( cmn.IsEventDone( "win_marinescr" ) ) then
      ObjDetach("spr_marinescr_win");      

    end;

  end;
  cmn.AddSubscriber( "win_marinescr", win_marinescr_func );

  local unmark_eee = function () 
    ObjSet( "spr_marinescr_eee", {input = 1, alp = 1} );
    ObjDelete("gfx_marinescr_unmark_eee_zone")
    ObjDelete("spr_marinescr_unmark_eee_part_1_sh")    
    ObjDelete("spr_marinescr_unmark_eee_part_1")
    ObjSet("anm_marinescr_use_knife",{animfunc="end_knife1",frame=0})
  end;
  cmn.AddSubscriber( "marinescr_unmark_eee", unmark_eee, "ho_marinescr" ); 

  
  local unmark_ddd = function () 
    ObjSet( "spr_marinescr_ddd", {input = 1, alp = 1} );
    ObjDelete("gfx_marinescr_unmark_ddd_zone")
    ObjSet("anm_marinescr_ddd_unmark",{animfunc="end_purse1",frame=0})
  end;
  cmn.AddSubscriber( "marinescr_unmark_ddd", unmark_ddd, "ho_marinescr" ); 
  
  
  local unmark_lll = function () 
    ObjSet( "spr_marinescr_lll", {input = 1, alp = 1} );
    ObjDelete("gfx_marinescr_unmark_lll_zone")
    ObjSet("anm_marinescr_lll_unmark",{animfunc="end_fishnet1",frame=0})
  end;
  cmn.AddSubscriber( "marinescr_unmark_lll", unmark_lll, "ho_marinescr" ); 
  
  local start_marinescr_func = function ()
  if not cmn.IsEventDone("win_marinescr") then
    if cmn.IsUnmarkedTask("marinescr","eee") then 
      unmark_eee()
    end    
    if cmn.IsUnmarkedTask("marinescr","lll") then 
      unmark_lll()
    end
    if cmn.IsUnmarkedTask("marinescr","ddd") then 
      unmark_ddd()
    end    
  end
  end;
  cmn.AddSubscriber( "win_marinescr", start_marinescr_func, "ho_marinescr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_seafront_env" )

  if ( not cmn.IsEventDone( "opn_marinescr" ) ) then

    cmn.InitHo( "marinescr" );
    cmn.SetMarkedTask( "marinescr", "eee" );
    cmn.SetMarkedTask( "marinescr", "lll" );    
    cmn.SetMarkedTask( "marinescr", "ddd" );     
    cmn.SetEventDone( "opn_marinescr" );
     ObjSet("txt_marinescr_panel",{param0=12})
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_marinescr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_marinescr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_marinescr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_marinescr_ddd" },{"gfx_marinescr_unmark_ddd_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 1, { { "spr_marinescr_eee" },{"spr_marinescr_unmark_eee_part_1","gfx_marinescr_unmark_eee_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_marinescr_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_marinescr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_marinescr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_marinescr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_marinescr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_marinescr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 1, { { "spr_marinescr_lll" },{"gfx_marinescr_unmark_lll_zone"} } );
  
  SoundHoTheme( true );
  ObjAttach("spr_marinescr_panel","int_taskpanel_impl")
  ObjSet("spr_marinescr_panel",{pos_x=0,pos_y=0})  
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_marinescr"].found do

    local name = tostring( ng_global.progress["scr"]["win_marinescr"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  if ng_global.progress["scr"]["win_marinescr"].found then
    ObjSet("txt_marinescr_panel",{param0=12-#ng_global.progress["scr"]["win_marinescr"].found})
  end
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;

function public.Close()
  ObjDetach("spr_marinescr_panel")  
end
--*********************************************************************************************************************
function public.HoComplete()
      ObjDetach("spr_marinescr_win");   
  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  local sum = 12 - #ng_global.progress["scr"]["win_marinescr"].found
   
  ObjSet("txt_marinescr_panel",{param0=sum})
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_marinescr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_marinescr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
----------------------------------------------------------------------------
function public.unmark_eee() 
  if ApplyObj("spr_marinescr_unmark_eee_part_1","gfx_marinescr_unmark_eee_zone") then 
  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marinescr", "eee" );
    cmn.CallEventHandler( "marinescr_unmark_eee" );
  end
  ld.Lock(1) 
  ObjDelete("spr_marinescr_unmark_eee_part_1")
  ObjDelete("gfx_marinescr_unmark_eee_zone")
  SoundSfx( "aud_ho_marine_knife" );
  ld.AnimPlay("anm_marinescr_use_knife","use_knife",func_end)
  else 
  ObjSet("spr_marinescr_unmark_eee_part_1",{pos_z = 1})
  ObjSet( "spr_marinescr_unmark_eee_part_1_sh", {alp = 1} );    
  end
end;

----------------------------------------------------------------------------
function public.unmark_lll() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marinescr", "lll" );
    cmn.CallEventHandler( "marinescr_unmark_lll" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_marinescr_unmark_lll_zone")
  SoundSfx( "aud_ho_marine_net" );
  ld.AnimPlay("anm_marinescr_lll_unmark","click_fishnet",func_end)
end;
----------------------------------------------------------------------------
function public.unmark_ddd() 

  local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "marinescr", "ddd" );
    cmn.CallEventHandler( "marinescr_unmark_ddd" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_marinescr_unmark_ddd_zone")
  SoundSfx( "aud_ho_marine_purse" );
  ld.AnimPlay("anm_marinescr_ddd_unmark","click_purse",func_end)
end;