-- name=ho_pantryhoscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pantryhoscr" );
  game.relations[ "ho_pantryhoscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pantryhoscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_pantryhoscr", zz_gate = "gho_residence_pantryhoscr" };
 
  local win_pantryhoscr_func = function ()

    if ( cmn.IsEventDone( "win_pantryhoscr" ) ) then
      ObjDetach( "spr_pantryhoscr_win" );

    end;

  end;
  cmn.AddSubscriber( "win_pantryhoscr", win_pantryhoscr_func );
  
  local unmark_bbb_3 = function () 
    ObjDelete("spr_pantryhoscr_bbb_mul_3_part")
    ObjDelete("spr_pantryhoscr_bbb_mul_3_part_sh")      
    ObjDelete("spr_pantryhoscr_bbb_mul_3_part_drop")
    ObjDelete("gfx_pantryhoscr_bbb_mul_3_part_drop_zone")
    ObjSet("spr_pantryhoscr_bbb_mul_3_back",{alp=1})
    ObjSet("spr_pantryhoscr_bbb_mul_3",{input=1,alp=1})
  end;
  cmn.AddSubscriber( "pantryhoscr_unmark_bbb_3", unmark_bbb_3, "ho_pantryhoscr" ); 

  local unmark_bbb_4 = function () 
    for i=1,ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4 do 
      ObjSet("anm_pantryhoscr_unmark_bbb_mul_4_"..i,{frame=999})
    end
    if ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4== 3 then
      ObjSet("spr_pantryhoscr_bbb_mul_4",{input=1,alp=1})
      ObjDelete("gfx_pantryhoscr_bbb_mul_4_clk_zone")
    end
  end;
  cmn.AddSubscriber( "pantryhoscr_unmark_bbb_4", unmark_bbb_4, "ho_pantryhoscr" );   
  
  local unmark_aaa_1 = function () 
    ObjSet("spr_pantryhoscr_aaa_mul_1",{input=1,alp=1})
    ObjDelete("gfx_pantryhoscr_aaa_mul_1_clk_zone")
    ObjSet("anm_pantryhoscr_unmark_aaa_mul_1",{frame=999})
  end;
  cmn.AddSubscriber( "pantryhoscr_unmark_aaa_1", unmark_aaa_1, "ho_pantryhoscr" ); 

  local unmark_aaa_4 = function () 
    ObjSet("spr_pantryhoscr_aaa_mul_4",{input=1,alp=1})
    ObjDelete("gfx_pantryhoscr_aaa_mul_4_part_drop_zone")
    ObjSet("anm_pantryhoscr_unmark_aaa_mul_4",{animfunc="end_hacksaw1",frame=0})
    ObjDelete("spr_pantryhoscr_aaa_mul_4_part")
    ObjDelete("spr_pantryhoscr_aaa_mul_4_part_sh")
  end;
  cmn.AddSubscriber( "pantryhoscr_unmark_aaa_4", unmark_aaa_4, "ho_pantryhoscr" ); 
  
  local start_pantryhoscr_func = function ()
  if not cmn.IsEventDone("win_pantryhoscr") then
    if ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_3 then
      unmark_bbb_3()
    end
    if ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4 then
      unmark_bbb_4()
    end    
    if ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_aaa_1 then
      unmark_aaa_1()
    end    
    if ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_aaa_4 then
      unmark_aaa_4()
    end     
  end
  end;
  cmn.AddSubscriber( "win_pantryhoscr", start_pantryhoscr_func, "ho_pantryhoscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_residence_env" )

  if ( not cmn.IsEventDone( "opn_pantryhoscr" ) ) then

    cmn.InitHo( "pantryhoscr" );

    cmn.SetEventDone( "opn_pantryhoscr" );
    ng_global.progress["scr"]["win_pantryhoscr"].state = {}
  end;

  local arr = { "aaa",
                "bbb",
                "ccc",
              }
    for i = 1,#arr do 
      local item_name = "spr_pantryhoscr_panel_"..arr[i].."_siluet"        
      local item_params = ObjGet( item_name );  
      --ld.LogTrace( item_name );      
      ObjSet( item_name, {
        event_menter = function () interface.PopupShow("tsk_pantryhoscr_"..arr[i] ) end,
        event_mleave = function () interface.PopupHide() end,
        inputrect_init = 1,
        inputrect_x    = - ( 0.5 * item_params.draw_width  ),
        inputrect_y    = - ( 0.5 * item_params.draw_height ),
        inputrect_w    = item_params.draw_width,
        inputrect_h    = item_params.draw_height               
      } );
    end     
  
  local ho_items = {};
                                                        
  interface.TaskPanelTaskAdd( ho_items, "aaa",          4, 0, { { "spr_pantryhoscr_aaa_mul_1" },{"gfx_pantryhoscr_aaa_mul_1_clk_zone"},{ "spr_pantryhoscr_aaa_mul_2" },{ "spr_pantryhoscr_aaa_mul_3" },{ "spr_pantryhoscr_aaa_mul_4" },{"spr_pantryhoscr_aaa_mul_4_part","gfx_pantryhoscr_aaa_mul_4_part_drop_zone"} });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          4, 0, { { "spr_pantryhoscr_bbb_mul_1" },{ "spr_pantryhoscr_bbb_mul_2" },{ "spr_pantryhoscr_bbb_mul_3" },{"spr_pantryhoscr_bbb_mul_3_part","gfx_pantryhoscr_bbb_mul_3_part_drop_zone"},{ "spr_pantryhoscr_bbb_mul_4" },{"gfx_pantryhoscr_bbb_mul_4_clk_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          4, 0, { { "spr_pantryhoscr_ccc_mul_1" },{ "spr_pantryhoscr_ccc_mul_2" },{ "spr_pantryhoscr_ccc_mul_3" },{ "spr_pantryhoscr_ccc_mul_4" } } );


  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  ObjAttach("spr_pantryhoscr_panel","int_taskpanel_impl")
  ObjSet("spr_pantryhoscr_panel",{pos_x=0,pos_y=0})
   for j = 1, #ng_global.progress["scr"]["win_pantryhoscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_pantryhoscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;
  private.LoadState()
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();
      ObjDetach( "spr_pantryhoscr_win" );
end;
--*********************************************************************************************************************
function public.Close()
  ObjDetach("spr_pantryhoscr_panel")
end

function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )
  private.LoadState()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_pantryhoscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_pantryhoscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------

function private.LoadState()
  public.state = {}
  for j = 1, #ng_global.progress["scr"]["win_pantryhoscr"].found do

    local task = tostring( ng_global.progress["scr"]["win_pantryhoscr"].found[j]["task"] );
    if public.state[task] then
      public.state[task] = public.state[task] + 1
    else 
      public.state[task] = 1
    end
  end;
  for k,v in pairs(public.state) do
    if public.state[k] then
      ObjSet("txt_pantryhoscr_panel_"..k.."_text",{text="x"..(4-tonumber(v))})
    end
  end 
end
----------------------------------------------------------------------------

function public.unmark_bbb_3()
  local f_end = function ()
    ld.Lock(0)
    ng_global.progress["scr"]["win_pantryhoscr"].start = 1;    
    ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_3 = true;    
    cmn.CallEventHandler("pantryhoscr_unmark_bbb_3");
  end
  if ApplyObj("spr_pantryhoscr_bbb_mul_3_part","gfx_pantryhoscr_bbb_mul_3_part_drop_zone") then   
    ld.Lock(1)
    ObjDelete("spr_pantryhoscr_bbb_mul_3_part")
    ObjAnimate( "spr_pantryhoscr_bbb_mul_3_part_drop", 8, 0, 0, f_end, {0,0,0, 0.5,0,1} );
    SoundSfx( "aud_ho_pantry_picture" );  
  else
    ObjSet( "spr_pantryhoscr_bbb_mul_3_part",{pos_z=3} );
    ObjSet("spr_pantryhoscr_bbb_mul_3_part_sh",{alp=1})
  end
end
----------------------------------------------------------------------------
function public.unmark_bbb_4()
  local f_end = function ()
    ld.Lock(0)
    ng_global.progress["scr"]["win_pantryhoscr"].start = 1;    
    ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4 =( ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4  or 0 )+1;
    cmn.CallEventHandler("pantryhoscr_unmark_bbb_4");
  end
  ld.Lock(1)
  --ObjDelete("gfx_pantryhoscr_bbb_mul_4_clk_zone")
  SoundSfx( "aud_ho_pantry_weed" );
  local num = (ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_bbb_4 or 0)+1
  ld.AnimPlay("anm_pantryhoscr_unmark_bbb_mul_4_"..num,"click_"..num,f_end)
end

----------------------------------------------------------------------------
function public.unmark_aaa_1()
  local f_end = function ()
    ld.Lock(0)
    ng_global.progress["scr"]["win_pantryhoscr"].start = 1;    
    ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_aaa_1 = true;    
    cmn.CallEventHandler("pantryhoscr_unmark_aaa_1");
  end
  ld.Lock(1)
  ObjDelete("gfx_pantryhoscr_aaa_mul_1_clk_zone")
  SoundSfx( "aud_ho_pantry_cloth" );  
  ld.AnimPlay("anm_pantryhoscr_unmark_aaa_mul_1","click_blind",f_end)
end
----------------------------------------------------------------------------
function public.unmark_aaa_4()
  local f_end = function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_pantryhoscr"].start = 1;    
    ng_global.progress["scr"]["win_pantryhoscr"].state.unmark_aaa_4 = true;    
    cmn.CallEventHandler("pantryhoscr_unmark_aaa_4");
  end
  if ApplyObj("spr_pantryhoscr_aaa_mul_4_part","gfx_pantryhoscr_aaa_mul_4_part_drop_zone") then   
    ld.Lock(1)
    ObjDelete("spr_pantryhoscr_aaa_mul_4_part")
    ld.AnimPlay("anm_pantryhoscr_unmark_aaa_mul_4","use_hacksaw",f_end)
    SoundSfx( "aud_ho_pantry_saw" );  
  else
    ObjSet( "spr_pantryhoscr_aaa_mul_4_part",{pos_z=3} );
    ObjSet("spr_pantryhoscr_aaa_mul_4_part_sh",{alp=1})
  end
end