-- name=ho_theatreextscr
--*********************************************************************************************************************
function private.ReverseItemsBuild()
  if not private.Builded then
    for i = 1, #private.taskpanel do
      local name = private.taskpanel[i][1]
      local style = private.taskpanel[i][2]

      local obj = "obj_theatreextscr_taskpanel_"..name;
      ObjSet( "spr_theatreextscr_"..name, { input = 0 } )

      if style == "text" then
        
        ObjCreate( obj, "text" )
        local o = ObjGet( "txt_int_taskpanel_task_1" )
        o.name = nil
        ObjSet( obj, o )
        ObjSet( obj, int_taskpanel_impl.GetTaskColors() )
        ObjSet( obj, { text = "tsk_theatreext_"..name; input = 0;fontsize=20,pos_y=15 } )

      elseif style == "item" then

        ObjCreate( obj, "spr" )
        ObjSet( obj, { 
          res = "assets/levels/levelext/ho_theatreext/item_"..name; 
          pos_y = 12;
          input = 0;
          inputrect_init = 1;
          inputrect_x = -50;
          inputrect_y = -50;
          inputrect_w = 100;
          inputrect_h = 100;
          drag = 1;
          event_startdrag = function() SoundSfx( "aud_get_inv", -1 ) PartSysStop("fx_"..obj,0)  ld.ShCur(CURSOR_NULL) end;
          event_dragdrop = function() PartSysRestart("fx_"..obj) ld.ShCur(CURSOR_DEFAULT) private.ReverseTaskComplete( name ) end;
        } )
        ObjSet( "obj_theatreextscr_"..name, { input = 0 } )

        local o = ObjGet( obj )
        ObjCreate( "fx_"..obj, "partsys" )
        ObjSet( "fx_"..obj, { 
          res = "assets/levels/levelext/ho_theatreext/item_fx"; 
        } )
        ObjAttach( "fx_"..obj, obj )

      end;

      ObjSet( "obj_theatreextscr_"..private.taskpanel[i][1].."_root", { input = i > 1 and 0 or 1 } )

    end;
    private.ReverseItemShowNext()
    private.Builded = true
  else

  end;
end;

function private.ReverseItemShowNext( name )

  if name then

    local n = ld.TableContains( private.taskpanel, name, true )
    local obj_now = "obj_theatreextscr_taskpanel_"..name
    local obj_next = "obj_theatreextscr_taskpanel_"..(private.taskpanel[n+1][1])

    ObjSet( "fx_theatreextscr_task_"..n, { active = 1 } )

    ObjCreate( "fx_theatreextscr_task_start_"..n, "partsys" )
    ObjSet( "fx_theatreextscr_task_start_"..n, { res = "assets/levels/levelext/ho_theatreext/light_on_fx"; } )
    ObjAttach( "fx_theatreextscr_task_start_"..n, "fx_theatreextscr_task_"..n )
    
    ObjAnimate( obj_now, 8,0,0, function() 
      ObjDelete( obj_now )
    end, { 0,0,1, 0.5,0,0 } )
    ObjAttach( obj_next, "obj_theatreextscr_taskpanel" )
    if private.taskpanel[n+1][2] == "item" then
      private.ReverseObjDestroyFx( obj_next, true )
    else
      ObjAnimate( obj_next, 8,0,0, _, { 0,0,0, 0.5,0,1 } )
    end;

    cmn.HoTaskFind( "xxx", name )

    ld.Lock( 0 )
    private.ReverseLoad()
  else
    local tasks = ld.TableCopy( private.taskpanel )
    if ng_global.progress["scr"]["win_theatreextscr"].found then
      for j = 1, #ng_global.progress["scr"]["win_theatreextscr"].found do
        local n = ld.TableContains( tasks, ng_global.progress["scr"]["win_theatreextscr"].found[j].task, true )
        if n ~= 0 then
          table.remove( tasks, n );
        end;
      end
    end

    local obj_next = "obj_theatreextscr_taskpanel_"..(tasks[1][1])
    --ObjSet( obj_next, { input = tasks[1][2] == "item" and 1 or 0 } )
    ObjAttach( obj_next, "obj_theatreextscr_taskpanel" )
  end
  private.ReverseLoad()
end;

function private.ReverseLoad()

  local clr = { 
    item = { 255/255, 200/255, 40/255 };
    text = { 25/255, 120/255, 255/255 };
  }

  for i = 1, #private.taskpanel do
    local name = private.taskpanel[i][1]
    ObjSet( "obj_theatreextscr_"..name.."_root", { input = 0 } )
    ObjSet( "obj_theatreextscr_"..name, { input = 0 } )
  end

  if not ld.TableContains( ng_global.progress[ "scr" ][ "win_theatreextscr" ].found, "aaa" ) then
    ObjSet( "obj_theatreextscr_aaa_root", { input = 1 } )
    ObjSet( "obj_theatreextscr_aaa", { input = 1 } )
  end

  for i = 1, #private.taskpanel-1 do
    ObjSet( "fx_theatreextscr_task_"..i, { 
      active = ld.TableContains( ng_global.progress[ "scr" ][ "win_theatreextscr" ].found, private.taskpanel[i][1] );
      color_r = clr[ private.taskpanel[ i ][ 2 ] ][ 1 ];
      color_g = clr[ private.taskpanel[ i ][ 2 ] ][ 2 ];
      color_b = clr[ private.taskpanel[ i ][ 2 ] ][ 3 ];
    } )

  end

  for i = 1, #private.taskpanel-1 do
    if ld.TableContains( ng_global.progress[ "scr" ][ "win_theatreextscr" ].found, private.taskpanel[i][1] )
    and not ld.TableContains( ng_global.progress[ "scr" ][ "win_theatreextscr" ].found, private.taskpanel[i+1][1] ) 
    then

      local name = private.taskpanel[i][1]
      ObjDelete( "spr_theatreextscr_"..name )
      ObjDelete( "obj_theatreextscr_"..name.."_zone" )
      ObjSet( "anm_theatreextscr_"..name, { animfunc = "anim_clk_"..name, frame = 999 } )

      ObjSet( "obj_theatreextscr_"..private.taskpanel[i+1][1].."_root", { input = 1 } )
      ObjSet( "fx_theatreextscr_task_"..i, { active = 1 } )

      if private.taskpanel[i+1][2] == "item" then
        ObjSet( "obj_theatreextscr_taskpanel_"..private.taskpanel[i+1][1], { input = 1 } )
        ObjSet( "obj_theatreextscr_"..private.taskpanel[i+1][1].."_zone", { input = 1 } )
      else
        ObjSet( "obj_theatreextscr_"..private.taskpanel[i+1][1], { input = 1 } )
      end

      break
    end
  end;

end

function private.ReverseTaskComplete( name, delta )

  delta = delta or 0
  if not private.ReverseTaskComplete_in_progress[ name ] then
    if private.taskpanel[ ld.TableContains( private.taskpanel, name, true ) ][ 2 ] == "item" then
      private.ReverseTaskComplete_in_progress[ name ] = 0
    else
      private.ReverseTaskComplete_in_progress[ name ] = 1
    end
  end;
  --ld.LogTrace( name,private.ReverseTaskComplete_in_progress[ name ], delta )
  if private.ReverseTaskComplete_in_progress[ name ] == ( 0 - delta ) then
    if ApplyObj( "obj_theatreextscr_taskpanel_"..name, "obj_theatreextscr_"..name ) then
      ld.Lock( 1 )

      local sfx = {
          
          bbb = "aud_ho_theatreext_scissors";
          ddd = "aud_ho_theatreext_butterfly";
          fff = "aud_ho_theatreext_hammer";
          hhh = "aud_ho_theatreext_shoe";
          jjj = "aud_ho_theatreext_mask";
          lll = "aud_ho_theatreext_use_head";
      }
      if sfx[ name ] then
        SoundSfx( sfx[name] )
      end

    ObjSet( "obj_theatreextscr_taskpanel_"..name,{input=0,visible=0} )
    ld.StartTimer( 5, function()ObjDelete( "obj_theatreextscr_taskpanel_"..name )end )  
      ObjDelete( "obj_theatreextscr_"..name.."_zone" )
      ld.AnimPlay( "anm_theatreextscr_"..name, "anim_use_"..name, function()
        ObjSet( "obj_theatreextscr_"..name, { input = 1 } ) 
        --if name == "fff" then
        --  private.ReverseTaskComplete( name, 1 )
        --else
          private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + ( 1 + delta )
          ld.Lock( 0 )
        --end
      end )
    else
      
    end;
  elseif private.ReverseTaskComplete_in_progress[ name ] == ( 1 - delta ) then

    ld.Lock( 1 )
    ObjDelete( "obj_theatreextscr_"..name )
    ObjSet( "spr_theatreextscr_"..name, { input = 1 } ) 

    local o = ObjGet( "spr_theatreextscr_"..name )
    ObjCreate( "fx_".."spr_theatreextscr_"..name, "partsys" )
    ObjSet( "fx_".."spr_theatreextscr_"..name, { 
      pos_x = o.pos_x; pos_y = o.pos_y; pos_z = 33;
      res = "assets/levels/levelext/ho_theatreext/scroll_fx"; 
    } )
    ObjAttach( "fx_".."spr_theatreextscr_"..name, "ho_theatreextscr" )

      local sfx = {
        aaa = "aud_ho_theatreext_hat";
        bbb = "aud_ho_theatreext_gift";
        ccc = "aud_ho_theatreext_purse";
        ddd = "aud_ho_theatreext_drawer";
        eee = "aud_ho_theatreext_wig";
        fff = "aud_ho_theatreext_debris";
        ggg = "aud_ho_theatreext_egg";
        hhh = "aud_ho_theatreext_shoes";
        iii = "aud_ho_theatreext_fan";
        jjj = "aud_ho_theatreext_mask_move";
        kkk = "aud_ho_theatreext_makeup";
        lll = "aud_ho_theatreext_head";
      }
      SoundSfx( sfx[name] )
      -- SoundSfx( "aud_slidestuff" )

    --if name == "fff" then
    --  ObjAnimate( "spr_theatreextscr_"..name, 8,0,0, _, { 0,0,0, 0.35,0,1 } )
    --end;

    ld.AnimPlay( "anm_theatreextscr_"..name, "anim_clk_"..name, function() 
      private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + ( 1 + delta )
      ld.Lock( 0 )
    end )
  elseif private.ReverseTaskComplete_in_progress[ name ] == ( 2 - delta ) then
    ld.Lock( 1 )
    PartSysStop( "fx_".."spr_theatreextscr_"..name, 0 );
    private.ReverseFlyToItem(name,function() 
      private.ReverseTaskComplete_in_progress[ name ] = private.ReverseTaskComplete_in_progress[ name ] + ( 1 + delta )
      private.ReverseItemShowNext( name )
    end)
  end
end

function private.ReverseFlyToItem(name,func_end)
  
  private.ReverseObjDestroyFx( "spr_theatreextscr_"..name )

  ObjSet( "spr_theatreextscr_"..name, { pos_z = 999 } )
  local p = GetObjPosByObj( "spr_theatreextscr_"..name, "obj_theatreextscr_taskpanel" )

  local t = 0.5 --( math.len( p[1], p[2] ) / 400 ) ^ 

  local fx = "fx_theatreextscr_fly_to_item_"..name
  ObjCreate( fx, "partsys" )
  ObjSet( fx, { res = "assets/levels/levelext/ho_theatreext/fly_fx", pos_z = 999 } )
  ObjAttach( fx, "obj_theatreextscr_taskpanel" )
  
  ObjAnimate( fx, 0,0,0, function()
    PartSysStop( fx, 0 ) 
  end, { 0,0,p[1], t,1,0 } )
  ObjAnimate( fx, 1,0,0, func_end, { 0,0,p[2], t,2,0 } )

end;

function private.ReverseObjDestroyFx( object_name, not_destroy )
  
  local func_end = function()
    if not not_destroy then
      ObjDelete( object_name )
    end
  end
  --ObjSet( object_name, {pos_z = 1} );
  local collect_pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
  local collect_drawoff_x = ObjGet( object_name ).drawoff_x;
  local collect_drawoff_y = ObjGet( object_name ).drawoff_y;
  
  local collect_name  = "fx_item_name_collect_"..object_name;

  PlaySfx( "assets/levels/common/audio/aud_ho_clk", 0, "", 0.0 )

  if not not_destroy then
    ObjAttach( object_name, InterfaceWidget_Top_Name );
    ObjSet( object_name ,{ pos_x = collect_pos[1], pos_y = collect_pos[2] });
  end

  if ObjGet(collect_name) then ObjDelete(collect_name) end
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho",
    pos_x = collect_drawoff_x + ( not_destroy and collect_pos[1] or 0 ), pos_y = collect_drawoff_y + ( not_destroy and collect_pos[2] or 0 ),
    active = 1, visible = 1, input = 0, pos_z = 10
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet(collect_name, {pos_z = 50});
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
  
  PartSysSetMaskObj( collect_name, object_name );  
  ObjAnimate( object_name, "alp",0,0, func_end,
  { 
      0.0, 0, not_destroy and 0 or 1,
      0.3, 0, not_destroy and 0 or 1,
      0.6, 0, not_destroy and 1 or 0
  } );
end

function private.ReverseGetTaskParams( name, set_objects )
  if set_objects == nil then
    set_objects = true
  end
  local n = ld.TableContains( private.taskpanel, name, true )
  local m;
  if private.taskpanel[n][2] == "text" then
    m = { 
      { "obj_theatreextscr_"..name }; 
      { "spr_theatreextscr_"..name }; 
    };
  elseif private.taskpanel[n][2] == "item" then
    m = { 
      { "obj_theatreextscr_taskpanel_"..name, "obj_theatreextscr_"..name.."_zone" }; 
      { "obj_theatreextscr_"..name }; 
      { "spr_theatreextscr_"..name }; 
    };
    ObjSet( "obj_theatreextscr_"..name, { 
      event_menter = function() ld.ShCur(CURSOR_HAND) end;
      event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
    } )
  end;

  if set_objects then
    private.ReverseSetTaskParams( name )
  end

  return name, 1, 0, m
end;
function private.ReverseSetTaskParams( name )
    local o = ObjGet( "spr_theatreextscr_"..name )
    if o and not o.inputrect_init then
      ObjSet( "spr_theatreextscr_"..name, { 
        event_mdown  = function() private.ReverseTaskComplete( name ) end;
        event_menter = function() ld.ShCur(CURSOR_HAND) end;
        event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
        inputrect_init = 1;
        inputrect_x = -25;
        inputrect_y = -25;
        inputrect_w = 50;
        inputrect_h = 50;
      } )
    else
      ObjSet( "spr_theatreextscr_"..name, { 
        event_mdown  = function() private.ReverseTaskComplete( name ) end;
        event_menter = function() ld.ShCur(CURSOR_HAND) end;
        event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
      } )
    end
    --ObjSet( "obj_theatreextscr_"..name.."_zone", { 
    --  --event_mdown  = function() ld.ShowBbt( "theatreext_need_"..name ) end;
    --  --event_menter = function() ld.ShCur(CURSOR_USE) end;
    --  --event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
    --} )
    ObjSet( "obj_theatreextscr_"..name, { 
      event_mdown  = function() private.ReverseTaskComplete( name ) end;
    } )
    --ObjSet( "spr_theatreextscr_"..name, { 
    --  blendmode = 2;
    --} )
end
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "theatreextscr" );
  game.relations[ "ho_theatreextscr" ].exitroom = "rm_secretroomscr";

  private.taskpanel = {
    { "aaa"; "text"; };
    { "bbb"; "item"; };
    { "ccc"; "text"; };
    { "ddd"; "item"; };
    { "eee"; "text"; };
    { "fff"; "item"; };
    { "ggg"; "text"; };
    { "hhh"; "item"; };
    { "iii"; "text"; };
    { "jjj"; "item"; };
    { "kkk"; "text"; };
    { "lll"; "item"; };
    { "mmm"; "text"; };    
  }  
 
   --ObjSet( "obj_theatreextscr_aaa", { 
  --  drag = 1;
  --  event_mdown = function() SoundSfx( "aud_get_inv", -1 ) end;
  --  event_dragdrop = private.unmark_aaa;
  --  event_menter = function() ld.ShCur(CURSOR_GET) end;
  --  event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
  --  event_startdrag = function() ld.ShCur(CURSOR_NULL) end;
  --} )

  ObjSet( "obj_theatreextscr_mmm", { 
    event_mdown = function() ObjSet( "obj_theatreextscr_mmm", { input = 0 } ) private.TaskComplete( "mmm" ) end;
  } )
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_theatreextscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_theatreextscr", zz_gate = "gho_squareext_theatreextscr" };
 
  local win_theatreextscr_func = function ()

    if ( cmn.IsEventDone( "win_theatreextscr" ) ) then

      ObjDetach("spr_theatreextscr_win");

    end;

  end;
  cmn.AddSubscriber( "win_theatreextscr", win_theatreextscr_func );
  
  --------------------------------------------------------------------------------------------------
  local win_theatreextscr_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_theatreextscr" ) ) then

      local ho_progress = ng_global.progress[ "scr" ][ "win_theatreextscr" ];

      

      for j = 1, #ng_global.progress["scr"]["win_theatreextscr"].found do

        
        local name = tostring( ng_global.progress[ "scr" ][ "win_theatreextscr" ].found[ j ][ "task" ] );
        ObjDelete( "obj_theatreextscr_taskpanel_"..name )

          ObjDelete( "spr_theatreextscr_"..name )
          ObjDelete( "obj_theatreextscr_"..name.."_zone" )
          ObjSet( "anm_theatreextscr_"..name, { animfunc = "anim_clk_"..name, frame = 999 } )

      end;

    end;
    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  cmn.AddSubscriber( "win_theatreextscr", win_theatreextscr_func, "ho_theatreextscr" );
  
  --------------------------------------------------------------------------------------------------
  local win_theatreextscr_square = function ()

    if ( cmn.IsEventDone( "win_theatreextscr" ) ) then
      
      ObjDelete( "gho_street_theatreextscr" );

    end;

  end;
  cmn.AddSubscriber( "win_theatreextscr", win_theatreextscr_square, "rm_square" );
  
  --------------------------------------------------------------------------------------------------
--  local unmark_ship = function () 
--   
--    ObjDelete( "spr_theatreextscr_bottle" );
--    ObjDelete( "spr_theatreextscr_hammer" );
--    ObjDelete( "obj_theatreextscr_use_hammer" );
--    ObjDelete( "vid_theatreextscr_bottle" );
--    ObjSet( "spr_theatreextscr_bottle_1", { alp = 1, input = true } );
--
--  end;
--
--  cmn.AddSubscriber( "unmark_ship", unmark_ship, "ho_theatreextscr" );  

  --------------------------------------------------------------------------------------------------
--  local unmark_aaa = function () 
--    if ng_global.progress["scr"]["win_theatreextscr"].aaa then
--
--      local s = ng_global.progress["scr"]["win_theatreextscr"].aaa
--
--      local notzero
--      if (#s - ld.TableSum(s)) == 0 then notzero = 1 end
--      ObjSet( "obj_theatreextscr_taskpanel_aaa", { param4 = notzero or (#s - ld.TableSum(s)) } )
--
--      for i = 1, #s do
--        local v = 1 - s[i]
--        ObjSet( "anm_theatreextscr_aaa_"..i, { visible = v } )
--        ObjSet( "gfx_theatreextscr_aaa_zone_"..i, { input = v, visible = v } )
--        ObjSet( "fx_theatreextscr_aaa_"..i, { active = s[i] } )
--      end;
--      if ld.TableSum(s) == #s then
--        ObjSet( "obj_theatreextscr_aaa_root", { input = 0 } )
--        ObjSet( "obj_theatreextscr_aaa", { input = 0 } )
--        ObjSet( "pfx_theatreextscr_ho_theatreextscr_pm", { active = 1 } )
--        ObjSet( "spr_theatreextscr_taskpanel", { alp = 1 } )
--      end
--    else
--      ObjSet( "obj_theatreextscr_taskpanel_aaa", { param4 = 5 } )
--    end
--  end;

  --cmn.AddSubscriber( "unmark_aaa", unmark_aaa, "ho_theatreextscr" );  
  --------------------------------------------------------------------------------------------------
  local start_theatreextscr_func = function ()
        
      if not cmn.IsEventDone( "win_theatreextscr" ) then
       
        --unmark_aaa()

      end;

  end;      
  
  cmn.AddSubscriber( "win_theatreextscr", start_theatreextscr_func, "ho_theatreextscr" );  


end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  private.ReverseTaskComplete_in_progress = private.ReverseTaskComplete_in_progress or {}

  if ( not cmn.IsEventDone( "opn_theatreextscr" ) ) then

    cmn.InitHo( "theatreextscr" );
   
    cmn.SetEventDone( "opn_theatreextscr" );
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "aaa" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "bbb" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ccc" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ddd" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "eee" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "fff" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "ggg" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "hhh" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "iii" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "jjj" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "kkk" ) );
  interface.TaskPanelTaskAdd( ho_items, private.ReverseGetTaskParams( "lll" ) );  
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "obj_theatreextscr_mmm" } } );
  
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "theatreextscr" );

  private.ReverseItemsBuild()
  SoundHoTheme(true)
  SoundEnv( "aud_squareext_env" )

  cmn.CallEventHandler( "win_theatreextscr" );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  SoundHoTheme(false)

end;
--*********************************************************************************************************************
function public.Open ()
end;
--*********************************************************************************************************************
function public.Close ()

    int_taskpanel_impl.ShowTextPanel( "theatreextscr" );
    ObjDetach("spr_theatreextscr_win");
    if cmn.IsEventDone("win_theatreextscr") then ObjDetach("obj_theatreextscr_taskpanel"); end;
end;
--*********************************************************************************************************************
function public.HoComplete()
  --ld.LogTrace( "public.HoComplete" )
  --ObjAnimate( "anm_theatreextscrscr_anm_item_full", 8,0,0, _, { 0,0,1, 0.35,0,0 } )
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, part )

  cmn.HoTaskFind( "spr_theatreextscr_"..task_name, task_name );

  local func_after = function()

    --common_impl.Lock(false);

--    if ( task_name == "harpoon" or task_name == "ship" ) then
--
--      ObjSet( "spr_theatreextscr_"..task_name, { input = false } );
--  
--    end;
  
    
  end;

  --private.check_task( "spr_theatreextscr_"..task_name, part )   

  --common_impl.Lock(true);

  --ObjAnimate( "spr_theatreextscr_taskpanel_"..task_name.."_contour", "alp", 0, 0, func_after, { 0,3,1,  0.8,3,0 } );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  common_impl.PlayAudio("sfx","common/audio/aud_get_inv_sfx");
  ObjSet( "spr_theatreextscr_"..name, { pos_z = 20 } );
  ObjSet( "spr_theatreextscr_"..name.."_shadow", { visible = false } );

end;

----------------------------------------------------------------------------

--function private.unmark_aaa() 
-- 
--  ld.ShCur( CURSOR_DEFAULT );
--  ng_global.progress["scr"]["win_theatreextscr"].aaa = ng_global.progress["scr"]["win_theatreextscr"].aaa or {0,0,0,0,0};
--  local s = ng_global.progress["scr"]["win_theatreextscr"].aaa
--
--  for i = 1, #s do
--
--    if s[i] == 0 and ApplyObj( "obj_theatreextscr_aaa", "gfx_theatreextscr_aaa_zone_"..i ) then
--
--      ld.Lock( 1 )
--
--      ObjAttach( "anm_theatreextscr_aaa_candle", "anm_theatreextscr_aaa_"..i )
--      --ObjAttach( "fx_theatreextscr_aaa", "anm_theatreextscr_aaa_"..i )
--
--      local p = GetZoomCursorPos()
--
--
--      ld.StartTimer( 0.85, function() ObjSet( "fx_theatreextscr_aaa_"..i, { active = 1 } ) end )
--      ObjSet( "anm_theatreextscr_aaa_"..i, { pos_z = 1 } )
--      SoundSfx( "aud_ignite_candles" )
--      ld.AnimPlay( "anm_theatreextscr_aaa_"..i, "use_candle_"..i, function() 
--        ObjSet( "anm_theatreextscr_aaa_"..i, { pos_z = 0 } )
--        s[i] = 1
--
--        ObjSet( "anm_theatreextscr_aaa_candle", { pos_x = 0; pos_y = 0; } )
--        ObjAttach( "anm_theatreextscr_aaa_candle", "obj_theatreextscr_aaa" )
--
--        if ld.TableSum(s) == #s then
--          ObjAnimate( "spr_theatreextscr_taskpanel", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
--          private.ReverseItemShowNext( "aaa" )
--        else
--          ld.Lock( 0 )
--          ObjSet( "obj_theatreextscr_taskpanel_aaa", { param4 = #s - ld.TableSum(s) } )
--          ObjStartDrag( "obj_theatreextscr_aaa" )
--        end;
--        cmn.CallEventHandler( "unmark_aaa" );
--      end )
--
--      ObjAnimate( "anm_theatreextscr_aaa_"..i, "anim_alp",0,0, _, { 0,0,1 } )
--      ObjAnimate( "anm_theatreextscr_aaa_"..i, "anim_x",0,0, _, { 0,0,p[1]+171 } )
--      ObjAnimate( "anm_theatreextscr_aaa_"..i, "anim_y",0,0, _, { 0,0,p[2] } )
--
--      return
--
--    end
--
--  end
--
--  SoundSfx( "aud_put_candle_back", -1 )
--
--end;
-----------------------------------------------------------------------