-- name=ho_toysscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "toysscr" );
  game.relations[ "ho_toysscr" ].exitroom = "rm_secretroomscr";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_toysscr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_toysscr", zz_gate = "gho_livingroom_toysscr" };
 
  local win_toysscr_func = function ()

    if ( cmn.IsEventDone( "win_toysscr" ) ) then
      ObjDetach( "spr_toysscr_win" );
    end;

  end;
  cmn.AddSubscriber( "win_toysscr", win_toysscr_func );

  local unmark_fff= function () 
    ObjSet( "spr_toysscr_fff", {input = 1, alp = 1} );
    ObjDelete("gfx_toysscr_unmark_fff_zone")
    ObjSet("anm_toysscr_unmark_fff",{animfunc="end_fff1",frame=0})
  end;
  cmn.AddSubscriber( "toysscr_unmark_fff", unmark_fff, "ho_toysscr" ); 

  local unmark_ddd= function () 
    ObjSet( "spr_toysscr_ddd", {input = 1, alp = 1} );
    ObjDelete("gfx_toysscr_unmark_ddd_zone")
    ObjSet("anm_toysscr_use_core",{animfunc="end_core1",frame=0})
  end;
  cmn.AddSubscriber( "toysscr_unmark_ddd", unmark_ddd, "ho_toysscr" ); 
  
   
  local unmark_iii= function () 
    ObjSet( "spr_toysscr_iii", {input = 1, alp = 1} );
    ObjDelete("gfx_toysscr_unmark_iii_zone")
    ObjSet("spr_toysscr_tr_iii",{alp=1})
    for i=1,4 do
      ObjSet("spr_toysscr_block_"..i,{pos_x=private.block_arr[i][1],pos_y=private.block_arr[i][2],pos_z=private.block_arr[i][3],input=0})
    end    
  end;
  cmn.AddSubscriber( "toysscr_unmark_iii", unmark_iii, "ho_toysscr" );   
  
  local start_toysscr_func = function ()
    if not cmn.IsEventDone("win_toysscr") then
      if cmn.IsUnmarkedTask("toysscr","fff") then 
        unmark_fff()
      end  
      if cmn.IsUnmarkedTask("toysscr","iii") then
        unmark_iii()
      else
        for i=1,4 do
          if ng_global.progress["scr"]["win_toysscr"].state_iii[i]==1 then
            ObjSet("spr_toysscr_block_"..i,{pos_x=private.block_arr[i][1],pos_y=private.block_arr[i][2],pos_z=private.block_arr[i][3],input=0})
          end
        end
      end
    end
  end;
  cmn.AddSubscriber( "win_toysscr", start_toysscr_func, "ho_toysscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_livingroom_env" )

  if ( not cmn.IsEventDone( "opn_toysscr" ) ) then

    cmn.InitHo( "toysscr" );
    cmn.SetMarkedTask( "toysscr", "fff" );  
    cmn.SetMarkedTask( "toysscr", "ddd" );    
    cmn.SetMarkedTask( "toysscr", "iii" );    
    cmn.SetEventDone( "opn_toysscr" );
    ng_global.progress["scr"]["win_toysscr"].state_iii={0,1,0,0}
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_toysscr_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_toysscr_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_toysscr_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 1, { { "spr_toysscr_ddd" },{"gfx_toysscr_unmark_ddd_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_toysscr_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 1, { { "spr_toysscr_fff" },{"gfx_toysscr_unmark_fff_zone"} } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_toysscr_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_toysscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 1, { { "spr_toysscr_iii" },{"gfx_toysscr_unmark_iii_zone","spr_toysscr_block_1"},{"gfx_toysscr_unmark_iii_zone","spr_toysscr_block_3"},{"gfx_toysscr_unmark_iii_zone","spr_toysscr_block_4"} } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_toysscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_toysscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_toysscr_lll" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );

   for j = 1, #ng_global.progress["scr"]["win_toysscr"].found do

    local name = tostring( ng_global.progress["scr"]["win_toysscr"].found[j]["object"] );
   
    ObjDelete( name );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
function public.Close()
  ObjDetach( "spr_toysscr_win" );
end
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_toysscr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_toysscr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

----------------------------------------------------------------------------
function public.unmark_fff() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "toysscr", "fff" );
    cmn.CallEventHandler( "toysscr_unmark_fff" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_toysscr_unmark_fff_zone")
  SoundSfx( "aud_ho_toys_sail" )
  ld.AnimPlay("anm_toysscr_unmark_fff","click_fff",func_end) 
end

function public.unmark_ddd() 
   local func_end = function()
    ld.Lock(0)
    cmn.UnmarkTask( "toysscr", "ddd" );
    cmn.CallEventHandler( "toysscr_unmark_ddd" );
  end
  ld.Lock(1) 
  ObjDelete("gfx_toysscr_unmark_ddd_zone")
  SoundSfx( "aud_ho_toys_shot" );
  ld.AnimPlay("anm_toysscr_use_core","use_core",func_end) 
end


private.block_arr={{143,433,7},{110,558,6},{248 ,426,6},{249 ,528 ,5}}
public.block_cur_posz = 0
function public.unmark_iii(obj)
  local f_end = function()
    ld.Lock(0)
    local count = 0
    for i=1,4 do
      count=count+ng_global.progress["scr"]["win_toysscr"].state_iii[i]
    end
    if count ==4 then
      cmn.UnmarkTask( "toysscr", "iii" );
      cmn.CallEventHandler( "toysscr_unmark_iii" );      
    end
  end
  local num = tonumber(ld.StringDivide(obj)[4])
  if ApplyObj(obj,"gfx_toysscr_unmark_iii_zone") then
    SoundSfx( "aud_ho_toys_set" );
    ld.Lock(1) 
    
    ObjSet(obj,{pos_z=private.block_arr[num][3],input=0})
    ng_global.progress["scr"]["win_toysscr"].state_iii[num]=1
    ObjAnimate( obj, 3, 0, 0, function() ld.Lock(0); f_end() end,
      {0,0,GetObjPosByObj(obj,"ho_toysscr")[1],GetObjPosByObj(obj,"ho_toysscr")[2], 0.2,0,private.block_arr[num][1],private.block_arr[num][2]}
    );
  else 
      ObjSet(obj,{pos_z=public.block_cur_posz})
  end
end