-- name=ho_treescr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "treescr" );
  game.relations[ "ho_treescr" ].exitroom = "rm_secretroomscr";
  ld.NoteInit("spr_treescr_note", "spr_treescr_note_1")

  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_treescr" ] = { type = "win", room = "rm_secretroomscr", zz = "ho_treescr", zz_gate = "gho_nearhouse_treescr" };
 
  local win_treescr_func = function ()

    if ( cmn.IsEventDone( "win_treescr" ) ) then
      ObjDetach( "spr_treescr_win" );
    end;

  end;
  cmn.AddSubscriber( "win_treescr", win_treescr_func );
  
  local unmark_iii = function () 
    ObjSet( "spr_treescr_iii", {input = 1} );
    ObjDelete("obj_treescr_iii_unmark")
    ObjSet("anm_treescr_anm_click_hat",{animfunc="end_hat1",frame=0})
  end;
  cmn.AddSubscriber( "treescr_unmark_iii", unmark_iii, "ho_treescr" ); 
 
  local unmark_jjj = function () 
    ObjSet( "spr_treescr_jjj", {input = 1,alp=1} );
    ObjDelete("obj_treescr_jjj_unmark")
    ObjSet("anm_treescr_anm_hedge",{animfunc="end_hedge2",frame=0,playing=0})
  end;
  cmn.AddSubscriber( "treescr_unmark_jjj", unmark_jjj, "ho_treescr" ); 
    
  local unmark_bbb = function () 
    ObjSet( "spr_treescr_bbb", {input = 1,alp=1} );
    ObjDelete("spr_treescr_bbb_unmark_1")
    ObjDelete("spr_treescr_bbb_unmark_2")    
  end;
  cmn.AddSubscriber( "treescr_unmark_bbb", unmark_bbb, "ho_treescr" ); 
      
  local start_treescr_func = function ()
  if not cmn.IsEventDone("win_treescr") then
      common_impl.ProcessHoStart( "treescr" );

      local ho_found = ng_global.progress[ "scr" ][ "win_treescr" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { input = false } );

      end;
    if cmn.IsUnmarkedTask("treescr","iii") then 
      unmark_iii()
    end  
    if cmn.IsUnmarkedTask("treescr","jjj") then 
      unmark_jjj()
    end 
    if cmn.IsUnmarkedTask("treescr","bbb") then 
      unmark_bbb()
    end      
  end
  end;
  cmn.AddSubscriber( "win_treescr", start_treescr_func, "ho_treescr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearhouse_env" )

  if ( not cmn.IsEventDone( "opn_treescr" ) ) then

    cmn.InitHo( "treescr" );

    cmn.SetEventDone( "opn_treescr" );
    cmn.SetMarkedTask( "treescr", "iii" );
    cmn.SetMarkedTask( "treescr", "jjj" );    
    cmn.SetMarkedTask( "treescr", "bbb" );     
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_treescr_aaa"}); 
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_treescr_bbb","spr_treescr_bbb_unmark_1","spr_treescr_bbb_unmark_2"}); 
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_treescr_ccc"}); 
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_treescr_ddd"}); 
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_treescr_eee"}); 
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_treescr_fff"}); 
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_treescr_ggg"}); 
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_treescr_hhh"}); 
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_treescr_iii","obj_treescr_iii_unmark"}); 
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_treescr_jjj","obj_treescr_jjj_unmark"}); 
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_treescr_kkk"}); 
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_treescr_lll"}); 

  
  SoundHoTheme( true )
  interface.ItemPanelShow( ho_items );

end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false )
  interface.ItemPanelHide();

end;
function public.Close()
  ObjDetach( "spr_treescr_win" );
end
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show();
  ObjDelete("grm_treescr_nearhouse") 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )


end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_treescr_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_treescr_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;


function public.unmark_iii()
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_treescr"].start = 1;
    ng_global.progress["scr"]["win_treescr"].unmark["iii"].done = 1;
    cmn.CallEventHandler("treescr_unmark_iii");
  end  
  ld.Lock(1)
  SoundSfx( "aud_ho_tree_hat" );
  ld.AnimPlay("anm_treescr_anm_click_hat","click_hat",func_end)
end

function public.unmark_jjj()
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_treescr"].start = 1;
    ng_global.progress["scr"]["win_treescr"].unmark["jjj"].done = 1;
    cmn.CallEventHandler("treescr_unmark_jjj");
  end  
  ld.Lock(1)
  SoundSfx( "aud_ho_tree_hedgehog" );
  ld.AnimPlay("anm_treescr_anm_hedge","hedge",func_end)
end

function public.unmark_bbb()
  if ApplyObj("spr_treescr_bbb_unmark_1","spr_treescr_bbb_unmark_2") then   
  local func_end = function()
    ld.Lock(0)
    ng_global.progress["scr"]["win_treescr"].start = 1;
    ng_global.progress["scr"]["win_treescr"].unmark["bbb"].done = 1;
    cmn.CallEventHandler("treescr_unmark_bbb");
  end  
  ld.Lock(1)
  ObjDelete("spr_treescr_bbb_unmark_1")
  SoundSfx( "aud_ho_tree_butterfly" );
  ObjAnimate( "spr_treescr_bbb", 8, 0, 0, func_end, {0,0,0, 0.5,0,1} );
  else 
    ObjSet("spr_treescr_bbb_unmark_1",{pos_z = 0})
  end
end